// InputArea.h : interface of the CInputArea class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_INPUTAREA_H__FDC5BBC6_2DCA_4689_AA25_2629A785F2B9__INCLUDED_)
#define AFX_INPUTAREA_H__FDC5BBC6_2DCA_4689_AA25_2629A785F2B9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "mgp.h"

class CInputArea : public CFormView
{
protected: // create from serialization only
	CInputArea();
	DECLARE_DYNCREATE(CInputArea)

public:
	//{{AFX_DATA(CInputArea)
	enum { IDD = IDD_INPUTAREA };
	CButton	m_SendCmd;
	CButton	m_Connect;
	CComboBox	m_CommandSelectionCtrl;
	int		m_CommandSelection;
	//}}AFX_DATA

// Attributes
public:
	CView *input_forms[100];
	DWORD CmdSel2View[100];
	DWORD activeView;

	HANDLE     hDiagnosticThread;
	HANDLE     hPollingThread;
	HANDLE     hPollingThread1;
	HANDLE     hPollingThread2;
	HANDLE     hTestProcThread;
	HANDLE     hSendThread;
   HANDLE     m_DiagnosticExitHandle;
   HANDLE     m_PollingExitHandle;
   HANDLE     m_Polling1ExitHandle;
   HANDLE     m_Polling2ExitHandle;
   HANDLE     m_TestProcExitHandle;
	HANDLE     m_SendExitHandle;
	HANDLE     m_SendPackHandle;
	DWORD      *threadParam; // Parameters for thread
	
	BYTE  **buffer;
	int   *bufferLen;
	DWORD numPackets;
	BYTE  commandId;
	
	SIZE m_orig_size;

// Operations
public:
	static UINT DiagnosticThread(LPVOID lpParams);
	static UINT PollingThread(LPVOID lpParams);
	static UINT PollingThread1(LPVOID lpParams);
	static UINT PollingThread2(LPVOID lpParams);
	static UINT SendThread(LPVOID lpParams);
	static UINT TestProcThread(LPVOID lpParams);
	void DiagnosticExitFromThread();
	void PollingExitFromThread();
	void Polling1ExitFromThread();
	void Polling2ExitFromThread();
	void SendExitFromThread();
	void TestProcExitFromThread();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInputArea)
	public:
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CInputArea();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CInputArea)
	afx_msg void OnSelChangeCmdSelection();
	afx_msg void OnCmdSend();
	afx_msg void OnConnect();
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	afx_msg LRESULT OnUpdateButtons(WPARAM type,LPARAM dummy2);
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INPUTAREA_H__FDC5BBC6_2DCA_4689_AA25_2629A785F2B9__INCLUDED_)
