// LBT_EngPanel.h : main header file for the LBT_ENGPANEL application
//

#if !defined(AFX_LBT_ENGPANEL_H__006FBC29_61B7_462C_B926_08FC4C9A1BF4__INCLUDED_)
#define AFX_LBT_ENGPANEL_H__006FBC29_61B7_462C_B926_08FC4C9A1BF4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
#include "mgp.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CLBT_EngPanelApp:
// See LBT_EngPanel.cpp for the implementation of this class
//
extern void AFXAPI DDX_HexText(CDataExchange* pDX, int nIDC, BYTE& value);
extern void AFXAPI DDX_HexText(CDataExchange* pDX, int nIDC, WORD& value);
extern void AFXAPI DDX_HexText(CDataExchange* pDX, int nIDC, DWORD& value);
extern void AFXAPI DDX_MyRadio(CDataExchange* pDX, int nIDC, int& value);

extern void InternalError(DWORD num,DWORD type=-1);
extern void ContinueMessages();
extern BOOL GetFileLine(FILE *fd,char *str,DWORD str_size);

#define WM_CREATE_BUFFER   WM_USER +0x0100
#define WM_UPDATE_BUTTONS  WM_USER +0x0101
#define WM_UPDATE_PROGRESS WM_USER +0x0102
#define WM_SET_PROGRESS    WM_USER +0x0103

#define EXIT_THREAD_TIMEOUT    200

typedef struct socketaddr
	{
	char IP[100];
	int  port;
	} SOCKETADDR;

struct CHECK_PACKET
	{
	DWORD ttl;                        // numero di cicli prima essere considerato perso
	DWORD status;                     // 0 = in idle; 1 = spedito in attesa di reply
	DWORD packetType;                 // 1 = pacchetto di read; 2 = pacchetto di write
	DWORD start_address;              // start address del device di destinazione da dove leggere i dati scritti dal cmd di wr
   void *pBuffer;
	};

struct PROGRESS_PACKET
	{
	DWORD progressCount;
	DWORD numCmdReplyFault;
	DWORD numBitsWrong;               
	DWORD numPacketLost;              
	DWORD elapsedTime;
   double numBitSent;
	};

#define NUM_BOARD_ON_CRATE 20

#define na_bcu_nios_fixed_area      ((void *)          0x001E0000)
#define na_bcu_nios_fixed_area_base                    0x001E0000
#define na_bcu_nios_fixed_area_end  ((void *)          0x001F0000)
#define na_bcu_nios_fixed_area_size                    0x00010000
#define na_bcu_nios_fixed_area_offset                  0x000E0000

typedef struct
	{
	int16 stratix_temp;      // temperatura del chip stratix
	int16 power_temp;        // temperatura board nella zona di power

	uint32 bck_digitalIO;    // canale spi sul backplane (MAX7301 U1)
	
	uint16 voltage_vccl;     // canale spi sul backplane (AD7927 U30)
	uint16 voltage_vcca;     // canale spi sul backplane
	uint16 voltage_vssa;     // canale spi sul backplane
	uint16 voltage_vccp;     // canale spi sul backplane
	uint16 voltage_vssp;     // canale spi sul backplane
	uint16 current_vccl;     // canale spi sul backplane
	uint16 current_vcca;     // canale spi sul backplane
	uint16 current_vssa;     // canale spi sul backplane

	uint16 current_vccp;     // canale spi sul backplane (AD7927 U31)
	uint16 current_vssp;     // canale spi sul backplane
	uint16 tot_current_vccp; // canale spi sul backplane
	uint16 tot_current_vssp; // canale spi sul backplane
	uint16 tot_current_vp;   // canale spi sul backplane

	uint16 in0_temp;         // canale spi sul backplane (AD7927 U32)
	uint16 in1_temp;         // canale spi sul backplane
	uint16 out0_temp;        // canale spi sul backplane
	uint16 out1_temp;        // canale spi sul backplane
	uint16 ext_umidity;      // canale spi sul backplane
	uint16 pressure;         // canale spi sul backplane
	uint16 dummy;

	uint32 reset_status;     // dword con lo status delle linee di reset
	} na_bcu_diagnostic_struct;

typedef volatile struct
	{
	uint16 crateID;                                 // identificazione del crate
	uint16 who_ami;                                 // identificazione della board sul crate
	uint32 software_release;                        // versione software del Nios
	uint16 logic_release;                           // lettura del PIO con la versione della logica
	uint8  mac_address[6];                          // indirizzo mac della scheda
	uint8  ip_address[4];                           // indirizzo ip della scheda
	uint8  crate_configuration[NUM_BOARD_ON_CRATE]; // stato del crate
	uint16 local_current_threshold;                 // livello di corrente locale di thresholds (positiva e negativa)
	uint16 vp_set;                                  // impostazione tensione rami power (positivo e negativo)
	uint16 total_current_thres_pos;                 // livello di corrente totale di thresholds (positiva)
	uint16 total_current_thres_neg;                 // livello di corrente totale di thresholds (negativa)
	uint32 frames_counter;                          // counter globale con il numero di frames arrivati dal DSP
	uint32 relais_board_out;                        // variabile con lo status dell'uscita della scheda relais
	uint16 serial_number;                           // numero seriale della scheda BCU
	uint16 pb_serial_number;                        // numero seriale del power backplane
	uint32 relais_board_out_1;                      // variabile con lo status dell'uscita della seconda scheda relais
	uint32 enable_hl_commands;                      // flag che indica se sono abilitati o disabilitati i comandi al secondario MMT
	uint32 enable_pos_acc;                          // abilita(1) / disabilita(0) la lettura dal secondario degli accumulatori di 
																	// posizione oltre a quelli di corrente per il calcolo mantegazza style
	uint32 diagnostic_record_ptr;                   // puntatore alla memoria che contiene la diagnostica da scaricare in SDRAM
	uint32 diagnostic_record_len;                   // dimensione del pacchetto diagnostico da salvare in DWORD
	uint16 enable_master_diag;                      // abilita(1) / disabilita(0) la spedizione della diagnostica in modo automatico
	uint16 decimation_factor;                       // fattore di decimazione sulla spedizione master BCU (0=tutti, 1=tutti i modulo 2, 2=tutti i modulo 3, ecc)
	uint8  remote_mac_address[6];                   // indirizzo mac della scheda dove spedire la diagnostica
	uint8  remote_ip_address[4];                    // indirizzo ip della scheda dove spedire la diagnostica
	uint16 remote_udp_port;                         // porta UDP alla quale mandare il pacchetto diagnostico BCU master
	uint32 rd_diagnostic_record_ptr;                // puntatore alla SDRAM della diagnostica da spedire via ETH
	uint32 wr_diagnostic_record_ptr;                // puntatore alla SDRAM della diagnostica da salvare in SDRAM
	uint32 rd_byte_serialAIA;                       // numero di byte ricevuti dalla seriale AIA
	uint32 wr_byte_serialAIA;                       // numero di byte da spedire alla seriale AIA mettere ad uno il bit 31 per partire
	na_bcu_diagnostic_struct diagnostic_area;       // area contenete i valori diagnostici
	} na_bcu_nios_fixed_area_struct;

// com mappatura nella parte alta della sram
#define na_dsp_nios_fixed_area      ((void *)          0x00160000) // area di allocazione fissa sulla sram (allocati gli ultimi 64 KB)
#define na_dsp_nios_fixed_area_base                    0x00160000
#define na_dsp_nios_fixed_area_end  ((void *)          0x00170000)
#define na_dsp_nios_fixed_area_size                    0x00010000
#define na_dsp_nios_fixed_area_offset                  0x00060000

// definizione della struttura della flash utilizzata sulla DSP
#define DEFAULT_LOGIC_SADDR 0x000000
#define DEFAULT_LOGIC_LEN   0x180000
#define DEFAULT_PRG_SADDR   (DEFAULT_LOGIC_SADDR+DEFAULT_LOGIC_LEN)
#define DEFAULT_PRG_LEN     0x040000
#define USER_PRG_SADDR      (DEFAULT_PRG_SADDR+DEFAULT_PRG_LEN)
#define USER_PRG_LEN        0x040000
#define USER_LOGIC_SADDR    (USER_PRG_SADDR+USER_PRG_LEN)
#define USER_LOGIC_LEN      0x180000
#define UNUSED_AREA0_SADDR  (USER_LOGIC_SADDR+USER_LOGIC_LEN)
#define UNUSED_AREA0_LEN    0x070000
#define CONFIG_AREA_SADDR   (UNUSED_AREA0_SADDR+UNUSED_AREA0_LEN)
#define CONFIG_AREA_LEN     0x00A000
#define UNUSED_AREA1_SADDR  (CONFIG_AREA_SADDR+CONFIG_AREA_LEN)
#define UNUSED_AREA1_LEN    0x002000
#define UNUSED_AREA2_SADDR  (UNUSED_AREA1_SADDR+UNUSED_AREA1_LEN)
#define UNUSED_AREA2_LEN    0x004000

#define NIOS_INTERPRETER_SPACE       MGP_HLEN+MAX_MGP_DATA_SIZE

typedef volatile struct
	{
	int16  stratix_temp;    // temperatura del chip stratix
	int16  power_temp;      // temperatura board nella zona di power
	int16  dsps_temp;       // temperatura board tra i due dsp
	int16  driver_temp;     // temperatura board tra i driver di corrente
	uint32 driver_status;   // dword con lo status delle linee di enable dei coils
	uint16 coil_current[8]; // corrente sui coils
	} na_dsp_diagnostic_struct_8ch;

typedef volatile struct
	{
	int16  stratix_temp;     // temperatura del chip stratix
	int16  power_temp;       // temperatura board nella zona di power
	int16  dsps_temp;        // temperatura board tra i due dsp
	int16  driverA_temp;     // temperatura board tra i driver di corrente (A)
	int16  driverB_temp;     // temperatura board tra i driver di corrente (B)
	int16  dummy;            // not used location
	uint32 driver_status;    // dword con lo status delle linee di enable dei coils
	uint16 coil_current[16]; // corrente sui coils
	uint16 coil_voltage[16]; // tensione sui coils
	} na_dsp_diagnostic_struct_16ch;

typedef volatile struct
	{
	uint8  nios_interpreter_area[NIOS_INTERPRETER_SPACE]; // area di copia di un comando backplane
	uint16 dummy_word;                                    // dummy word per allineare a 32 bit
	uint32 nios_interpreter_reply;                        // areola per il reply ad un comando backplane
	uint16 who_ami;                                       // identificazione della board
	uint16 logic_release;                                 // lettura del PIO con la versione della logica
	uint32 software_release;                              // versione software del Nios
	uint16 serial_number;                                 // numero seriale della scheda
	uint16 dummy_word1;                                   // dummy word per allineare a 32 bit
	float  ADC_spi_offset[8];                             // valori di taratura degli ADC SPI
	float  ADC_spi_gain[8];
	float  ADC_offset[8];                                 // valori di taratura degli ADC
	float  ADC_gain[8];
	float  DAC_offset[8];                                 // valori di taratura dei DAC
	float  DAC_gain[8];
	uint32 diagnostic_record_ptr;                         // puntatore alla memoria che contiene la diagnostica da scaricare in SDRAM
	uint32 diagnostic_record_len;                         // dimensione del pacchetto diagnostico da salvare
	uint32 rd_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da spedire (not used)
	uint32 wr_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da salvare in SDRAM
	na_dsp_diagnostic_struct_8ch diagnostic_area;         // area contenete i valori diagnostici
	} na_dsp_nios_fixed_area_struct_8ch;

typedef volatile struct
	{
	uint16 who_ami;                                       // identificazione della board
	uint16 logic_release;                                 // lettura del PIO con la versione della logica
	uint32 software_release;                              // versione software del Nios
	uint16 serial_number;                                 // numero seriale della scheda
	uint16 dummy_word1;                                   // dummy word per allineare a 32 bit
	float  ADC_spi_offset[8];                             // valori di taratura degli ADC SPI
	float  ADC_spi_gain[8];
	float  ADC_offset[8];                                 // valori di taratura degli ADC
	float  ADC_gain[8];
	float  DAC_offset[8];                                 // valori di taratura dei DAC
	float  DAC_gain[8];
	uint32 diagnostic_record_ptr;                         // puntatore alla memoria che contiene la diagnostica da scaricare in SDRAM
	uint32 diagnostic_record_len;                         // dimensione del pacchetto diagnostico da salvare
	uint32 rd_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da spedire (not used)
	uint32 wr_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da salvare in SDRAM
	na_dsp_diagnostic_struct_8ch diagnostic_area;         // area contenete i valori diagnostici
	} na_dsp_nios_fixed_area_simply_struct_8ch;

typedef volatile struct
	{
	uint8  nios_interpreter_area[NIOS_INTERPRETER_SPACE]; // area di copia di un comando backplane
	uint16 dummy_word;                                    // dummy word per allineare a 32 bit
	uint32 nios_interpreter_reply;                        // areola per il reply ad un comando backplane
	uint16 who_ami;                                       // identificazione della board
	uint16 logic_release;                                 // lettura del PIO con la versione della logica
	uint32 software_release;                              // versione software del Nios
	uint16 serial_number;                                 // numero seriale della scheda
	uint16 dummy_word1;                                   // dummy word per allineare a 32 bit
	float  ADC_spi_offset[8];                             // valori di taratura degli ADC SPI
	float  ADC_spi_gain[8];
	float  ADC_offset[8];                                 // valori di taratura degli ADC
	float  ADC_gain[8];
	float  DAC_offset[8];                                 // valori di taratura dei DAC
	float  DAC_gain[8];
	uint32 diagnostic_record_ptr;                         // puntatore alla memoria che contiene la diagnostica da scaricare in SDRAM
	uint32 diagnostic_record_len;                         // dimensione del pacchetto diagnostico da salvare
	uint32 rd_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da spedire (not used)
	uint32 wr_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da salvare in SDRAM
	na_dsp_diagnostic_struct_16ch diagnostic_area;        // area contenete i valori diagnostici
	} na_dsp_nios_fixed_area_struct_16ch;

typedef volatile struct
	{
	uint16 who_ami;                                       // identificazione della board
	uint16 logic_release;                                 // lettura del PIO con la versione della logica
	uint32 software_release;                              // versione software del Nios
	uint16 serial_number;                                 // numero seriale della scheda
	uint16 dummy_word1;                                   // dummy word per allineare a 32 bit
	float  ADC_spi_offset[8];                             // valori di taratura degli ADC SPI
	float  ADC_spi_gain[8];
	float  ADC_offset[8];                                 // valori di taratura degli ADC
	float  ADC_gain[8];
	float  DAC_offset[8];                                 // valori di taratura dei DAC
	float  DAC_gain[8];
	uint32 diagnostic_record_ptr;                         // puntatore alla memoria che contiene la diagnostica da scaricare in SDRAM
	uint32 diagnostic_record_len;                         // dimensione del pacchetto diagnostico da salvare
	uint32 rd_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da spedire (not used)
	uint32 wr_diagnostic_record_ptr;                      // puntatore alla SDRAM della diagnostica da salvare in SDRAM
	na_dsp_diagnostic_struct_16ch diagnostic_area;        // area contenete i valori diagnostici
	} na_dsp_nios_fixed_area_simply_struct_16ch;

inline uint16 swap16_be_le(uint16 x)
{
uint16 y;

((uint8 *)&y)[0]=((uint8 *)&x)[1];
((uint8 *)&y)[1]=((uint8 *)&x)[0];

return y;
}

inline void cks_add_val16(uint32 *val32,uint16 add_val)
{
(*val32)+=add_val;
if ((*val32)&0x00010000) // nel caso di riporto aggiungo il carry alla parte bassa
	*val32=((*val32)&0x0000FFFF)+1;
}

class CLBT_EngPanelApp : public CWinApp
{
public:
	CLBT_EngPanelApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLBT_EngPanelApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CLBT_EngPanelApp)
	afx_msg void OnAppAbout();
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LBT_ENGPANEL_H__006FBC29_61B7_462C_B926_08FC4C9A1BF4__INCLUDED_)
