#if !defined(AFX_MYASYNCSOCKET_H__F0CBD96F_DDA8_11D5_9D9B_0001022C5F30__INCLUDED_)
#define AFX_MYASYNCSOCKET_H__F0CBD96F_DDA8_11D5_9D9B_0001022C5F30__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// MyAsyncSocket.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CMyAsyncSocket command target
#include <windowsx.h>
#include <winsvc.h>
#include "ntddpack.h"
#include "eth.h"
#include "ip.h"
#include "mgp.h"

typedef struct ReadThread
	{
	HANDLE enable_event;
	HANDLE receive_event;
	DWORD  type;
	} READTHREAD, *PREADTHREAD;

// #define ETHERNET_MAX_BUFFER_SIZE 1514
#define ETHERNET_MAX_BUFFER_SIZE 4096

class CMyAsyncSocket : public CWnd
{
// Attributes
public:
	CONTROL_BLOCK Adapter;
	ADAPTERS_INFO AdaptersInfo;
	UCHAR         local_eth_addr[ETH_ALEN];
	DWORD         local_ip_addr;
	UCHAR         remote_eth_addr[ETH_ALEN];
	DWORD         remote_ip_addr;
	WORD          UDPPort;

	void*  pOutputSend;
	void*  pOutputReceive;
	BOOL   m_EnableOutput;
   TCHAR  receiverBuffer[CIRCULAR_BUFFER_SIZE][ETHERNET_MAX_BUFFER_SIZE];
	int    receiverBufferLen[CIRCULAR_BUFFER_SIZE];
	DWORD  receiverBufferPtr;
	FILE   *m_fd;
	READTHREAD readThread;
	HANDLE m_CallbackHandle;

// Operations
public:
	CMyAsyncSocket();
	virtual ~CMyAsyncSocket();
	void ConnectAdapter(SOCKETADDR *pSocketAddr);
	void DisconnectAdapter();
	BOOL OpenAdapter();
	void CloseAdapter();
	BOOL EnumAdapters();
	BOOL PacketStartDriver(LPTSTR ServiceName);
	BOOL PacketSend(int nBufLen);
	void Send(const void*lpBuf,int nBufLen,int nFlags);
	BOOL PacketRead(int nBufLen);

// Implementation
protected:
	static void OnReceive();
	static UINT ReceiverThread(LPVOID lpParams);
	void   ExitFromReceiveThread();
	HANDLE m_ExitHandle;
	HANDLE hReceiverThread;
	DWORD  *threadParam; // Parameters for thread

	BOOL  PacketStopDriver(IN LPCTSTR ServiceName);
	PVOID PacketOpenAdapter(LPTSTR AdapterName);
	BOOL  PacketSendPacket(LPADAPTER AdapterObject, LPPACKET lpPacket, BOOL Sync);
	PVOID PacketAllocatePacket(LPADAPTER AdapterObject);
	VOID  PacketInitPacket(LPPACKET lpPacket, PVOID Buffer, UINT Length);
	VOID  PacketFreePacket(LPPACKET lpPacket);
	BOOL  PacketResetAdapter(LPADAPTER AdapterObject);
	BOOL  PacketGetAddress(LPADAPTER AdapterObject, PUCHAR AddressBuffer, PUINT Length);
	BOOL  PacketWaitPacket(LPADAPTER AdapterObject, LPPACKET lpPacket, PULONG BytesReceived);
	BOOL  PacketReceivePacket(LPADAPTER AdapterObject, LPPACKET lpPacket, BOOL Sync, PULONG BytesReceived);
	VOID  PacketCloseAdapter(LPADAPTER lpAdapter);
   BOOL  PacketSetFilter(LPADAPTER AdapterObject, ULONG Filter);
   ULONG PacketGetAdapterNames(PTSTR pStr, PULONG BufferSize);
	BOOL  PacketRequest(LPADAPTER AdapterObject, BOOL Set, PPACKET_OID_DATA OidData);
	BOOL  PacketInit(IN PVOID DllHandle, IN ULONG Reason, IN PCONTEXT Context OPTIONAL);
	
// Overrides
public:

	// Generated message map functions
	//{{AFX_MSG(CMyAsyncSocket)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYASYNCSOCKET_H__F0CBD96F_DDA8_11D5_9D9B_0001022C5F30__INCLUDED_)
