#include "ntddndis.h"

#ifndef __NTDDPACKET
#define __NTDDPACKET 1

#include "devioctl.h"

#define        MAX_LINK_NAME_LENGTH   124

typedef struct _PACKET_OID_DATA {

    ULONG           Oid;
    ULONG           Length;
    UCHAR           Data[1];

}   PACKET_OID_DATA, *PPACKET_OID_DATA;


#define FILE_DEVICE_PROTOCOL        0x8000



#define IOCTL_PROTOCOL_SET_OID      CTL_CODE(FILE_DEVICE_PROTOCOL, 0 , METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_PROTOCOL_QUERY_OID    CTL_CODE(FILE_DEVICE_PROTOCOL, 1 , METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_PROTOCOL_RESET        CTL_CODE(FILE_DEVICE_PROTOCOL, 2 , METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_ENUM_ADAPTERS        CTL_CODE(FILE_DEVICE_PROTOCOL, 3 , METHOD_BUFFERED, FILE_ANY_ACCESS)

#define MAX_ADAPTERS              10
#define DOSNAMEPREFIX   TEXT("Packet_")
#define CIRCULAR_BUFFER_SIZE 256

typedef struct _ADAPTER
	{
   HANDLE     hFile;
   TCHAR      SymbolicLink[MAX_LINK_NAME_LENGTH];
   } ADAPTER, *LPADAPTER;

typedef struct _PACKET 
	{
   HANDLE       hEvent;
   OVERLAPPED   OverLapped;
   PVOID        Buffer;
   UINT         Length;
   BOOL         Result;
   } PACKET, *LPPACKET;

typedef struct _CONTROL_BLOCK 
	{
   PVOID       OpenInstance;
   HANDLE      hEvent;

   HANDLE      hMem[2];
   LPBYTE      lpMem[2];

   HGLOBAL     hMem2;
   LPBYTE      lpMem2;
   ULONG       PacketLength;
   UINT        BufferSize;

	UINT        DeviceSelected;
   } CONTROL_BLOCK, *PCONTROL_BLOCK;

typedef struct _ADAPTERS_INFO
	{
   ULONG   NumAdapters;
   LPTSTR  AdapterName[MAX_ADAPTERS];
   LPTSTR  SymbolicLink[MAX_ADAPTERS];
	} ADAPTERS_INFO, *PADAPTERS_INFO;

#endif


