// BCUConf_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "BCUConf_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FONT_NAME    "Courier New"
#define FONT_HEIGHT  14
#define FONT_WIDTH   0
#define MAX_LINES    500

int CALLBACK EnumFontFamExProc2(ENUMLOGFONT *lpelfe,      // pointer to logical-font data
                                NEWTEXTMETRICEX *lpntme,  // pointer to physical-font data
                                DWORD FontType,           // type of font
                                LPARAM lParam)            // application-defined data
{
// cerco i tre caratteri per la stampa
if (((CFont*)lParam)->m_hObject==0 && strcmp(lpelfe->elfLogFont.lfFaceName,FONT_NAME)==0)
	{
	lpelfe->elfLogFont.lfHeight=(long)(FONT_HEIGHT);
	lpelfe->elfLogFont.lfWidth=(long)(FONT_WIDTH);
	lpelfe->elfLogFont.lfWeight=FW_NORMAL;
	lpelfe->elfLogFont.lfItalic=0;
	((CFont*)lParam)->CreateFontIndirect(&lpelfe->elfLogFont);
	}
return(1);
}

/////////////////////////////////////////////////////////////////////////////
// CBCUConf_View

IMPLEMENT_DYNCREATE(CBCUConf_View, CFormView)

CBCUConf_View::CBCUConf_View()
	: CFormView(CBCUConf_View::IDD)
{
	//{{AFX_DATA_INIT(CBCUConf_View)
	m_CrateID = _T("");
	m_CrateMAC = _T("");
	m_CrateIP = _T("");
	m_FrameCnt = _T("");
	m_LocPos = _T("");
	m_LocNeg = _T("");
	m_TotNeg = _T("");
	m_TotPos = _T("");
	m_LogicVer = _T("");
	m_NiosVer = _T("");
	m_BoardSN = _T("");
	m_BckBoardSN = _T("");
	m_ResetStatus = _T("");
	m_FrameCnt = _T("");
	m_EnaPosAcc = _T("");
	m_DiagRecPtr = _T("");
	m_DiagRecLen = _T("");
	m_EnaHLCommands = _T("");
	m_EnaMasterDiag = _T("");
	m_RemoteMAC = _T("");
	m_RemoteIP = _T("");
	m_RemoteUDP = _T("");
	m_WRDiagPtr = _T("");
	m_RDDiagPtr = _T("");
	//}}AFX_DATA_INIT
}

CBCUConf_View::~CBCUConf_View()
{
}

void CBCUConf_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBCUConf_View)
	DDX_Control(pDX, IDC_SLOTCONF, m_SlotConf);
	DDX_Text(pDX, IDC_CRATEID, m_CrateID);
	DDX_Text(pDX, IDC_CRATEMAC, m_CrateMAC);
	DDX_Text(pDX, IDC_CRATEIP, m_CrateIP);
	DDX_Text(pDX, IDC_LOCPOS, m_LocPos);
	DDX_Text(pDX, IDC_LOCNEG, m_LocNeg);
	DDX_Text(pDX, IDC_TOTNEG, m_TotNeg);
	DDX_Text(pDX, IDC_TOTPOS, m_TotPos);
	DDX_Text(pDX, IDC_LOGICVER, m_LogicVer);
	DDX_Text(pDX, IDC_NIOSVER, m_NiosVer);
	DDX_Text(pDX, IDC_BOARDSN, m_BoardSN);
	DDX_Text(pDX, IDC_BCKBOARDSN, m_BckBoardSN);
	DDX_Text(pDX, IDC_RESETST, m_ResetStatus);
	DDX_Text(pDX, IDC_FRAMECNT, m_FrameCnt);
	DDX_Text(pDX, IDC_ENAPOSACC, m_EnaPosAcc);
	DDX_Text(pDX, IDC_DIAGRECPTR, m_DiagRecPtr);
	DDX_Text(pDX, IDC_DIAGRECLEN, m_DiagRecLen);
	DDX_Text(pDX, IDC_ENAHLCOMMANDS, m_EnaHLCommands);
	DDX_Text(pDX, IDC_ENAMASTERDIAG, m_EnaMasterDiag);
	DDX_Text(pDX, IDC_REMOTEMAC, m_RemoteMAC);
	DDX_Text(pDX, IDC_REMOTEIP, m_RemoteIP);
	DDX_Text(pDX, IDC_REMOTEUDP, m_RemoteUDP);
	DDX_Text(pDX, IDC_WRDIAGPTR, m_WRDiagPtr);
	DDX_Text(pDX, IDC_RDDIAGPTR, m_RDDiagPtr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBCUConf_View, CFormView)
	//{{AFX_MSG_MAP(CBCUConf_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBCUConf_View diagnostics

#ifdef _DEBUG
void CBCUConf_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CBCUConf_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CBCUConf_View message handlers

BOOL CBCUConf_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CBCUConf_View::OnInitialUpdate() 
{
LOGFONT logfont;

CFormView::OnInitialUpdate();

// carico il font per il list box
logfont.lfCharSet=DEFAULT_CHARSET;
memset((void *)logfont.lfFaceName,0,sizeof(logfont.lfFaceName));
logfont.lfPitchAndFamily=0;
EnumFontFamiliesEx(GetDC()->m_hDC,                   // handle to device context
						 &logfont,                         // pointer to logical font information
						 (FONTENUMPROC)EnumFontFamExProc2, // pointer to callback function
						 (LPARAM)&m_Font,                  // application-supplied data
						 0);                               // reserved; must be zero
// aspetto che il font venga caricato
while(m_Font.m_hObject==0);

m_SlotConf.SetFont(&m_Font,TRUE);
}

LRESULT CBCUConf_View::OnUpdateProgress(na_bcu_nios_fixed_area_struct *p_bcufixarea,LPARAM dummy2)
{
DWORD i;
char str[100];

UpdateData(TRUE);
sprintf(str,"0x%02x",p_bcufixarea->crateID);
m_CrateID=str;
sprintf(str,"%02x:%02x:%02x:%02x:%02x:%02x",p_bcufixarea->mac_address[0],p_bcufixarea->mac_address[1],p_bcufixarea->mac_address[2],p_bcufixarea->mac_address[3],p_bcufixarea->mac_address[4],p_bcufixarea->mac_address[5]);
m_CrateMAC=str;
sprintf(str,"%3d.%3d.%3d.%3d",p_bcufixarea->ip_address[0],p_bcufixarea->ip_address[1],p_bcufixarea->ip_address[2],p_bcufixarea->ip_address[3]);
m_CrateIP=str;
sprintf(str,"%d",p_bcufixarea->local_current_threshold);
m_LocPos=str;
sprintf(str,"%d",p_bcufixarea->vp_set);
m_LocNeg=str;
sprintf(str,"%d",p_bcufixarea->total_current_thres_pos);
m_TotPos=str;
sprintf(str,"%d",p_bcufixarea->total_current_thres_neg);
m_TotNeg=str;
sprintf(str,"v%x.%02x",(p_bcufixarea->logic_release>>8)&0x00FF,p_bcufixarea->logic_release&0x00FF);
m_LogicVer=str;
sprintf(str,"v%x.%02x.%04x",(p_bcufixarea->software_release>>24)&0xFF,(p_bcufixarea->software_release>>16)&0xFF,p_bcufixarea->software_release&0xFFFF);
m_NiosVer=str;
sprintf(str,"%04d",p_bcufixarea->serial_number);
m_BoardSN=str;
sprintf(str,"%04d",p_bcufixarea->pb_serial_number);
m_BckBoardSN=str;
sprintf(str,"0x%08x",p_bcufixarea->diagnostic_area.reset_status);
m_ResetStatus=str;
sprintf(str,"%d",p_bcufixarea->frames_counter);
m_FrameCnt=str;
sprintf(str,"%d",p_bcufixarea->enable_pos_acc);
m_EnaPosAcc=str;
sprintf(str,"%d",p_bcufixarea->enable_hl_commands);
m_EnaHLCommands=str;
sprintf(str,"%d",p_bcufixarea->enable_master_diag);
m_EnaMasterDiag=str;
sprintf(str,"0x%08x",p_bcufixarea->diagnostic_record_ptr);
m_DiagRecPtr=str;
sprintf(str,"%d",p_bcufixarea->diagnostic_record_len);
m_DiagRecLen=str;
sprintf(str,"%02x:%02x:%02x:%02x:%02x:%02x",p_bcufixarea->remote_mac_address[0],p_bcufixarea->remote_mac_address[1],p_bcufixarea->remote_mac_address[2],p_bcufixarea->remote_mac_address[3],p_bcufixarea->remote_mac_address[4],p_bcufixarea->remote_mac_address[5]);
m_RemoteMAC=str;
sprintf(str,"%3d.%3d.%3d.%3d",p_bcufixarea->remote_ip_address[0],p_bcufixarea->remote_ip_address[1],p_bcufixarea->remote_ip_address[2],p_bcufixarea->remote_ip_address[3]);
m_RemoteIP=str;
sprintf(str,"%d",p_bcufixarea->remote_udp_port);
m_RemoteUDP=str;
sprintf(str,"0x%08x",p_bcufixarea->wr_diagnostic_record_ptr);
m_WRDiagPtr=str;
sprintf(str,"0x%08x",p_bcufixarea->rd_diagnostic_record_ptr);
m_RDDiagPtr=str;
UpdateData(FALSE);
m_SlotConf.ResetContent();
for (i=0;i<NUM_BOARD_ON_CRATE;i++)
	{
	if (p_bcufixarea->crate_configuration[i]==0xFF)
		sprintf(str,"Slot #%2d: BCU board",i);
	else if (p_bcufixarea->crate_configuration[i]==0xFC)
		sprintf(str,"Slot #%2d: SIGGEN board",i);
	else if (p_bcufixarea->crate_configuration[i]==0xFA)
		sprintf(str,"Slot #%2d: WAVEGEN board",i);
	else if (p_bcufixarea->crate_configuration[i]==0xF8)
		sprintf(str,"Slot #%2d: ACCEL board",i);
	else if (p_bcufixarea->crate_configuration[i]==0x80)
		sprintf(str,"Slot #%2d: no board present",i);
	else if (p_bcufixarea->crate_configuration[i]<0x80)
		sprintf(str,"Slot #%2d: DSP board #%3d",i,p_bcufixarea->crate_configuration[i]);
	m_SlotConf.AddString(str);
	}

return (0);
}
