// DLDspPrg_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "DLDspPrg_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDLDspPrg_View

IMPLEMENT_DYNCREATE(CDLDspPrg_View, CFormView)

CDLDspPrg_View::CDLDspPrg_View()
	: CFormView(CDLDspPrg_View::IDD)
{
	//{{AFX_DATA_INIT(CDLDspPrg_View)
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\Lbt\\Codes\\LBT_dsp_SlopeCalculator\\v3.02\\Release\\CalcoloSlopes.ldr");
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_WantReply = TRUE;
	//}}AFX_DATA_INIT

}

CDLDspPrg_View::~CDLDspPrg_View()
{
}

void CDLDspPrg_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDLDspPrg_View)
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDLDspPrg_View, CFormView)
	//{{AFX_MSG_MAP(CDLDspPrg_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLDspPrg_View diagnostics

#ifdef _DEBUG
void CDLDspPrg_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CDLDspPrg_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDLDspPrg_View message handlers

BOOL CDLDspPrg_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CDLDspPrg_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
}

DWORD CDLDspPrg_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets,val32,packet_len;
char   tmpbuff[100];

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;

// determino la lunghezza del file binario
fd=fopen(m_FileName,"rt");
if (!fd)
	{
	AfxMessageBox("Input file name not valid");
	return 0;
	}

// primo pacchetto per mandare il DSP in reset e quindi in idle
// (write singolo su 180359)
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x00180359;
pData[0]=0x00000020;
(*bufferLen)[numPackets]=16;
tx_mgp->len=4;
(*bufferLen)[numPackets++]+=MGP_HLEN;

// primo pacchetto per resettare il dma di ricezione
// (write as a quad word in 180448)
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->fl+=MGP_FL_ASQUADWORD;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x00180448;
pData[0]=0x00000000;
pData[1]=0x00000000;
pData[2]=0x00000000;
pData[3]=0x00000000;
(*bufferLen)[numPackets]=16;
tx_mgp->len=4;
(*bufferLen)[numPackets++]+=MGP_HLEN;

// primo pacchetto per resettare il dma di ricezione
// (write as a quad word in 18044c)
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->fl+=MGP_FL_ASQUADWORD;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x0018044c;
pData[0]=0x00000000;
pData[1]=0x00000000;
pData[2]=0x00000000;
pData[3]=0x00000000;
(*bufferLen)[numPackets]=16;
tx_mgp->len=4;
(*bufferLen)[numPackets++]+=MGP_HLEN;

// secondo pacchetto per l'inizializzazione dei linkport 
// (write as a quad word in 1804e0)
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->fl+=MGP_FL_ASQUADWORD;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x001804e0;
pData[0]=0x00000000;
pData[1]=0x00000000;
pData[2]=0x000004c8;
pData[3]=0x000004c8;
(*bufferLen)[numPackets]=16;
tx_mgp->len=4;
(*bufferLen)[numPackets++]+=MGP_HLEN;

// ora leggo la parte programma
while (fscanf(fd,"%s",tmpbuff)!=-1)
	{
	if (!ConvertString(tmpbuff,&val32))
		{
		AfxMessageBox("Format of DSP program file not valid");
		return 0;
		}
	if ((val32&0xF0000000)==0x40000000)
		{ // buffer di dati
		packet_len=val32&0x0FFFFFFF;
		if (fscanf(fd,"%s",tmpbuff)==-1)
			{
			AfxMessageBox("Lenght of DSP program file not valid");
			return 0;
			}
		if (!ConvertString(tmpbuff,&start_addr))
			{
			AfxMessageBox("Format of DSP program file not valid");
			return 0;
			}
		i=0;
		do
			{
			(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
			(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
			// alloco il (*buffer) a dimensione massima
			(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
			memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
			tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
			pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
			tx_mgp->DSPs[0]=m_FirstDSP<<4;
			tx_mgp->DSPs[1]=m_FirstDSP>>4;
			tx_mgp->DSPs[2]=m_LastDSP;
			tx_mgp->op=MGP_OP_WRSAME_DSP;
			tx_mgp->fl=0;
			if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
			tx_mgp->id=(*packetID)++;
			tx_mgp->saddr=start_addr;
			i=0;
			if (start_addr&3)
				{ // allineamento a multiplo di 0x04 dello start address
				while (i<4-(start_addr&3) && packet_len)
					{
					if (fscanf(fd,"%s",tmpbuff)==-1)
						{
						AfxMessageBox("Lenght of DSP program file not valid");
						return 0;
						}
					if (!ConvertString(tmpbuff,(DWORD *)&pData[i++]))
						{
						AfxMessageBox("Format of DSP program file not valid");
						return 0;
						}
					packet_len--;
					}
				}
			else if (packet_len<4)
				{ // pacchetto finale 
				while (packet_len)
					{
					if (fscanf(fd,"%s",tmpbuff)==-1)
						{
						AfxMessageBox("Lenght of DSP program file not valid");
						return 0;
						}
					if (!ConvertString(tmpbuff,(DWORD *)&pData[i++]))
						{
						AfxMessageBox("Format of DSP program file not valid");
						return 0;
						}
					packet_len--;
					}
				}
			else if (packet_len<MAX_MGP_DATA_SIZE>>2)
				{ // allineamento a multiplo di 0x04 del packet_len
				for (;i<(packet_len&0xFFFFFFFC);)
					{
					if (fscanf(fd,"%s",tmpbuff)==-1)
						{
						AfxMessageBox("Lenght of DSP program file not valid");
						return 0;
						}
					if (!ConvertString(tmpbuff,(DWORD *)&pData[i++]))
						{
						AfxMessageBox("Format of DSP program file not valid");
						return 0;
						}
					}
				packet_len&=3;
				}
			else
				{ // pacchetti standard
				while (i<MAX_MGP_DATA_SIZE>>2)
					{
					if (fscanf(fd,"%s",tmpbuff)==-1)
						{
						AfxMessageBox("Lenght of DSP program file not valid");
						return 0;
						}
					if (!ConvertString(tmpbuff,(DWORD *)&pData[i++]))
						{
						AfxMessageBox("Format of DSP program file not valid");
						return 0;
						}
					packet_len--;
					}
				}
			(*bufferLen)[numPackets]=i*4;
			tx_mgp->len=i;
			start_addr+=i;
			(*bufferLen)[numPackets++]+=MGP_HLEN;
			}
		while (packet_len);
		}
	else if ((val32&0xF0000000)==0x80000000)
		{ // buffer da fillar a zero
		packet_len=val32&0x0FFFFFFF;
		if (fscanf(fd,"%s",tmpbuff)==-1)
			{
			AfxMessageBox("Length of DSP program file not valid");
			return 0;
			}
		if (!ConvertString(tmpbuff,&start_addr))
			{
			AfxMessageBox("Format of DSP program file not valid");
			return 0;
			}
		i=0;
		do
			{
			(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
			(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
			// alloco il (*buffer) a dimensione massima
			(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
			memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
			tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
			pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
			tx_mgp->DSPs[0]=m_FirstDSP<<4;
			tx_mgp->DSPs[1]=m_FirstDSP>>4;
			tx_mgp->DSPs[2]=m_LastDSP;
			tx_mgp->op=MGP_OP_WRSAME_DSP;
			tx_mgp->fl=0;
			if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
			tx_mgp->id=(*packetID)++;
			tx_mgp->saddr=start_addr;
			i=0;
			if (start_addr&3)
				{ // allineamento a multiplo di 0x04 dello start address
				while (i<4-(start_addr&3) && packet_len)
					{
					pData[i++]=0;
					packet_len--;
					}
				}
			else if (packet_len<4)
				{ // pacchetto finale 
				while (packet_len)
					{
					pData[i++]=0;
					packet_len--;
					}
				}
			else if (packet_len<MAX_MGP_DATA_SIZE>>2)
				{ // allineamento a multiplo di 0x04 del packet_len
				for (;i<(packet_len&0xFFFFFFFC);)
					pData[i++]=0;
				packet_len&=3;
				}
			else
				{ // pacchetti standard
				while (i<MAX_MGP_DATA_SIZE>>2)
					{
					pData[i++]=0;
					packet_len--;
					}
				}
			(*bufferLen)[numPackets]=i*4;
			tx_mgp->len=i;
			start_addr+=i;
			(*bufferLen)[numPackets++]+=MGP_HLEN;
			}
		while (packet_len);
		}
	else if (val32==0x00000000)
		{ // area programma
		i=0;
		start_addr=0;
		do
			{
			(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
			(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
			// alloco il (*buffer) a dimensione massima
			(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
			memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
			tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
			pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
			tx_mgp->DSPs[0]=m_FirstDSP<<4;
			tx_mgp->DSPs[1]=m_FirstDSP>>4;
			tx_mgp->DSPs[2]=m_LastDSP;
			tx_mgp->op=MGP_OP_WRSAME_DSP;
			tx_mgp->fl=0;
			if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
			tx_mgp->id=(*packetID)++;
			tx_mgp->saddr=start_addr;
			i=0;
			while (i<MAX_MGP_DATA_SIZE>>2 && fscanf(fd,"%s",tmpbuff)!=-1)
				{
				if (!ConvertString(tmpbuff,(DWORD *)&pData[i++]))
					{
					AfxMessageBox("Format of DSP program file not valid");
					return 0;
					}
				}
			(*bufferLen)[numPackets]=i*4;
			tx_mgp->len=i;
			start_addr+=i;
			(*bufferLen)[numPackets]+=MGP_HLEN;
			}
		while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);
		}
	else
		AfxMessageBox("Unknown format of DSP program file");
	}
fclose(fd);

// ultimo pacchetto per far partire il programma
// scrittura nel registro VIRPT (0x180730) dell'indirizzo 0
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x00180730;
pData[0]=0x00000000;
(*bufferLen)[numPackets]=4;
tx_mgp->len=1;
(*bufferLen)[numPackets++]+=MGP_HLEN;

return (numPackets);
}

void CDLDspPrg_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"DSP program file (*.ldr)|*.ldr|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select DSP program file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}

BOOL CDLDspPrg_View::ConvertString(char *buff,DWORD *val32)
{
int   i1;

strlwr(buff);
*val32=0;
if (buff[0]=='0' && buff[1]=='x')
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='a' && buff[2+i1]<='f')
			{
			*val32=*val32*16+buff[2+i1]-'a'+10;
			i1++;
			}
		else if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*16+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
return FALSE;
}
