// DLMMTDspPrg_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "DLMMTDspPrg_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define MAX_BUFFER            16384
#define MAXSTRING                50

/////////////////////////////////////////////////////////////////////////////
// CDLMMTDspPrg_View

IMPLEMENT_DYNCREATE(CDLMMTDspPrg_View, CFormView)

CDLMMTDspPrg_View::CDLMMTDspPrg_View()
	: CFormView(CDLMMTDspPrg_View::IDD)
{
	//{{AFX_DATA_INIT(CDLMMTDspPrg_View)
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\MMT\\Codes\\Am2_dsp\\v4.00\\Am2_dsp.exe");
	m_FirstDSP = 0;
	m_LastDSP = 0;
	m_WantReply = TRUE;
	//}}AFX_DATA_INIT

}

CDLMMTDspPrg_View::~CDLMMTDspPrg_View()
{
}

void CDLMMTDspPrg_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDLMMTDspPrg_View)
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDLMMTDspPrg_View, CFormView)
	//{{AFX_MSG_MAP(CDLMMTDspPrg_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDLMMTDspPrg_View diagnostics

#ifdef _DEBUG
void CDLMMTDspPrg_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CDLMMTDspPrg_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDLMMTDspPrg_View message handlers

BOOL CDLMMTDspPrg_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CDLMMTDspPrg_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
}

DWORD CDLMMTDspPrg_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
struct mgphdr *tx_mgp;
uint32 *pData32;
uint16 *pData16;
BYTE   *packetID;
DWORD  start_addr,numPackets;
DWORD  PMcode_buf[MAX_BUFFER];
WORD   DMcode_buf[MAX_BUFFER];
WORD   PMstartAddress,PMstopAddress,PMpointer;
WORD   DMstartAddress,DMstopAddress,DMpointer;
WORD   val16;
FILE   *exe_file;
char   linebuffer[MAXSTRING];

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;

memset(PMcode_buf,0,sizeof(PMcode_buf));
memset(DMcode_buf,0,sizeof(DMcode_buf));

///////////////// mette il file da scaricare in memoria /////////////////////////
// open file
if((exe_file=fopen(m_FileName,"r"))==NULL)
	{
	AfxMessageBox("Input file name not valid");
	return 0;
	}

// legge la prima linea
fgets(linebuffer,MAXSTRING,exe_file);

// verifica il formato del file
if (linebuffer[2] != 'i')
   {
   fclose(exe_file);
	AfxMessageBox("Input file format not valid");
	return 0;
   }

PMstartAddress=0x3fff;
PMstopAddress=0;
DMstartAddress=0x3fff;
DMstopAddress=0;

fgets(linebuffer,MAXSTRING,exe_file);
do
   {
   // checks for @PA
   if (!strncmp(linebuffer,"@PA",3))
	   {
   	// change the memory pointer
	   fgets(linebuffer,MAXSTRING,exe_file);
      // insert null terminator
      linebuffer[4]=0; 
    	sscanf(&linebuffer[0],"%x",&PMpointer);
      if (PMstartAddress>PMpointer)
         PMstartAddress=PMpointer;
     	fgets(linebuffer,MAXSTRING,exe_file);
      while (linebuffer[0]!='#' && PMpointer<MAX_BUFFER)
         {
         linebuffer[6]=linebuffer[5];
	      linebuffer[5]=linebuffer[4];
         linebuffer[7]=0;
   	   linebuffer[4]=0;
         sscanf(&linebuffer[0],"%x",&val16); 
   	   PMcode_buf[PMpointer]=val16;
   	   sscanf(&linebuffer[5],"%x",&val16); 
      	PMcode_buf[PMpointer]+=(val16<<16);
         PMpointer++;
         fgets(linebuffer,MAXSTRING,exe_file);
         }
      if (PMstopAddress<PMpointer)
         PMstopAddress=PMpointer;
      }

   // checks for @DA
   if (!strncmp(linebuffer,"@DA",3))
   	{
	   // change the memory pointer
   	fgets(linebuffer,MAXSTRING,exe_file);
      // insert null terminator
      linebuffer[4]=0; 
  	   sscanf(&linebuffer[0],"%x",&DMpointer); 
      if (DMstartAddress>DMpointer)
         DMstartAddress=DMpointer;
   	fgets(linebuffer,MAXSTRING,exe_file);
      while (linebuffer[0]!='#' && DMpointer<MAX_BUFFER)
         {
         linebuffer[4]=0;
        	sscanf(&linebuffer[0],"%x",&val16);
         DMcode_buf[DMpointer]=val16;
        	DMpointer++;
     		fgets(linebuffer,MAXSTRING,exe_file);
         }
      if (DMstopAddress<DMpointer)
         DMstopAddress=DMpointer;
      }
   fgets(linebuffer,MAXSTRING,exe_file);
   }
while (linebuffer[2] != 'o');

fclose(exe_file);

if (PMstartAddress!=0 || DMstartAddress>=DMstopAddress || PMstartAddress>=PMstopAddress)
   {
	AfxMessageBox("Input file format not valid");
	return 0;
   }

// primo pacchetto per mettere i DSP in reset
// scrittura nella locazione zero della data memory
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData16=(uint16 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->fl+=MGP_FL_HL_RESET;
tx_mgp->fl+=MGP_FL_HL_DMPM;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x00000000;
pData16[0]=0x0000;
pData16[1]=0x0000;
(*bufferLen)[numPackets]=4;
tx_mgp->len=2;
(*bufferLen)[numPackets++]+=MGP_HLEN;

// spedizione della data memory
if (((DMstopAddress-DMstartAddress)*2)%4)
   DMstopAddress+=1;
start_addr=DMstartAddress;
do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData16=(uint16 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->fl+=MGP_FL_HL_DMPM;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	if (DMstopAddress-start_addr<(MAX_MGP_DATA_SIZE>>1))
		val16=(WORD)(DMstopAddress-start_addr);
	else
		val16=(WORD)(MAX_MGP_DATA_SIZE>>1);
	memcpy(pData16,&DMcode_buf[start_addr],val16<<1);
	tx_mgp->len=val16;
	start_addr+=val16;
	(*bufferLen)[numPackets]=val16<<1;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

// spedizione della program memory
start_addr=PMstartAddress+1;
do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData32=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	if (PMstopAddress-start_addr<(MAX_MGP_DATA_SIZE>>2))
		val16=(WORD)(PMstopAddress-start_addr);
	else
		val16=(WORD)(MAX_MGP_DATA_SIZE>>2);
	memcpy(pData32,&PMcode_buf[start_addr],val16<<2);
	tx_mgp->len=val16;
	start_addr+=val16;
	(*bufferLen)[numPackets]=val16<<2;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

// ultimo pacchetto per far partire il programma
// scrittura nella locazione zero della program memory
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
// alloco il (*buffer) a dimensione massima
(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
pData32=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0x00000000;
pData32[0]=PMcode_buf[0];
(*bufferLen)[numPackets]=4;
tx_mgp->len=1;
(*bufferLen)[numPackets++]+=MGP_HLEN;

return (numPackets);
}

void CDLMMTDspPrg_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"DSP program file (*.exe)|*.exe|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select DSP program file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}

BOOL CDLMMTDspPrg_View::ConvertString(char *buff,DWORD *val32)
{
int   i1;

strlwr(buff);
*val32=0;
if (buff[0]=='0' && buff[1]=='x')
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='a' && buff[2+i1]<='f')
			{
			*val32=*val32*16+buff[2+i1]-'a'+10;
			i1++;
			}
		else if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*16+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
return FALSE;
}
