// Diagnostic_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "Diagnostic_View.h"
#include "mgp.h"
#include "Null_View.h"
#include "BCUConf_View.h"
#include "BCUStatus_View.h"
#include "DSPStatus_View.h"
#include "SigGenStatus_View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FONT_NAME    "Arial Narrow"
#define FONT_HEIGHT  14
#define FONT_WIDTH   0
#define MAX_LINES    500

/////////////////////////////////////////////////////////////////////////////
// CDiagnostic_View
int CALLBACK EnumFontFamExProc1(ENUMLOGFONT *lpelfe,      // pointer to logical-font data
                                NEWTEXTMETRICEX *lpntme,  // pointer to physical-font data
                                DWORD FontType,           // type of font
                                LPARAM lParam)            // application-defined data
{
// cerco i tre caratteri per la stampa
if (((CFont*)lParam)->m_hObject==0 && strcmp(lpelfe->elfLogFont.lfFaceName,FONT_NAME)==0)
	{
	lpelfe->elfLogFont.lfHeight=(long)(FONT_HEIGHT);
	lpelfe->elfLogFont.lfWidth=(long)(FONT_WIDTH);
	lpelfe->elfLogFont.lfWeight=FW_NORMAL;
	lpelfe->elfLogFont.lfItalic=0;
	((CFont*)lParam)->CreateFontIndirect(&lpelfe->elfLogFont);
	}
return(1);
}

IMPLEMENT_DYNCREATE(CDiagnostic_View, CFormView)

CDiagnostic_View::CDiagnostic_View()
	: CFormView(CDiagnostic_View::IDD)
{
	//{{AFX_DATA_INIT(CDiagnostic_View)
	//}}AFX_DATA_INIT
memset (m_TabView,0,sizeof(m_TabView));
activeView = 0;
}

CDiagnostic_View::~CDiagnostic_View()
{
}

void CDiagnostic_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiagnostic_View)
	DDX_Control(pDX, IDC_TABSELECTION, m_TabSelection);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiagnostic_View, CFormView)
	//{{AFX_MSG_MAP(CDiagnostic_View)
	ON_WM_SIZE()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TABSELECTION, OnSelChangeTabSelection)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiagnostic_View diagnostics

#ifdef _DEBUG
void CDiagnostic_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CDiagnostic_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDiagnostic_View message handlers

BOOL CDiagnostic_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
DWORD i;
RECT rect1;

if (!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect1, pParentWnd, nID, pContext))
	return (FALSE);

rect1=rect;

m_TabView[0].pView=new(CBCUConf_View);
((CBCUConf_View *)m_TabView[0].pView)->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
m_TabView[1].pView=new(CBCUStatus_View);
((CBCUStatus_View *)m_TabView[1].pView)->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
m_TabView[2].pView=new(CSigGenStatus_View);
((CSigGenStatus_View *)m_TabView[2].pView)->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
m_TabView[3].pView=new(CSigGenStatus_View);
((CSigGenStatus_View *)m_TabView[3].pView)->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
m_TabView[4].pView=new(CDSPStatus_View);
((CDSPStatus_View *)m_TabView[4].pView)->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
for (i=5;i<20;i++)
	m_TabView[i].pView=m_TabView[4].pView;

return (TRUE);
}

void CDiagnostic_View::OnInitialUpdate() 
{
CSize   size;
TCITEM  item;
LOGFONT logfont;
DWORD   i;
char    str[50];

CFormView::OnInitialUpdate();

// carico il font per il list box
logfont.lfCharSet=DEFAULT_CHARSET;
memset((void *)logfont.lfFaceName,0,sizeof(logfont.lfFaceName));
logfont.lfPitchAndFamily=0;
EnumFontFamiliesEx(GetDC()->m_hDC,                   // handle to device context
						 &logfont,                         // pointer to logical font information
						 (FONTENUMPROC)EnumFontFamExProc1, // pointer to callback function
						 (LPARAM)&m_Font,                  // application-supplied data
						 0);                               // reserved; must be zero
// aspetto che il font venga caricato
while(m_Font.m_hObject==0);

m_TabSelection.SetFont(&m_Font,TRUE);

size.cx=3;
size.cy=2;
m_TabSelection.SetPadding(size);

item.mask=TCIF_PARAM|TCIF_TEXT;
item.pszText="BCU config";
item.lParam=(LPARAM)&m_TabView[0];
m_TabSelection.InsertItem(0,&item);

item.pszText="BCU status";
item.lParam=(LPARAM)&m_TabView[1];
m_TabSelection.InsertItem(1,&item);

item.pszText="SIGGEN status";
item.lParam=(LPARAM)&m_TabView[2];
m_TabSelection.InsertItem(2,&item);

item.pszText="WAVEGEN status";
item.lParam=(LPARAM)&m_TabView[3];
m_TabSelection.InsertItem(3,&item);

for (i=0;i<16;i++)
	{
	sprintf(str,"DSP#%02d status",i*2);
	item.pszText=str;
	item.lParam=(LPARAM)&m_TabView[i+4];
	m_TabSelection.InsertItem(i+4,&item);
	}

m_TabView[activeView].enabled=TRUE;
m_TabSelection.SetCurSel(activeView);
m_TabView[activeView].pView->ShowWindow(SW_SHOW);
}

void CDiagnostic_View::OnSize(UINT nType, int cx, int cy) 
{
SIZE size;
CFormView::OnSize(nType, cx, cy);

size.cx=cx;
size.cy=cy;

SetScrollSizes(MM_TEXT,size);
if (::IsWindow(m_TabSelection.m_hWnd))
	m_TabSelection.MoveWindow(0,0,cx,cy,TRUE);
if (m_TabView[activeView].pView && ::IsWindow(m_TabView[activeView].pView->m_hWnd))
	m_TabView[activeView].pView->MoveWindow(1,30,cx-3,cy-33,TRUE);
}

void CDiagnostic_View::OnSelChangeTabSelection(NMHDR* pNMHDR, LRESULT* pResult) 
{
CRect rect;
if (m_TabView[m_TabSelection.GetCurSel()].enabled)
	{
	if (activeView<5)
		m_TabView[activeView].pView->ShowWindow(SW_HIDE);
	else
		m_TabView[4].pView->ShowWindow(SW_HIDE);
	activeView=m_TabSelection.GetCurSel();
	if (activeView<5)
		m_TabView[activeView].pView->ShowWindow(SW_SHOW);
	else
		m_TabView[4].pView->ShowWindow(SW_SHOW);
	GetClientRect(&rect);
	SendMessage(WM_SIZE,0,(rect.Height()<<16)+rect.Width());
	}
else
	m_TabSelection.SetCurSel(activeView);

*pResult = 0;
}

LRESULT CDiagnostic_View::OnUpdateProgress(void *p_data,LPARAM dummy2)
{
return (::PostMessage(m_TabView[activeView].pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)p_data,0));
}
