// InputArea.cpp : implementation of the CInputArea class
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "LBT_EngPanelDoc.h"
#include "InputArea.h"
#include "Null_View.h"
#include "BCUConf_View.h"
#include "SetBCUIP_View.h"
#include "WriteDsp_View.h"
#include "ReadDsp_View.h"
#include "WrRdDspTest_View.h"
#include "DLDspPrg_View.h"
#include "LockFlash_View.h"
#include "UnlockFlash_View.h"
#include "ClearFlash_View.h"
#include "WriteFlash_View.h"
#include "ReadFlash_View.h"
#include "WriteFpgaRam_View.h"
#include "ClearSdram_View.h"
#include "WriteSdram_View.h"
#include "ReadSdram_View.h"
#include "WriteDiagBuff_View.h"
#include "ReadDiagBuff_View.h"
#include "WrRdSdramTest_View.h"
#include "ClearSram_View.h"
#include "WriteSram_View.h"
#include "ReadSram_View.h"
#include "WrRdSramTest_View.h"
#include "TestProcedures_View.h"
#include "Reset_View.h"
#include "RelaisBoard_View.h"
#include "WriteMMTDsp_View.h"
#include "ReadMMTDsp_View.h"
#include "DLMMTDspPrg_View.h"
#include "WrRdMMTDspTest_View.h"
#include "Diagnostic_View.h"
#include "WrRdFLDspTest_View.h"
#include "ThroughputTest_View.h"
#include "MainFrm.h"
#include "mgp.h"
#include "udp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define NUM_RET_BEFORE_TIMEOUT   250
#define CIRCULAR_BUFFER_ELEM     256 // NB deve essere 256
#define NUM_PARALLEL_PACKETS       1
#define PACKET_TYPE_NONE           0
#define PACKET_TYPE_WRITE          1
#define PACKET_TYPE_READ           2
#define TIME_TO_ALIVE             10

#define PACKET_FREE                0
#define PACKET_BUSY                1

// defines per il progamma di test dei fast link
#define DSP_ENABLE_PTR   0x8008e
#define DSP_COUNTERS_PTR 0x80080

/////////////////////////////////////////////////////////////////////////////
// CInputArea
#define TOP_BORDER                 35
#define NULL_VIEW                   0
#define SETBCUIP_VIEW               1
#define RESET_VIEW                  2
#define DIAGNOSTIC_VIEW             3
#define WRSAME_DSP_VIEW             4
#define WRSEQ_DSP_VIEW              5
#define READ_DSP_VIEW               6
#define DLDSP_PRG_VIEW              7
#define WRRDDSPTEST_VIEW            8
#define LOCK_FLASH_VIEW             9
#define UNLOCK_FLASH_VIEW          10
#define CLEAR_FLASH_VIEW           11
#define WRITE_FLASH_VIEW           12
#define READ_FLASH_VIEW            13
#define WRITE_FPGA_RAM_VIEW        14
#define CLEAR_SDRAM_VIEW           15
#define WRSAME_SDRAM_VIEW          16
#define WRSEQ_SDRAM_VIEW           17
#define READ_SDRAM_VIEW            18
#define WRSAME_DIAGBUFF_VIEW       19
#define WRSEQ_DIAGBUFF_VIEW        20
#define READ_DIAGBUFF_VIEW         21
#define WRRDSDRAMTEST_VIEW         22
#define CLEAR_SRAM_VIEW            23
#define WRSAME_SRAM_VIEW           24
#define WRSEQ_SRAM_VIEW            25
#define READ_SRAM_VIEW             26
#define WRRDSRAMTEST_VIEW          27
#define TESTPROCEDURES_VIEW        28
#define WRSAME_MMT_DSP_VIEW        29
#define WRSEQ_MMT_DSP_VIEW         30
#define READ_MMT_DSP_VIEW          31
#define DLMMTDSP_PRG_VIEW          32
#define WRRDMMTDSPTEST_VIEW        33
#define WRRDFLDSPTEST_VIEW         34
#define RELAISBOARD_VIEW           35
#define THROUGHPUTTEST_VIEW        36

IMPLEMENT_DYNCREATE(CInputArea, CFormView)

BEGIN_MESSAGE_MAP(CInputArea, CFormView)
	//{{AFX_MSG_MAP(CInputArea)
	ON_CBN_SELCHANGE(IDC_CMD_SELECTION, OnSelChangeCmdSelection)
	ON_BN_CLICKED(IDC_CMD_SEND, OnCmdSend)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_BUTTONS, OnUpdateButtons)
END_MESSAGE_MAP()

#define DELAY_COUNTER 300000

/*************************************************************/
/* THREAD usato per le test procedures                       */
/*************************************************************/
UINT CInputArea::TestProcThread(LPVOID lpParams)
{
struct mgphdr *tx_mgp,*rx_mgp;
uint32        *pData;
DWORD         **threadParam=(DWORD **)lpParams;
DWORD         event,counter;
HANDLE        handles[2];
BYTE          packetID;
char          file_name[200];
BYTE          *wr_buffer;
FILE          *fd=NULL;
int           i,i1;

CInputArea     *pParent   = (CInputArea *)((*threadParam)[0]);
CMyAsyncSocket *pSocket   = (CMyAsyncSocket *)((*threadParam)[1]);
CView          *pView     = (CView *)((*threadParam)[2]);
               handles[0] = (HANDLE)((*threadParam)[3]); // exit handle
               handles[1] = (HANDLE)((*threadParam)[4]); // callback handle
BYTE           firstDSP   = (BYTE)((*threadParam)[5]);
BOOL           saveOnFile = (BOOL)((*threadParam)[6]);
DWORD          step       = (DWORD)((*threadParam)[7]);

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
// metodo spartano per svuotare il semaforo
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// apro il file di salvataggio dei dati in ricezione
if (saveOnFile)
	{
	sprintf(file_name,"S:\\Ausil\\Roby\\DspBoard_test_result.dat");
	fd=fopen(file_name,"wt");
	}

// azzero il packet ID
packetID=0;

switch (step)
	{
	case  0:
	case  1:
	case  2:
	case  3:
	case  4:
	case  5:
	case  6:
	case  11:
		sprintf(file_name,"Step %d not available yet",step);
		AfxMessageBox(file_name);
	break;
	case  7:
		// preparo l'output di visualizzazione
		::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,500,0);
		wr_buffer=(BYTE *)malloc(MAX_MGP_DATA_SIZE);
		tx_mgp=(struct mgphdr *)wr_buffer;
		tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
		tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
		tx_mgp->DSPs[2]=(BYTE)(0xFF);
		tx_mgp->op=MGP_OP_RESERVED_2;
		tx_mgp->len=1;
		tx_mgp->fl=MGP_FL_WANTREPLY;
		tx_mgp->id=0;
		tx_mgp->saddr=0;
		((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=firstDSP;
		// reset buffer circolare di ricezione
		pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
		counter=0;
		while (1)
			{
			event=WaitForMultipleObjects(2,handles,FALSE,50);
			if (event==WAIT_TIMEOUT) // timeout
				{
				if (counter<500)
					{
					counter++;
					::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)counter,0);
					}
				else
					{
					AfxMessageBox("No reply data received");
					goto end;
					}
				}
			else if (event==0)       // esco dal thread
				{
				TRACE ("TestProcThread exit event received\n");
				goto end;
				}
			else if (event==1) // callback event
				{
				// verifica dei dati di reply
				rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
				if (rx_mgp->op!=MGP_OP_CMD_SUCCESS)
					TRACE("Command reply:  %02x\n",rx_mgp->op);
				// verifica che il data buffer sia corretto
				pData=(uint32 *)((uint32)rx_mgp+MGP_HLEN);
				if (fd)
					{
					for (i=0;i<rx_mgp->len;)
						{
						for (i1=0;i1<8 && i<rx_mgp->len;i++,i1++)
							{
							fprintf(fd,"%08x ",pData[i]);
							}
						fprintf(fd,"\n");
						}
/*					strcpy(str,"Data rcvd ");
					for (i=0;i<rx_mgp->len;)
						{
						for (i1=0;i1<7 && i<rx_mgp->len-1;i++,i1++)
							{
							sprintf(str1,"%08x - ",pData[i]);
							strcat(str,str1);
							}
						sprintf(str1,"%08x\n",pData[i++]);
						strcat(str,str1);
						fprintf(fd,str);
						strcpy(str,"          ");
						}
*/
					}

				goto end;
				}
			}
	break;
	case  8:
		// preparo l'output di visualizzazione
		::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,500,0);
		wr_buffer=(BYTE *)malloc(MAX_MGP_DATA_SIZE);
		tx_mgp=(struct mgphdr *)wr_buffer;
		tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
		tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
		tx_mgp->DSPs[2]=(BYTE)(0xFF);
		tx_mgp->op=MGP_OP_RESERVED_3;
		tx_mgp->len=1;
		tx_mgp->fl=MGP_FL_WANTREPLY;
		tx_mgp->id=0;
		tx_mgp->saddr=0;
		((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=(0<<8) + firstDSP;
		// reset buffer circolare di ricezione
		pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
		counter=0;
		while (1)
			{
			event=WaitForMultipleObjects(2,handles,FALSE,50);
			if (event==WAIT_TIMEOUT) // timeout
				{
				counter++;
				::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)counter%500,0);
				}
			else if (event==0)       // esco dal thread
				{
				TRACE ("TestProcThread exit event received\n");
				goto end;
				}
			else if (event==1) // callback event
				{
				goto end;
				}
			}
	break;
	case  9: // DAC frequency test
		// preparo l'output di visualizzazione
		::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,500,0);
		wr_buffer=(BYTE *)malloc(MAX_MGP_DATA_SIZE);
		tx_mgp=(struct mgphdr *)wr_buffer;
		tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
		tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
		tx_mgp->DSPs[2]=(BYTE)(0xFF);
		tx_mgp->op=MGP_OP_RESERVED_3;
		tx_mgp->len=1;
		tx_mgp->fl=MGP_FL_WANTREPLY;
		tx_mgp->id=0;
		tx_mgp->saddr=0;
		((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=(1<<8) + firstDSP;
		// reset buffer circolare di ricezione
		pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
		counter=0;
		while (1)
			{
			event=WaitForMultipleObjects(2,handles,FALSE,50);
			if (event==WAIT_TIMEOUT) // timeout
				{
				if (counter<500)
					{
					counter++;
					::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)counter,0);
					}
				else
					{
					AfxMessageBox("No reply data received");
					goto end;
					}
				}
			else if (event==0)       // esco dal thread
				{
				TRACE ("TestProcThread exit event received\n");
				goto end;
				}
			else if (event==1) // callback event
				{
				goto end;
				}
			}
	case  10: // on-board memory test
		// disabilito l'output a video
		pSocket->m_EnableOutput=FALSE;
		// preparo l'output di visualizzazione
		::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,500,(LPARAM)"DSP memory test in process...");
		wr_buffer=(BYTE *)malloc(MAX_MGP_DATA_SIZE);
		tx_mgp=(struct mgphdr *)wr_buffer;
		pData=(uint32 *)((uint32)tx_mgp+MGP_HLEN);
		tx_mgp->DSPs[0]=(BYTE)(firstDSP<<4);
		tx_mgp->DSPs[1]=(BYTE)(firstDSP>>4);
		tx_mgp->DSPs[2]=(BYTE)(firstDSP);
		// metto la variabile che mi indica lo status del test a -1
		tx_mgp->op=MGP_OP_WRSAME_SRAM;
		tx_mgp->len=1;
		tx_mgp->fl=0;
		tx_mgp->id=0;
		tx_mgp->saddr=0x00007FFF;
		pData[0]=0xffffffff;
		pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
		// comando di start del test
		tx_mgp->op=MGP_OP_RESERVED_4;
		tx_mgp->len=0;
		tx_mgp->saddr=0;
		pSocket->Send((void *)tx_mgp,MGP_HLEN,0);
		counter=0;
		// polling in attesa che il test sia terminato
		tx_mgp->op=MGP_OP_RDSEQ_SRAM;
		tx_mgp->id=1;
		tx_mgp->len=1;
		tx_mgp->saddr=0x00007FFF;
		tx_mgp->fl=MGP_FL_WANTREPLY;
		pSocket->Send((void *)tx_mgp,MGP_HLEN,0);
		while (1)
			{
			event=WaitForMultipleObjects(2,handles,FALSE,200);
			if (event==WAIT_TIMEOUT) // timeout
				{
				AfxMessageBox("No reply data received");
				goto end;
				}
			else if (event==0)       // esco dal thread
				{
				TRACE ("TestProcThread exit event received\n");
				goto end;
				}
			else if (event==1) // callback event
				{
				rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
				if (rx_mgp->op!=MGP_OP_CMD_SUCCESS)
					TRACE("Command reply:  %02x\n",rx_mgp->op);
				// verifica che il data buffer sia corretto
				pData=(uint32 *)((uint32)rx_mgp+MGP_HLEN);
				if (pData[0]==0xFFFFFFFF)
					{
					counter+=2;
					if (counter>=500) counter=0;
					::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)counter,0);
					Sleep(100);
					pSocket->Send((void *)tx_mgp,MGP_HLEN,0);
					}
				else
					{
					sprintf(file_name,"Test completed with result %08x\n",pData[0]);
					AfxMessageBox(file_name);
					goto end;
					}
				}
			}
	break;
	default:
		sprintf(file_name,"Step %d not supported",step);
		AfxMessageBox(file_name);
	break;
	}
		
AfxMessageBox("Step done!!!");

end:

// chiudo il file di salvataggio dei dati in ricezione
if (fd) fclose(fd),fd=NULL;

if (wr_buffer) free (wr_buffer),wr_buffer=NULL;

// reset dell'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,-1,0);

// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// se l'uscita non e' stata forzata resetto i bottoni
pParent->hTestProcThread=NULL;

::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,2,0);

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

TRACE ("TestProc thread exited\n");
return (0);
}

/*************************************************************/
/* THREAD usato per il test write/read                       */
/*************************************************************/
UINT CInputArea::PollingThread(LPVOID lpParams)
{
struct mgphdr   *tx_mgp,*rx_mgp;
uint32          *pData,*pData1;
DWORD           **threadParam=(DWORD **)lpParams;
DWORD           event,i,i1,val,filter,startTime;
HANDLE          handles[2];
DWORD           packetID;
CHECK_PACKET    check_packet[CIRCULAR_BUFFER_ELEM];
PROGRESS_PACKET progress_packet;
BYTE            *wr_buffer[CIRCULAR_BUFFER_ELEM];
BYTE            *rd_buffer[CIRCULAR_BUFFER_ELEM];
UINT            wr_buffer_len,rd_buffer_len;
UINT            wr_packets_received,rd_packets_received;
UINT            num_retry;
DWORD           delay,size32;
BYTE            numDSP;
DWORD           counter,readerBufferPtr,num_pack_busy;

CInputArea        *pParent           = (CInputArea *)((*threadParam)[0]);
CMyAsyncSocket    *pSocket           = (CMyAsyncSocket *)((*threadParam)[1]);
CView             *pView             = (CView *)((*threadParam)[2]);
                  handles[0]         = (HANDLE)((*threadParam)[3]); // exit handle
                  handles[1]         = (HANDLE)((*threadParam)[4]); // callback handle
BYTE              firstDSP           = (BYTE)((*threadParam)[5]);
BYTE              lastDSP            = (BYTE)((*threadParam)[6]);
UINT              numIter            = (UINT)((*threadParam)[7]);
WORD              size               = (WORD)((*threadParam)[8]);
UINT              startAddress       = (UINT)((*threadParam)[9]);
BOOL              fixedBuffer        = (BOOL)((*threadParam)[10]);
DWORD             device             = (DWORD)((*threadParam)[11]); // 0 = DSP, 1 = SDRAM, 2 = SRAM, 3 = MMTDSP(DM), 4 = MMTDSP(PM)

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// preparo l'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,numIter*2,0);
// disabilito l'output a video
pSocket->m_EnableOutput=FALSE;

// apro il file di salvataggio dei dati in ricezione
// pSocket->m_fd=fopen("output.txt","wt");

// reset dei buffer di trasmissione e ricezione
memset((void *)wr_buffer,0,sizeof(wr_buffer));
memset((void *)rd_buffer,0,sizeof(rd_buffer));
// reset di tutto il buffer dei comandi in queue
memset((void *)check_packet,0,sizeof(check_packet));
// azzero il packet ID
packetID=0;
delay=0;

// determino il size per ogni dsp
if (firstDSP==0xFF || firstDSP==0xFE)
	{
	numDSP = 1;
	size32 = size;
	}
else if (device==0)
	{
	numDSP = lastDSP - firstDSP + 1;
	size /= numDSP;
	if (size > 7) size&=0xfffffffC;
	size32 = size;
	}
else if (device==1)
	{
	numDSP = (lastDSP>>1) - (firstDSP>>1) + 1;
	size /= numDSP;
	size32 = size;
	}
else if (device==2)
	{
	numDSP = (lastDSP>>1) - (firstDSP>>1) + 1;
	size /= numDSP;
	size32 = size;
	}
else if (device==3)
	{
	numDSP = lastDSP - firstDSP + 1;
	size /= numDSP;
	size32 = size / 2;
	}
else if (device==4)
	{
	numDSP = lastDSP - firstDSP + 1;
	size /= numDSP;
	size32 = size;
	}

if (size32==0)
	{
	AfxMessageBox("Invalid size");
	goto end;
	}

counter=0;

// creo i CIRCULAR_BUFFER_ELEM buffers di write
wr_buffer_len=size32*4*numDSP+MGP_HLEN;
wr_buffer[0]=(BYTE *)malloc(wr_buffer_len);
memset(wr_buffer[0],0,wr_buffer_len);
tx_mgp=(struct mgphdr *)wr_buffer[0];
tx_mgp->DSPs[0]=firstDSP<<4;
tx_mgp->DSPs[1]=firstDSP>>4;
tx_mgp->DSPs[2]=lastDSP;
if (device==0)
	tx_mgp->op=MGP_OP_WRSEQ_DSP;
else if (device==1)
	tx_mgp->op=MGP_OP_WRSEQ_SDRAM;
else if (device==2)
	tx_mgp->op=MGP_OP_WRSEQ_SRAM;
else if (device==3 || device==4)
	{
	if (numDSP==1)
		tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
	else
		tx_mgp->op=MGP_OP_HL_WRSEQ_DSP;
	}
tx_mgp->len=size;
tx_mgp->fl=MGP_FL_WANTREPLY;
if (device==3)
	tx_mgp->fl|=MGP_FL_HL_DMPM;
tx_mgp->id=0;
tx_mgp->saddr=startAddress;
for (i=1;i<CIRCULAR_BUFFER_ELEM;i++)
	{
	wr_buffer[i]=(BYTE *)malloc(wr_buffer_len);
	memcpy(wr_buffer[i],wr_buffer[0],wr_buffer_len);
	tx_mgp=(struct mgphdr *)wr_buffer[i];
	tx_mgp->saddr=startAddress+size*i;               // ciascun pacchetto di ha un'area distinta dove scrivere/leggere
	}

// creo i CIRCULAR_BUFFER_ELEM buffer di read
rd_buffer_len=MGP_HLEN;
rd_buffer[0]=(BYTE *)malloc(rd_buffer_len);
memset(rd_buffer[0],0,rd_buffer_len);
tx_mgp=(struct mgphdr *)rd_buffer[0];
tx_mgp->DSPs[0]=firstDSP<<4;
tx_mgp->DSPs[1]=firstDSP>>4;
tx_mgp->DSPs[2]=lastDSP;
if (device==0)
	tx_mgp->op=MGP_OP_RDSEQ_DSP;
else if (device==1)
	tx_mgp->op=MGP_OP_RDSEQ_SDRAM;
else if (device==2)
	tx_mgp->op=MGP_OP_RDSEQ_SRAM;
else if (device==3 || device==4)
	tx_mgp->op=MGP_OP_HL_RDSEQ_DSP;
tx_mgp->len=size;
tx_mgp->fl=MGP_FL_WANTREPLY;
if (device==3)
	tx_mgp->fl|=MGP_FL_HL_DMPM;
tx_mgp->id=0;
tx_mgp->saddr=startAddress;
for (i=1;i<CIRCULAR_BUFFER_ELEM;i++) 
	{
	rd_buffer[i]=(BYTE *)malloc(rd_buffer_len);
	memcpy(rd_buffer[i],rd_buffer[0],rd_buffer_len);
	tx_mgp=(struct mgphdr *)rd_buffer[i];
	tx_mgp->saddr=startAddress+size*i;               // ciascun pacchetto di ha un'area distinta dove scrivere/leggere
	}

progress_packet.progressCount=0;
progress_packet.numCmdReplyFault=0;
progress_packet.numBitsWrong=0;
progress_packet.numPacketLost=0;
progress_packet.elapsedTime=0;
progress_packet.numBitSent=0;
startTime=GetTickCount();

// azzero il numero di packets sent
wr_packets_received=rd_packets_received=0;
readerBufferPtr=(pSocket->receiverBufferPtr + 1)&(CIRCULAR_BUFFER_SIZE-1);

// mando i primi pacchetti di write 
for (i1=0;i1<NUM_PARALLEL_PACKETS;i1++)
	{
	while (packetID!=CIRCULAR_BUFFER_ELEM && check_packet[packetID].status==PACKET_BUSY)
		packetID=packetID++;
	// reset di tutto il buffer dei comandi in queue
	if (packetID==CIRCULAR_BUFFER_ELEM)
		{
		AfxMessageBox("Casino 0");
		goto end;
		}
	tx_mgp=(struct mgphdr *)wr_buffer[packetID];
	tx_mgp->id=(BYTE)(packetID&0xFF);
	pData=(uint32 *)((uint32)tx_mgp+MGP_HLEN);
	if (!fixedBuffer)
		{
		for (i=0;i<(uint32)(size32*numDSP);i++)
			{
			pData[i]=rand()+(rand()<<16);
			if (device==4) pData[i]&=0x00FFFFFF;
			}
		pData[0]=counter++;
		}
	else
		{
		for (i=0;i<(uint32)(size32*numDSP);i++)
			{
//			pData[i]=0xaaaaaaaa;
			pData[i]=delay;
			if (device==4) pData[i]&=0x00FFFFFF;
			}
		delay++;
		}
	check_packet[packetID].status=PACKET_BUSY;
	check_packet[packetID].packetType=PACKET_TYPE_WRITE;
	check_packet[packetID].start_address=tx_mgp->saddr;
	check_packet[packetID].pBuffer=(void *)tx_mgp;
	check_packet[packetID].ttl=TIME_TO_ALIVE;
	pSocket->Send((void *)tx_mgp,wr_buffer_len,0);
//Sleep(0);
	}

num_retry=0;
while (1)
	{
   event=WaitForMultipleObjects(2,handles,FALSE,100);

	if (event==WAIT_TIMEOUT)      // timeout 
		{
		if (num_retry==NUM_RET_BEFORE_TIMEOUT)
			{
			AfxMessageBox("Timeout: no reply data received");
			goto end;
			}
		else
			{
			TRACE ("Timeout condition\n");
			// aggiorno il numero di packets lost
			for (i=0;i<256;i++)
				{
				if (check_packet[i].status==PACKET_BUSY)
					progress_packet.numPacketLost++;
				}
			memset((void *)check_packet,0,sizeof(check_packet));
			packetID=0;
			// mando i primi pacchetti di write 
			for (i1=0;i1<NUM_PARALLEL_PACKETS;i1++)
				{
				// cerco la prossima locazione libera
				while (packetID!=CIRCULAR_BUFFER_ELEM && check_packet[packetID].status==PACKET_BUSY)
					packetID=packetID++;
				// reset di tutto il buffer dei comandi in queue
				if (packetID==CIRCULAR_BUFFER_ELEM)
					{
					AfxMessageBox("Casino 1");
					goto end;
					}
				tx_mgp=(struct mgphdr *)wr_buffer[packetID];
				tx_mgp->id=(BYTE)(packetID&0xFF);
				pData=(uint32 *)((uint32)tx_mgp+MGP_HLEN);
				if (!fixedBuffer)
					{
					for (i=0;i<size32;i++)
						{
//						pData[i]=rand()+(rand()<<16);
						if (device==4) pData[i]&=0x00FFFFFF;
						}
					pData[0]=counter++;
					}
				else
					{
					for (i=0;i<size32;i++)
						{
//			         pData[i]=0xaaaaaaaa;
						pData[i]=delay;
						if (device==4) pData[i]&=0x00FFFFFF;
						}
					delay++;
					}
				check_packet[packetID].status=PACKET_BUSY;
				check_packet[packetID].packetType=PACKET_TYPE_WRITE;
				check_packet[packetID].start_address=tx_mgp->saddr;
				check_packet[packetID].pBuffer=(void *)tx_mgp;
				check_packet[packetID].ttl=TIME_TO_ALIVE;
				pSocket->Send((void *)tx_mgp,wr_buffer_len,0);
//Sleep(0);
				}
			num_retry++;
			}
		}
	else if (event==0)      // esco dal thread
		{
		TRACE ("PollingThread exit event received\n");
		goto end;
		}
	else if (event==1)      // callback event, verifico i dati ricevuti e mando un nuovo pacchetto
		{
		// aggiorno il numero di packets lost
		num_pack_busy=0;
		for (i=0;i<256;i++)
			{
			if (check_packet[i].status==PACKET_BUSY)
				{
				if (check_packet[i].ttl==0)
					{
					check_packet[i].status=PACKET_FREE;
					progress_packet.numPacketLost++;
					}
				else
					check_packet[i].ttl--;
				num_pack_busy++;
				}
			}
		// rimetto in linea gli eventuali pacchetti persi
		for (i=num_pack_busy;i<NUM_PARALLEL_PACKETS;i++)
			{
			packetID=0;
			// cerco la prossima locazione libera
			while (packetID!=CIRCULAR_BUFFER_ELEM && check_packet[packetID].status==PACKET_BUSY)
				packetID=packetID++;
			// reset di tutto il buffer dei comandi in queue
			if (packetID==CIRCULAR_BUFFER_ELEM)
				{
				AfxMessageBox("Casino 2");
				goto end;
				}
			tx_mgp=(struct mgphdr *)wr_buffer[packetID];
			tx_mgp->id=(BYTE)(packetID&0xFF);
			pData=(uint32 *)((uint32)tx_mgp+MGP_HLEN);
			if (!fixedBuffer)
				{
				for (i=0;i<size32;i++)
					{
//					pData[i]=rand()+(rand()<<16);
					if (device==4) pData[i]&=0x00FFFFFF;
					}
				pData[0]=counter++;
				}
			else
				{
				for (i=0;i<size32;i++)
					{
//			         pData[i]=0xaaaaaaaa;
					pData[i]=delay;
					if (device==4) pData[i]&=0x00FFFFFF;
					}
				delay++;
				}
			check_packet[packetID].status=PACKET_BUSY;
			check_packet[packetID].packetType=PACKET_TYPE_WRITE;
			check_packet[packetID].start_address=tx_mgp->saddr;
			check_packet[packetID].pBuffer=(void *)tx_mgp;
			check_packet[packetID].ttl=TIME_TO_ALIVE;
			pSocket->Send((void *)tx_mgp,wr_buffer_len,0);
//Sleep(0);
			}
		// reset del counter di num reply
		num_retry=0;
		// verifica dei dati di reply
		rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[readerBufferPtr]);
		readerBufferPtr=(readerBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1);
		if (check_packet[rx_mgp->id].status==PACKET_BUSY && check_packet[rx_mgp->id].packetType==PACKET_TYPE_WRITE)
			{ // ricevuto un reply ad un pacchetto di write
			wr_packets_received++;
			progress_packet.elapsedTime=GetTickCount()-startTime;
			progress_packet.numBitSent+=(wr_buffer_len-MGP_HLEN)*8;
			// verifica che il comando di reply sia di success e che il data buffer len sia corretto
			if (rx_mgp->op!=MGP_OP_CMD_SUCCESS || rx_mgp->len!=0)
				{
				TRACE("Command reply:  %02x\n",rx_mgp->op);
				TRACE("Data len: %04x\n",rx_mgp->len);
				progress_packet.numCmdReplyFault++;
				}
			packetID=rx_mgp->id;
			tx_mgp=(struct mgphdr *)rd_buffer[packetID];
			tx_mgp->id=(BYTE)(packetID&0xFF);
			tx_mgp->saddr=check_packet[rx_mgp->id].start_address;
			// mando la richiesta di read
			check_packet[packetID].status=PACKET_BUSY;
			check_packet[packetID].packetType=PACKET_TYPE_READ;
			check_packet[packetID].start_address=check_packet[rx_mgp->id].start_address;
			check_packet[packetID].pBuffer=check_packet[rx_mgp->id].pBuffer;
			check_packet[packetID].ttl=TIME_TO_ALIVE;
			pSocket->Send((void *)tx_mgp,rd_buffer_len,0);
//Sleep(0);
			}
		else if (check_packet[rx_mgp->id].status==PACKET_BUSY && check_packet[rx_mgp->id].packetType==PACKET_TYPE_READ)
			{ // ricevuto un reply ad un pacchetto di read 
			rd_packets_received++;
			progress_packet.elapsedTime=GetTickCount()-startTime;
			progress_packet.numBitSent+=(wr_buffer_len-MGP_HLEN)*8;
			// verifica che il comando di reply sia di success e che il data buffer len sia corretto
			if (rx_mgp->op!=MGP_OP_CMD_SUCCESS || rx_mgp->len!=(wr_buffer_len-MGP_HLEN)/4)
				{
				TRACE("Command reply:  %02x\n",rx_mgp->op);
				TRACE("Data len: %04x\n",rx_mgp->len);
				progress_packet.numCmdReplyFault++;
				}
			// verifica che il data buffer sia corretto
			if (memcmp((void *)((uint32)rx_mgp+MGP_HLEN),(void *)((uint32)check_packet[rx_mgp->id].pBuffer+MGP_HLEN),rx_mgp->len*4))
				{
				pData=(uint32 *)((uint32)rx_mgp+MGP_HLEN);
				pData1=(uint32 *)((uint32)check_packet[rx_mgp->id].pBuffer+MGP_HLEN);
				// cerco quanti bit sono sbagliati
				for (i=0;i<rx_mgp->len;i++) 
					if (pData[i]!=pData1[i])
						{
						TRACE("data sent %d: %08x - %08x - %08x\n",i,pData1[i-1],pData1[i],pData1[i+1]);
						TRACE("data rcvd %d: %08x - %08x - %08x\n",i,pData[i-1],pData[i],pData[i+1]);
						val=pData[i]^pData1[i];
						for (i1=0,filter=1;i1<32;i1++,filter*=2)
							if (val&filter)
								progress_packet.numBitsWrong++;
						}
//				goto end;
				}
			// mando il comando di write successivo se minore di numIter
			if (wr_packets_received<numIter)
				{
				packetID=rx_mgp->id;
				tx_mgp=(struct mgphdr *)wr_buffer[packetID];
				tx_mgp->id=(BYTE)(packetID&0xFF);
				pData=(uint32 *)((uint32)tx_mgp+MGP_HLEN);
				if (!fixedBuffer)
					{
					for (i=0;i<size32;i++)
						{
//						pData[i]=rand()+(rand()<<16);
						if (device==4) pData[i]&=0x00FFFFFF;
						}
					pData[0]=counter++;
					}
				else
					{
					for (i=0;i<size32;i++)
						{
//			         pData[i]=0xaaaaaaaa;
						pData[i]=delay;
						if (device==4) pData[i]&=0x00FFFFFF;
						}
					delay++;
					}
				check_packet[packetID].status=PACKET_BUSY;
				check_packet[packetID].packetType=PACKET_TYPE_WRITE;
				check_packet[packetID].start_address=tx_mgp->saddr;
				check_packet[packetID].pBuffer=(void *)tx_mgp;
				check_packet[packetID].ttl=TIME_TO_ALIVE;
				pSocket->Send((void *)tx_mgp,wr_buffer_len,0);
//Sleep(0);
				}
			else
				{
				AfxMessageBox("Test completed!!!");
				goto end;
				}
			}
		else
			{ 
			}
		// update dell'output di visualizzazione
		progress_packet.progressCount=wr_packets_received+rd_packets_received;
		if (!(progress_packet.progressCount%500))
			::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)&progress_packet,0);
		}
	if (rd_packets_received==numIter)
		{
		::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)&progress_packet,0);
		break;
		}
	}
AfxMessageBox("All done!!!");

end:

// chiudo il file di salvataggio dei dati in ricezione
if (pSocket->m_fd)
	fclose(pSocket->m_fd),pSocket->m_fd=NULL;

for (i=0;i<CIRCULAR_BUFFER_ELEM;i++)
	{
	if (wr_buffer[i]) free (wr_buffer[i]),wr_buffer[i]=NULL;
	if (rd_buffer[i]) free (rd_buffer[i]),rd_buffer[i]=NULL;
	}

// reset dell'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,-1,0);

// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

// se l'uscita non e' stata forzata resetto i bottoni
::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,2,0);

TRACE ("Polling thread exited\n");
return (0);
}

/*************************************************************/
/* THREAD usato per il test di throughput                    */
/*************************************************************/
UINT CInputArea::PollingThread2(LPVOID lpParams)
{
struct mgphdr   *tx_mgp,*rx_mgp;
DWORD           **threadParam=(DWORD **)lpParams;
DWORD           event,i,i1,startTime,oldIdx;
HANDLE          handles[2];
DWORD           packetID;
CHECK_PACKET    check_packet[CIRCULAR_BUFFER_ELEM];
PROGRESS_PACKET progress_packet;
BYTE            *rd_buffer[CIRCULAR_BUFFER_ELEM];
UINT            rd_buffer_len,tx_buffer_len;
UINT            rd_packets_received;
UINT            num_retry;
DWORD           size32;
BYTE            numDSP;
DWORD           counter,readerBufferPtr,num_pack_busy;

CInputArea        *pParent           = (CInputArea *)((*threadParam)[0]);
CMyAsyncSocket    *pSocket           = (CMyAsyncSocket *)((*threadParam)[1]);
CView             *pView             = (CView *)((*threadParam)[2]);
                  handles[0]         = (HANDLE)((*threadParam)[3]); // exit handle
                  handles[1]         = (HANDLE)((*threadParam)[4]); // callback handle
BYTE              firstDSP           = (BYTE)((*threadParam)[5]);
BYTE              lastDSP            = (BYTE)((*threadParam)[6]);
UINT              numIter            = (UINT)((*threadParam)[7]);
WORD              size               = (WORD)((*threadParam)[8]);
UINT              startAddress       = (UINT)((*threadParam)[9]);
DWORD             device             = (DWORD)((*threadParam)[10]); // 0 = DSP, 1 = SDRAM, 2 = MMTDSP(DM)

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// preparo l'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,numIter,0);
// disabilito l'output a video
pSocket->m_EnableOutput=FALSE;

// reset dei buffer di trasmissione e ricezione
memset((void *)rd_buffer,0,sizeof(rd_buffer));
// reset di tutto il buffer dei comandi in queue
memset((void *)check_packet,0,sizeof(check_packet));

// determino il size per ogni dsp
if (firstDSP==0xFF || firstDSP==0xFE)
	{
	numDSP = 1;
	size32 = size;
	}
else if (device==0)
	{
	numDSP = lastDSP - firstDSP + 1;
	size /= numDSP;
	if (size > 7) size&=0xfffffffC;
	size32 = size;
	}
else if (device==1 || device==2)
	{
	numDSP = (lastDSP>>1) - (firstDSP>>1) + 1;
	size /= numDSP;
	size32 = size;
	}
else if (device==3)
	{
	numDSP = lastDSP - firstDSP + 1;
	size /= numDSP;
	size32 = size / 2;
	}

if (size32==0 || size32*numDSP>JUMBO_MAX_MGP_DATA_SIZE)
	{
	AfxMessageBox("Invalid packet size");
	goto end;
	}

counter=0;
rd_buffer_len=size;

// creo i CIRCULAR_BUFFER_ELEM buffer di read
tx_buffer_len=MGP_HLEN;
rd_buffer[0]=(BYTE *)malloc(tx_buffer_len);
memset(rd_buffer[0],0,tx_buffer_len);
tx_mgp=(struct mgphdr *)rd_buffer[0];
tx_mgp->DSPs[0]=firstDSP<<4;
tx_mgp->DSPs[1]=firstDSP>>4;
tx_mgp->DSPs[2]=lastDSP;
if (device==0)
	tx_mgp->op=MGP_OP_RDSEQ_DSP;
else if (device==1)
	tx_mgp->op=MGP_OP_RDSEQ_SDRAM;
else if (device==2)
	tx_mgp->op=MGP_OP_RDSEQ_SRAM;
else if (device==3)
	tx_mgp->op=MGP_OP_HL_RDSEQ_DSP;
tx_mgp->len=size;
tx_mgp->fl=MGP_FL_WANTREPLY;
if (device==3)
	tx_mgp->fl|=MGP_FL_HL_DMPM;
tx_mgp->saddr=startAddress;
for (i=1;i<CIRCULAR_BUFFER_ELEM;i++) 
	{
	rd_buffer[i]=(BYTE *)malloc(tx_buffer_len);
	memcpy(rd_buffer[i],rd_buffer[0],tx_buffer_len);
	tx_mgp=(struct mgphdr *)rd_buffer[i];
	tx_mgp->saddr=startAddress;
	}

progress_packet.progressCount=0;
progress_packet.numCmdReplyFault=0;
progress_packet.numBitsWrong=0;
progress_packet.numPacketLost=0;
progress_packet.elapsedTime=0;
progress_packet.numBitSent=0;
startTime=GetTickCount();

// azzero il numero di packets sent
rd_packets_received=0;
readerBufferPtr=pSocket->receiverBufferPtr;

// azzero il packet ID
packetID=0;
// mando i primi pacchetti di read 
for (i1=0;i1<NUM_PARALLEL_PACKETS;i1++)
	{
	tx_mgp=(struct mgphdr *)rd_buffer[packetID];
	tx_mgp->id=(BYTE)(packetID&0xFF);
	check_packet[packetID].status=PACKET_BUSY;
	check_packet[packetID].ttl=TIME_TO_ALIVE;
	check_packet[packetID].pBuffer=(void *)tx_mgp;
	pSocket->Send((void *)tx_mgp,tx_buffer_len,0);
	packetID=(packetID+1)&0xFF;
	}

oldIdx=1;
num_retry=0;
while (1)
	{
   event=WaitForMultipleObjects(2,handles,FALSE,100);

	if (event==WAIT_TIMEOUT)      // timeout 
		{
		if (num_retry==NUM_RET_BEFORE_TIMEOUT)
			{
			AfxMessageBox("Timeout: no reply data received");
			goto end;
			}
		else
			{
			TRACE ("Timeout condition\n");
			// aggiorno il numero di packets lost
			for (i=0;i<256;i++)
				{
				if (check_packet[i].status==PACKET_BUSY)
					progress_packet.numPacketLost++;
				}
			memset((void *)check_packet,0,sizeof(check_packet));
			packetID=0;
			// mando i primi pacchetti di read
			for (i1=0;i1<NUM_PARALLEL_PACKETS;i1++)
				{
				tx_mgp=(struct mgphdr *)rd_buffer[packetID];
				tx_mgp->id=(BYTE)packetID;
				check_packet[packetID].status=PACKET_BUSY;
				check_packet[packetID].ttl=TIME_TO_ALIVE;
				pSocket->Send((void *)tx_mgp,tx_buffer_len,0);
				packetID=(packetID+1)&0xFF;
				}
			num_retry++;
			}
		}
	else if (event==0)      // esco dal thread
		{
		TRACE ("PollingThread exit event received\n");
		goto end;
		}
	else if (event==1)      // callback event, verifico i dati ricevuti e mando un nuovo pacchetto
		{
//		num_pack_busy=0;
//		TRACE("---event received---\n");
//		while (readerBufferPtr!=pSocket->receiverBufferPtr)
//			{
			// verifica dei dati di reply
			rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[(readerBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1)]);
			readerBufferPtr=(readerBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1);
//			TRACE("packet received %d\n",rx_mgp->id);
			if (check_packet[rx_mgp->id].status==PACKET_BUSY)
				{ // ricevuto un reply ad un pacchetto di read 
				rd_packets_received++;
				progress_packet.elapsedTime=GetTickCount()-startTime;
				progress_packet.numBitSent+=(rd_buffer_len-MGP_HLEN)*8;
				// verifica che il comando di reply sia di success e che il data buffer len sia corretto
				if (rx_mgp->op!=MGP_OP_CMD_SUCCESS || rx_mgp->len!=rd_buffer_len)
					{
					TRACE("Command reply:  %02x\n",rx_mgp->op);
					TRACE("Data len: %04x\n",rx_mgp->len);
					progress_packet.numCmdReplyFault++;
					}
				// mando un'altro pacchetto di read
				tx_mgp=(struct mgphdr *)rd_buffer[rx_mgp->id];
				tx_mgp->id=(BYTE)rx_mgp->id;
				check_packet[rx_mgp->id].status=PACKET_BUSY;
				check_packet[rx_mgp->id].ttl=TIME_TO_ALIVE;
				pSocket->Send((void *)tx_mgp,tx_buffer_len,0);
				}
			else
				{
				AfxMessageBox("Casino 2");
				goto end;
				}
//			num_pack_busy++;
//			}
//		TRACE("%d pacchetti ricevuti\n",num_pack_busy);
		// aggiorno il numero di packets lost
		num_pack_busy=0;
		for (i=0;i<256;i++)
			{
			if (check_packet[i].status==PACKET_BUSY)
				{
				if (check_packet[i].ttl==0)
					{
					check_packet[i].status=PACKET_FREE;
					progress_packet.numPacketLost++;
					}
				else
					{
					check_packet[i].ttl--;
					num_pack_busy++;
					}
				}
			}
		// rimetto in linea gli eventuali pacchetti persi
		for (i1=num_pack_busy,packetID=0;i1<NUM_PARALLEL_PACKETS;i1++)
			{
			// cerco la prossima locazione libera
			while (packetID!=256 && check_packet[packetID].status==PACKET_BUSY)
				packetID++;
			// reset di tutto il buffer dei comandi in queue
			if (packetID==CIRCULAR_BUFFER_ELEM)
				{
				AfxMessageBox("Casino 2");
				goto end;
				}
			tx_mgp=(struct mgphdr *)rd_buffer[packetID];
			tx_mgp->id=(BYTE)packetID;
			check_packet[tx_mgp->id].status=PACKET_BUSY;
			check_packet[tx_mgp->id].ttl=TIME_TO_ALIVE;
			pSocket->Send((void *)tx_mgp,tx_buffer_len,0);
			}
		// reset del counter di num reply
		num_retry=0;
		// update dell'output di visualizzazione
		progress_packet.progressCount=rd_packets_received;
		if (!(progress_packet.progressCount%500))
			::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)&progress_packet,0);
		}
	if (rd_packets_received==numIter)
		{
		::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)&progress_packet,0);
		break;
		}
	}
AfxMessageBox("All done!!!");

end:

// chiudo il file di salvataggio dei dati in ricezione
if (pSocket->m_fd)
	fclose(pSocket->m_fd),pSocket->m_fd=NULL;

for (i=0;i<CIRCULAR_BUFFER_ELEM;i++)
	if (rd_buffer[i]) free (rd_buffer[i]),rd_buffer[i]=NULL;

// reset dell'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,-1,0);

// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

// se l'uscita non e' stata forzata resetto i bottoni
::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,2,0);

TRACE ("Polling thread exited\n");
return (0);
}

/*************************************************************/
/* THREAD usato per il test della fastlink e bus32 bit       */
/*************************************************************/
UINT CInputArea::PollingThread1(LPVOID lpParams)
{
struct mgphdr   *tx_mgp,*rx_mgp;
DWORD           **threadParam=(DWORD **)lpParams;
DWORD           event,startTime,elapsedTime;
HANDLE          handles[2];
BYTE            *wr_buffer;
UINT            num_retry;

CInputArea        *pParent           = (CInputArea *)((*threadParam)[0]);
CMyAsyncSocket    *pSocket           = (CMyAsyncSocket *)((*threadParam)[1]);
CView             *pView             = (CView *)((*threadParam)[2]);
                  handles[0]         = (HANDLE)((*threadParam)[3]); // exit handle
                  handles[1]         = (HANDLE)((*threadParam)[4]); // callback handle

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// preparo l'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,0x10000,0);
// disabilito l'output a video
pSocket->m_EnableOutput=FALSE;

// apro il file di salvataggio dei dati in ricezione
// pSocket->m_fd=fopen("output.txt","wt");

wr_buffer=(BYTE *)malloc(MAX_MGP_DATA_SIZE);
memset(wr_buffer,0,MAX_MGP_DATA_SIZE);
// fermo il test nel caso fosse in running
tx_mgp=(struct mgphdr *)wr_buffer;
tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
tx_mgp->DSPs[2]=(BYTE)(0xFF);
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->len=1;
tx_mgp->fl=MGP_FL_WANTREPLY;
tx_mgp->id=0;
tx_mgp->saddr=DSP_ENABLE_PTR;
((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=0;
pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
event=WaitForMultipleObjects(2,handles,FALSE,1000);
if (event==WAIT_TIMEOUT)      // timeout 
	{
	AfxMessageBox("Timeout: unable to start Dsp FastLink test program");
	goto end;
	}
// paccheto che azzera tutti i contatori e disabilita la comunicazione veloce
tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
tx_mgp->DSPs[2]=(BYTE)(0xFF);
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->len=16;
tx_mgp->fl=MGP_FL_WANTREPLY;
tx_mgp->id=0;
tx_mgp->saddr=DSP_COUNTERS_PTR;
((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=0;
pSocket->Send((void *)tx_mgp,MGP_HLEN+0x40,0);
event=WaitForMultipleObjects(2,handles,FALSE,1000);
if (event==WAIT_TIMEOUT)      // timeout 
	{
	AfxMessageBox("Timeout: unable to start Dsp FastLink test program");
	goto end;
	}
// start del test
tx_mgp=(struct mgphdr *)wr_buffer;
tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
tx_mgp->DSPs[2]=(BYTE)(0xFF);
tx_mgp->op=MGP_OP_WRSAME_DSP;
tx_mgp->len=1;
tx_mgp->fl=MGP_FL_WANTREPLY;
tx_mgp->id=0;
tx_mgp->saddr=DSP_ENABLE_PTR;
((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=1;
pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
event=WaitForMultipleObjects(2,handles,FALSE,1000);
if (event==WAIT_TIMEOUT)      // timeout 
	{
	AfxMessageBox("Timeout: unable to start Dsp FastLink test program");
	goto end;
	}

num_retry=0;
startTime=GetTickCount();
while (1)
	{
	tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
	tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
	tx_mgp->DSPs[2]=(BYTE)(0xFF);
	tx_mgp->op=MGP_OP_RDSEQ_DSP;
	tx_mgp->len=16;
	tx_mgp->fl=MGP_FL_WANTREPLY;
	tx_mgp->id=0;
	tx_mgp->saddr=DSP_COUNTERS_PTR;
	pSocket->Send((void *)tx_mgp,MGP_HLEN,0);

   event=WaitForMultipleObjects(2,handles,FALSE,1000);

	if (event==WAIT_TIMEOUT)      // timeout 
		{
		if (num_retry==NUM_RET_BEFORE_TIMEOUT)
			{
			AfxMessageBox("Timeout: no reply data received");
			goto end;
			}
		else
			{
			TRACE ("Timeout condition\n");
			num_retry++;
			}
		}
	else if (event==0)      // esco dal thread
		{
		tx_mgp->DSPs[0]=(BYTE)(0xFF<<4);
		tx_mgp->DSPs[1]=(BYTE)(0xFF>>4);
		tx_mgp->DSPs[2]=(BYTE)(0xFF);
		tx_mgp->op=MGP_OP_WRSAME_DSP;
		tx_mgp->len=1;
		tx_mgp->fl=MGP_FL_WANTREPLY;
		tx_mgp->id=0;
		tx_mgp->saddr=DSP_ENABLE_PTR;
		((uint32 *)((uint32)tx_mgp+MGP_HLEN))[0]=0;
		pSocket->Send((void *)tx_mgp,MGP_HLEN+4,0);
		TRACE ("PollingThread1 exit event received\n");
		goto end;
		}
	else if (event==1)      // callback event, verifico i dati ricevuti e mando un nuovo pacchetto
		{
		// verifica dei dati di reply
		rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
		// update dell'output di visualizzazione
		elapsedTime=GetTickCount()-startTime;
		::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)elapsedTime,(LPARAM)&((uint32 *)((uint32)rx_mgp+MGP_HLEN))[0]);
		Sleep(200);
		num_retry=0;
		}
	}
AfxMessageBox("All done!!!");

end:

// chiudo il file di salvataggio dei dati in ricezione
if (pSocket->m_fd)
	fclose(pSocket->m_fd),pSocket->m_fd=NULL;

if (wr_buffer) free (wr_buffer),wr_buffer=NULL;

// reset dell'output di visualizzazione
::SendMessage(pView->m_hWnd,WM_SET_PROGRESS,-1,0);

// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

// se l'uscita non e' stata forzata resetto i bottoni
::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,2,0);

TRACE ("Polling thread exited\n");
return (0);
}

/*************************************************************/
/* THREAD usato per la spedizione di una serie di pacchetti  */
/*************************************************************/
UINT CInputArea::SendThread(LPVOID lpParams)
{
DWORD         **threadParam=(DWORD **)lpParams;
DWORD         event,i;
HANDLE        handles[3];
CInputArea        *pParent;
CMyAsyncSocket    *pSocket;
BYTE  ***buffer;
int   **bufferLen;
DWORD *numPackets;
BYTE  packetID;
struct mgphdr   *rx_mgp;

pParent     = (CInputArea *)((*threadParam)[0]);
pSocket     = (CMyAsyncSocket *)((*threadParam)[1]);
handles[0]  = (HANDLE)((*threadParam)[2]);   // exit handle
handles[1]  = (HANDLE)((*threadParam)[3]);   // start send handle
handles[2]  = (HANDLE)((*threadParam)[4]);   // reply received handle
buffer      = (BYTE ***)((*threadParam)[5]); 
bufferLen   = (int **)((*threadParam)[6]);   
numPackets  = (DWORD *)((*threadParam)[7]);  

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
ResetEvent(handles[1]);

// disabilito l'output a video
//pSocket->m_EnableOutput=FALSE;

while (1)
	{
   event=WaitForMultipleObjects(2,handles,FALSE,INFINITE);
	
// disabilito l'output a video
// pSocket->m_EnableOutput=FALSE;
// riabilito l'output a video
// pSocket->m_EnableOutput=TRUE;

	if (event==0)      // esco dal thread
		{
		TRACE ("InputArea SendThread exit event received\n");
		goto end;
		}
	else if (event==1) // start send event
		{
		TRACE ("InputArea send packets event received\n");
		// metodo spartano per svuotare il semaforo di eventuali reply spuri
		while (WAIT_TIMEOUT!=WaitForSingleObject(handles[2],100));
		// spedizione dei pacchetti
		for (i=0;i<*numPackets;i++)
			{
			if ((*buffer)[i])
				{
				// spedizione del pacchetto
				packetID=((struct mgphdr *)(*buffer)[i])->id;
				pSocket->Send((void *)((*buffer)[i]),(*bufferLen)[i],0);
				::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,3,0);
				// attesa del reply del pacchetto appena spedito
				event=WaitForMultipleObjects(3,handles,FALSE,60000);
				if      (event==WAIT_TIMEOUT)      // esco dal thread
					{
					TRACE ("InputArea SendThread timeout\n");
					break;
					}
				else if (event==0) // esco dal thread
					{
					TRACE ("InputArea SendThread exit event received\n");
					goto end;
					}
				else if (event==1) // stop send event
					{
					TRACE ("InputArea SendThread stop event received\n");
					break;
					}
				else if (event==2) // reply event (continue!)
					{
					// verifica dei dati di reply
					rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
					if      (rx_mgp->op==MGP_OP_CMD_SUCCESS && rx_mgp->id!=packetID)
						{
						AfxMessageBox("Error: inconsistent reply packet reveived!!!");
						break;
						}
					else if (rx_mgp->op==MGP_OP_CMD_FAULT || rx_mgp->op==MGP_OP_CMD_TIMEOUT)
						{
						AfxMessageBox("Error: fault or timeout reply packet reveived!!!");
						break;
						}
					}
				}
			}	
		for (i=0;i<*numPackets;i++)
			if ((*buffer)[i]) free ((*buffer)[i]),(*buffer)[i]=NULL;
		if (*buffer) free (*buffer),*buffer=NULL;
		if (*bufferLen) free (*bufferLen),*bufferLen=NULL;
		*numPackets=0;
		::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,1,0);
		}
	}

end:

for (i=0;i<*numPackets;i++)
	if ((*buffer)[i]) free ((*buffer)[i]),(*buffer)[i]=NULL;
if (*buffer) free (*buffer),*buffer=NULL;
if (*bufferLen) free (*bufferLen),*bufferLen=NULL;
*numPackets=0;

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

TRACE ("InputArea SendThread thread exited\n");
return (0);
}

/*************************************************************/
/* THREAD usato per il polling diagnostico                   */
/*************************************************************/
UINT CInputArea::DiagnosticThread(LPVOID lpParams)
{
struct mgphdr   *tx_mgp,*rx_mgp;
DWORD           event,i,active_view;
DWORD           **threadParam=(DWORD **)lpParams;
HANDLE          handles[2];
BYTE            *rd_buffer;
UINT            rd_buffer_len;
UINT            num_retry;
BYTE            firstDSP,lastDSP;
na_bcu_nios_fixed_area_struct     *p_bcufixarea;
volatile na_bcu_diagnostic_struct *p_bcudiagarea;

CInputArea       *pParent   = (CInputArea *)((*threadParam)[0]);
CMyAsyncSocket   *pSocket   = (CMyAsyncSocket *)((*threadParam)[1]);
CDiagnostic_View *pView     = (CDiagnostic_View *)((*threadParam)[2]);
                 handles[0] = (HANDLE)((*threadParam)[3]); // exit handle
                 handles[1] = (HANDLE)((*threadParam)[4]); // callback handle

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

ResetEvent(handles[0]);
// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// disabilito l'output a video
pSocket->m_EnableOutput=FALSE;

rd_buffer_len=MGP_HLEN;
rd_buffer=(BYTE *)malloc(rd_buffer_len);
tx_mgp=(struct mgphdr *)rd_buffer;

// prima richiesta di un pacchetto di configurazione per abilitare i tab corrispondenti alle schede presenti sul bus
firstDSP=lastDSP=0xff;
tx_mgp->DSPs[0]=firstDSP<<4;
tx_mgp->DSPs[1]=firstDSP>>4;
tx_mgp->DSPs[2]=lastDSP;
tx_mgp->op=MGP_OP_RDSEQ_SRAM;
tx_mgp->len=sizeof(na_bcu_nios_fixed_area_struct)/4;
tx_mgp->fl=MGP_FL_WANTREPLY;
tx_mgp->id=0;
tx_mgp->saddr=na_bcu_nios_fixed_area_offset/4;

pSocket->Send((void *)tx_mgp,rd_buffer_len,0);
// attesa del reply
event=WaitForMultipleObjects(2,handles,FALSE,1000);

if (event==WAIT_TIMEOUT)      // timeout
	{
	AfxMessageBox("Timeout: no reply data received");
	goto end;
	}
else if (event==0)      // esco dal thread
	{
	TRACE ("DiagnosticThread exit event received\n");
	goto end;
	}
else if (event==1)      // callback event, verifico i dati ricevuti e mando un nuovo pacchetto
	{
	rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
	p_bcufixarea=(na_bcu_nios_fixed_area_struct *)((uint32)rx_mgp+MGP_HLEN);
	p_bcudiagarea=&p_bcufixarea->diagnostic_area;
	// aggiorno il tab diagnostico
	for (i=1;i<NUM_BOARD_ON_CRATE;i++)
		pView->m_TabView[i].enabled=FALSE;
	for (i=0;i<NUM_BOARD_ON_CRATE;i++)
		{
		if (p_bcufixarea->crate_configuration[i]==0xFF)
			pView->m_TabView[1].enabled=TRUE;
		else if (p_bcufixarea->crate_configuration[i]==0xFC)
			pView->m_TabView[2].enabled=TRUE;
		else if (p_bcufixarea->crate_configuration[i]==0xFA)
			pView->m_TabView[3].enabled=TRUE;
		else if (p_bcufixarea->crate_configuration[i]==0xF8)
			pView->m_TabView[2].enabled=TRUE;
		else if (p_bcufixarea->crate_configuration[i]>=0x00 && p_bcufixarea->crate_configuration[i]<=0x1E)
			pView->m_TabView[p_bcufixarea->crate_configuration[i]/2+4].enabled=TRUE;
		else if (p_bcufixarea->crate_configuration[i]!=0x80)
			{
			AfxMessageBox("Invalid bus crate configuration");
			goto end;
			}
		}
	}

num_retry=0;
while (1)
	{
	active_view=pView->m_TabSelection.GetCurSel();
	// mando un pacchetto di read dello status in funzione del tab attivo
	if (active_view==0)
		{
		firstDSP=lastDSP=0xFF;
		tx_mgp->len=sizeof(na_bcu_nios_fixed_area_struct)/4;
		tx_mgp->saddr=na_bcu_nios_fixed_area_offset/4;
		}
	else if (active_view==1)
		{
		firstDSP=lastDSP=0xFF;
		tx_mgp->len=sizeof(na_bcu_diagnostic_struct)/4;
		tx_mgp->saddr=(na_bcu_nios_fixed_area_offset+sizeof(na_bcu_nios_fixed_area_struct)-sizeof(na_bcu_diagnostic_struct))/4;
		}
	else if (active_view==2)
		{
		firstDSP=lastDSP=0xFC;
//		firstDSP=lastDSP=0xF8;
		tx_mgp->len=(sizeof(na_dsp_nios_fixed_area_struct_16ch)-(MGP_HLEN+MAX_MGP_DATA_SIZE+6))/4;
		tx_mgp->saddr=(na_dsp_nios_fixed_area_offset+MGP_HLEN+MAX_MGP_DATA_SIZE+6)/4;
		}
	else if (active_view==3)
		{
		firstDSP=lastDSP=0xFA;
		tx_mgp->len=(sizeof(na_dsp_nios_fixed_area_struct_16ch)-(MGP_HLEN+MAX_MGP_DATA_SIZE+6))/4;
		tx_mgp->saddr=(na_dsp_nios_fixed_area_offset+MGP_HLEN+MAX_MGP_DATA_SIZE+6)/4;
		}
	else
		{
		firstDSP=lastDSP=(BYTE)((active_view-4)*2);
		tx_mgp->len=(sizeof(na_dsp_nios_fixed_area_struct_16ch)-(MGP_HLEN+MAX_MGP_DATA_SIZE+6))/4;
		tx_mgp->saddr=(na_dsp_nios_fixed_area_offset+MGP_HLEN+MAX_MGP_DATA_SIZE+6)/4;
		}
	tx_mgp->DSPs[0]=firstDSP<<4;
	tx_mgp->DSPs[1]=firstDSP>>4;
	tx_mgp->DSPs[2]=lastDSP;
	tx_mgp->op=MGP_OP_RDSEQ_SRAM;
	tx_mgp->fl=MGP_FL_WANTREPLY;
	tx_mgp->id=0;
	pSocket->Send((void *)tx_mgp,rd_buffer_len,0);

   event=WaitForMultipleObjects(2,handles,FALSE,1000);

	if (event==WAIT_TIMEOUT)      // timeout 
		{
		if (num_retry==NUM_RET_BEFORE_TIMEOUT)
			{
			AfxMessageBox("Timeout: no reply data received");
			goto end;
			}
		else
			{
			TRACE ("Timeout condition\n");
			num_retry++;
			}
		}
	else if (event==0)      // esco dal thread
		{
		TRACE ("DiagnosticThread exit event received\n");
		goto end;
		}
	else if (event==1)      // callback event, verifico i dati ricevuti e mando un nuovo pacchetto
		{
		rx_mgp=(struct mgphdr *)(pSocket->receiverBuffer[pSocket->receiverBufferPtr]);
		::PostMessage(pView->m_hWnd,WM_UPDATE_PROGRESS,(WPARAM)((uint32)rx_mgp+MGP_HLEN),0);
		num_retry=0;
		}
	// refresh time di 500ms
	Sleep(500);
	}

AfxMessageBox("All done!!!");

end:

// chiudo il file di salvataggio dei dati in ricezione
if (pSocket->m_fd)
	fclose(pSocket->m_fd),pSocket->m_fd=NULL;

if (rd_buffer) free (rd_buffer),rd_buffer=NULL;

// metodo spartano per svuotare il semaforo di eventuali reply spuri
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[1],100));

// riabilito l'output a video
pSocket->m_EnableOutput=TRUE;

// se l'uscita non e' stata forzata resetto i bottoni
::SendMessage(pParent->m_hWnd,WM_UPDATE_BUTTONS,2,0);

TRACE ("Diagnostic thread exited\n");
return (0);
}

/////////////////////////////////////////////////////////////////////////////
// CInputArea construction/destruction

CInputArea::CInputArea()
	: CFormView(CInputArea::IDD)
{
//{{AFX_DATA_INIT(CInputArea)
//m_CommandSelection = 0; // set BCU ip
//m_CommandSelection = 1; // reset view
//m_CommandSelection = 2; // diagnostic view
//m_CommandSelection = 13; // write sdram
//m_CommandSelection =  7; // wrrd dsp test 
//m_CommandSelection =  4; // dl dsp program
//m_CommandSelection =  20; // write diag buff
//m_CommandSelection =  23; // test procedures
//m_CommandSelection = 31; // dl mmt dsp program
//m_CommandSelection = 32; // mmt dsp wr/rd test
m_CommandSelection = 35; // read throughput test
//}}AFX_DATA_INIT

buffer=NULL;
bufferLen=NULL;
commandId=0;
numPackets=0;

memset (input_forms,0,sizeof(input_forms));
memset (CmdSel2View,0,sizeof(CmdSel2View));

// creo il thread per la nuova configurazione
m_DiagnosticExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelDiagnosticExitEvent");
m_SendExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelSendExitEvent");
m_SendPackHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelSendPackEvent");
m_PollingExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelPollingExitEvent");
m_Polling1ExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelPolling1ExitEvent");
m_Polling2ExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelPolling2ExitEvent");
m_TestProcExitHandle=CreateEvent(NULL,FALSE,FALSE,"LBT_EngPanelTestProcExitEvent");
threadParam=NULL;
hSendThread=NULL;
hDiagnosticThread=NULL;
hPollingThread=NULL;
hPollingThread1=NULL;
hPollingThread2=NULL;
hTestProcThread=NULL;

activeView=-1;
}

CInputArea::~CInputArea()
{
DWORD i;

if (m_DiagnosticExitHandle!=NULL) CloseHandle(m_DiagnosticExitHandle),m_DiagnosticExitHandle=NULL;
if (m_SendExitHandle!=NULL) CloseHandle(m_SendExitHandle),m_SendExitHandle=NULL;
if (m_SendPackHandle!=NULL) CloseHandle(m_SendPackHandle),m_SendPackHandle=NULL;
if (m_PollingExitHandle!=NULL) CloseHandle(m_PollingExitHandle),m_PollingExitHandle=NULL;
if (m_Polling1ExitHandle!=NULL) CloseHandle(m_Polling1ExitHandle),m_Polling1ExitHandle=NULL;
if (m_Polling2ExitHandle!=NULL) CloseHandle(m_Polling2ExitHandle),m_Polling2ExitHandle=NULL;
if (m_TestProcExitHandle!=NULL) CloseHandle(m_TestProcExitHandle),m_TestProcExitHandle=NULL;
if (threadParam) free (threadParam),threadParam=NULL;

for (i=0;i<numPackets;i++)
	if (buffer[i])
		free(buffer[i]),buffer[i]=NULL;
if (buffer) free(buffer),buffer=NULL;
if (bufferLen) free (bufferLen);bufferLen=NULL;
}

void CInputArea::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CInputArea)
	DDX_Control(pDX, IDC_CMD_SEND, m_SendCmd);
	DDX_Control(pDX, IDC_CONNECT, m_Connect);
	DDX_Control(pDX, IDC_CMD_SELECTION, m_CommandSelectionCtrl);
	DDX_CBIndex(pDX, IDC_CMD_SELECTION, m_CommandSelection);
	//}}AFX_DATA_MAP
}

void CInputArea::OnInitialUpdate()
{
CRect rect;
CMainFrame *pMainFrame=(CMainFrame *)(GetParent()->GetParent());
CWinThread *pThread;

CFormView::OnInitialUpdate();

// aggiungo tutti i comandi gestiti
m_CommandSelectionCtrl.AddString("Set BCU IP Address");
m_CommandSelectionCtrl.AddString("Reset System");
m_CommandSelectionCtrl.AddString("Diagnostic monitor");
m_CommandSelectionCtrl.AddString("DSP Write Same");
m_CommandSelectionCtrl.AddString("DSP Write Sequential");
m_CommandSelectionCtrl.AddString("DSP Read  Sequential");
m_CommandSelectionCtrl.AddString("DSP Download Program");
m_CommandSelectionCtrl.AddString("DSP Write/Read Test");
m_CommandSelectionCtrl.AddString("Flash Lock");
m_CommandSelectionCtrl.AddString("Flash Unlock");
m_CommandSelectionCtrl.AddString("Flash Clear");
m_CommandSelectionCtrl.AddString("Flash Write Same");
m_CommandSelectionCtrl.AddString("Flash Read  Sequential");
m_CommandSelectionCtrl.AddString("Fpga Ram Write");
m_CommandSelectionCtrl.AddString("Sdram Clear");
m_CommandSelectionCtrl.AddString("Sdram Write Same");
m_CommandSelectionCtrl.AddString("Sdram Write Sequential");
m_CommandSelectionCtrl.AddString("Sdram Read  Sequential");
m_CommandSelectionCtrl.AddString("Sdram Write/Read Test");
m_CommandSelectionCtrl.AddString("Sram Clear");
m_CommandSelectionCtrl.AddString("Sram Write Same");
m_CommandSelectionCtrl.AddString("Sram Write Sequential");
m_CommandSelectionCtrl.AddString("Sram Read  Sequential");
m_CommandSelectionCtrl.AddString("Sram Write/Read Test");
m_CommandSelectionCtrl.AddString("DiagBuff Write Same");
m_CommandSelectionCtrl.AddString("DiagBuff Write Sequential");
m_CommandSelectionCtrl.AddString("DiagBuff Read  Sequential");
m_CommandSelectionCtrl.AddString("DSP's Test Procedures");
m_CommandSelectionCtrl.AddString("MMT DSP Write Same");
m_CommandSelectionCtrl.AddString("MMT DSP Write Sequential");
m_CommandSelectionCtrl.AddString("MMT DSP Read Sequential");
m_CommandSelectionCtrl.AddString("MMT DSP Download Program");
m_CommandSelectionCtrl.AddString("MMT DSP Write/Read Test");
m_CommandSelectionCtrl.AddString("FL DSP Write/Read Test");
m_CommandSelectionCtrl.AddString("Relais board setting");
m_CommandSelectionCtrl.AddString("Read Throughput Test");

UpdateData(FALSE);

CmdSel2View[ 0]=SETBCUIP_VIEW;
CmdSel2View[ 1]=RESET_VIEW;
CmdSel2View[ 2]=DIAGNOSTIC_VIEW;
CmdSel2View[ 3]=WRSAME_DSP_VIEW;
CmdSel2View[ 4]=WRSEQ_DSP_VIEW;
CmdSel2View[ 5]=READ_DSP_VIEW;
CmdSel2View[ 6]=DLDSP_PRG_VIEW;
CmdSel2View[ 7]=WRRDDSPTEST_VIEW;
CmdSel2View[ 8]=LOCK_FLASH_VIEW;
CmdSel2View[ 9]=UNLOCK_FLASH_VIEW;
CmdSel2View[10]=CLEAR_FLASH_VIEW;
CmdSel2View[11]=WRITE_FLASH_VIEW;
CmdSel2View[12]=READ_FLASH_VIEW;
CmdSel2View[13]=WRITE_FPGA_RAM_VIEW;
CmdSel2View[14]=CLEAR_SDRAM_VIEW;
CmdSel2View[15]=WRSAME_SDRAM_VIEW;
CmdSel2View[16]=WRSEQ_SDRAM_VIEW;
CmdSel2View[17]=READ_SDRAM_VIEW;
CmdSel2View[18]=WRRDSDRAMTEST_VIEW;
CmdSel2View[19]=CLEAR_SRAM_VIEW;
CmdSel2View[20]=WRSAME_SRAM_VIEW;
CmdSel2View[21]=WRSEQ_SRAM_VIEW;
CmdSel2View[22]=READ_SRAM_VIEW;
CmdSel2View[23]=WRRDSRAMTEST_VIEW;
CmdSel2View[24]=WRSAME_DIAGBUFF_VIEW;
CmdSel2View[25]=WRSEQ_DIAGBUFF_VIEW;
CmdSel2View[26]=READ_DIAGBUFF_VIEW;
CmdSel2View[27]=TESTPROCEDURES_VIEW;
CmdSel2View[28]=WRSAME_MMT_DSP_VIEW;
CmdSel2View[29]=WRSEQ_MMT_DSP_VIEW;
CmdSel2View[30]=READ_MMT_DSP_VIEW;
CmdSel2View[31]=DLMMTDSP_PRG_VIEW;
CmdSel2View[32]=WRRDMMTDSPTEST_VIEW;
CmdSel2View[33]=WRRDFLDSPTEST_VIEW;
CmdSel2View[34]=RELAISBOARD_VIEW;
CmdSel2View[35]=THROUGHPUTTEST_VIEW;

activeView=CmdSel2View[m_CommandSelection];
input_forms[activeView]->ShowWindow(SW_SHOW);

if      (activeView==NULL_VIEW || activeView==SETBCUIP_VIEW)
	SendMessage(WM_UPDATE_BUTTONS,0,0);
else if (activeView==DIAGNOSTIC_VIEW || 
         activeView==WRRDDSPTEST_VIEW || 
         activeView==WRRDSDRAMTEST_VIEW || 
			activeView==WRRDSRAMTEST_VIEW || 
			activeView==TESTPROCEDURES_VIEW ||
			activeView==WRRDMMTDSPTEST_VIEW ||
			activeView==WRRDFLDSPTEST_VIEW ||
			activeView==THROUGHPUTTEST_VIEW)
	SendMessage(WM_UPDATE_BUTTONS,2,0);
else
	SendMessage(WM_UPDATE_BUTTONS,1,0);
SendMessage(WM_UPDATE_BUTTONS,11,0);

// faccio partire il thread per la scrittura/lettura dei buffer
SendExitFromThread();
if (threadParam) free (threadParam),threadParam=NULL;
threadParam=(DWORD *)malloc(sizeof (DWORD*)*8);
threadParam[ 0]=(DWORD)this;
threadParam[ 1]=(DWORD)&pMainFrame->socket;
threadParam[ 2]=(DWORD)m_SendExitHandle;
threadParam[ 3]=(DWORD)m_SendPackHandle;
threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
threadParam[ 5]=(DWORD)&buffer;
threadParam[ 6]=(DWORD)&bufferLen;
threadParam[ 7]=(DWORD)&numPackets;
pThread=AfxBeginThread(SendThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,0,0,NULL);
DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hSendThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);

MoveWindow(0,0,0,0,FALSE);
GetParentFrame()->RecalcLayout();
ResizeParentToFit();

}

/////////////////////////////////////////////////////////////////////////////
// CInputArea diagnostics

#ifdef _DEBUG
void CInputArea::AssertValid() const
{
	CFormView::AssertValid();
}

void CInputArea::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CInputArea message handlers

void CInputArea::OnSelChangeCmdSelection() 
{
SIZE size;
CRect rect;
UpdateData(TRUE);

input_forms[activeView]->ShowWindow(SW_HIDE);

if (input_forms[CmdSel2View[m_CommandSelection]])
	activeView=CmdSel2View[m_CommandSelection];
else
	activeView=NULL_VIEW;

input_forms[activeView]->ShowWindow(SW_SHOW);
GetClientRect(&rect);
size.cx=rect.Width();
size.cy=rect.Height();
SetScrollSizes(MM_TEXT,size);
input_forms[activeView]->MoveWindow(0,TOP_BORDER,size.cx,size.cy-TOP_BORDER,TRUE);

if      (activeView==NULL_VIEW || activeView==SETBCUIP_VIEW)
	SendMessage(WM_UPDATE_BUTTONS,0,0);
else if (activeView==DIAGNOSTIC_VIEW || 
			activeView==WRRDDSPTEST_VIEW || 
         activeView==WRRDSDRAMTEST_VIEW || 
			activeView==WRRDSRAMTEST_VIEW || 
			activeView==TESTPROCEDURES_VIEW ||
			activeView==WRRDMMTDSPTEST_VIEW ||
			activeView==WRRDFLDSPTEST_VIEW ||
			activeView==THROUGHPUTTEST_VIEW)
	SendMessage(WM_UPDATE_BUTTONS,2,0);
else
	SendMessage(WM_UPDATE_BUTTONS,1,0);

}

BOOL CInputArea::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
RECT rect1;

if (!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
	return (FALSE);

m_orig_size.cx=rect.right-rect.left;
m_orig_size.cy=rect.bottom-rect.top;

rect1=rect;
rect1.top+=TOP_BORDER;
rect1.bottom+=TOP_BORDER;

input_forms[NULL_VIEW]=new(CNull_View);
((CNull_View *)input_forms[NULL_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[SETBCUIP_VIEW]=new(CSetBCUIP_View);
((CSetBCUIP_View *)input_forms[SETBCUIP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[RESET_VIEW]=new(CReset_View);
((CReset_View *)input_forms[RESET_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[DIAGNOSTIC_VIEW]=new(CDiagnostic_View);
((CDiagnostic_View *)input_forms[DIAGNOSTIC_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRSAME_DSP_VIEW]=new(CWriteDsp_View);
((CWriteDsp_View *)input_forms[WRSAME_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteDsp_View *)input_forms[WRSAME_DSP_VIEW])->m_wrsame=TRUE;
input_forms[WRSEQ_DSP_VIEW]=new(CWriteDsp_View);
((CWriteDsp_View *)input_forms[WRSEQ_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteDsp_View *)input_forms[WRSEQ_DSP_VIEW])->m_wrsame=FALSE;
input_forms[READ_DSP_VIEW]=new(CReadDsp_View);
((CReadDsp_View *)input_forms[READ_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[DLDSP_PRG_VIEW]=new(CDLDspPrg_View);
((CDLDspPrg_View *)input_forms[DLDSP_PRG_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRRDDSPTEST_VIEW]=new(CWrRdDspTest_View);
((CWrRdDspTest_View *)input_forms[WRRDDSPTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[LOCK_FLASH_VIEW]=new(CLockFlash_View);
((CLockFlash_View *)input_forms[LOCK_FLASH_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[UNLOCK_FLASH_VIEW]=new(CUnlockFlash_View);
((CUnlockFlash_View *)input_forms[UNLOCK_FLASH_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[CLEAR_FLASH_VIEW]=new(CClearFlash_View);
((CClearFlash_View *)input_forms[CLEAR_FLASH_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRITE_FLASH_VIEW]=new(CWriteFlash_View);
((CWriteFlash_View *)input_forms[WRITE_FLASH_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[READ_FLASH_VIEW]=new(CReadFlash_View);
((CReadFlash_View *)input_forms[READ_FLASH_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRITE_FPGA_RAM_VIEW]=new(CWriteFpgaRam_View);
((CWriteFpgaRam_View *)input_forms[WRITE_FPGA_RAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[CLEAR_SDRAM_VIEW]=new(CClearSdram_View);
((CClearSdram_View *)input_forms[CLEAR_SDRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRSAME_SDRAM_VIEW]=new(CWriteSdram_View);
((CWriteSdram_View *)input_forms[WRSAME_SDRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteSdram_View *)input_forms[WRSAME_SDRAM_VIEW])->m_wrsame=TRUE;
input_forms[WRSEQ_SDRAM_VIEW]=new(CWriteSdram_View);
((CWriteSdram_View *)input_forms[WRSEQ_SDRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteSdram_View *)input_forms[WRSEQ_SDRAM_VIEW])->m_wrsame=FALSE;
input_forms[READ_SDRAM_VIEW]=new(CReadSdram_View);
((CReadSdram_View *)input_forms[READ_SDRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRSAME_DIAGBUFF_VIEW]=new(CWriteDiagBuff_View);
((CWriteDiagBuff_View *)input_forms[WRSAME_DIAGBUFF_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteDiagBuff_View *)input_forms[WRSAME_DIAGBUFF_VIEW])->m_wrsame=TRUE;
input_forms[WRSEQ_DIAGBUFF_VIEW]=new(CWriteDiagBuff_View);
((CWriteDiagBuff_View *)input_forms[WRSEQ_DIAGBUFF_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteDiagBuff_View *)input_forms[WRSEQ_DIAGBUFF_VIEW])->m_wrsame=FALSE;
input_forms[READ_DIAGBUFF_VIEW]=new(CReadDiagBuff_View);
((CReadDiagBuff_View *)input_forms[READ_DIAGBUFF_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRRDSDRAMTEST_VIEW]=new(CWrRdSdramTest_View);
((CWrRdSdramTest_View *)input_forms[WRRDSDRAMTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[CLEAR_SRAM_VIEW]=new(CClearSram_View);
((CClearSram_View *)input_forms[CLEAR_SRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRSAME_SRAM_VIEW]=new(CWriteSram_View);
((CWriteSram_View *)input_forms[WRSAME_SRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteSram_View *)input_forms[WRSAME_SRAM_VIEW])->m_wrsame=TRUE;
input_forms[WRSEQ_SRAM_VIEW]=new(CWriteSram_View);
((CWriteSram_View *)input_forms[WRSEQ_SRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteSram_View *)input_forms[WRSEQ_SRAM_VIEW])->m_wrsame=FALSE;
input_forms[READ_SRAM_VIEW]=new(CReadSram_View);
((CReadSram_View *)input_forms[READ_SRAM_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRRDSRAMTEST_VIEW]=new(CWrRdSramTest_View);
((CWrRdSramTest_View *)input_forms[WRRDSRAMTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[TESTPROCEDURES_VIEW]=new(CTestProcedures_View);
((CTestProcedures_View *)input_forms[TESTPROCEDURES_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRSAME_MMT_DSP_VIEW]=new(CWriteMMTDsp_View);
((CWriteMMTDsp_View *)input_forms[WRSAME_MMT_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteMMTDsp_View *)input_forms[WRSAME_MMT_DSP_VIEW])->m_wrsame=TRUE;
input_forms[WRSEQ_MMT_DSP_VIEW]=new(CWriteMMTDsp_View);
((CWriteMMTDsp_View *)input_forms[WRSEQ_MMT_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
((CWriteMMTDsp_View *)input_forms[WRSEQ_MMT_DSP_VIEW])->m_wrsame=FALSE;
input_forms[READ_MMT_DSP_VIEW]=new(CReadMMTDsp_View);
((CReadMMTDsp_View *)input_forms[READ_MMT_DSP_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[DLMMTDSP_PRG_VIEW]=new(CDLMMTDspPrg_View);
((CDLMMTDspPrg_View *)input_forms[DLMMTDSP_PRG_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRRDMMTDSPTEST_VIEW]=new(CWrRdMMTDspTest_View);
((CWrRdMMTDspTest_View *)input_forms[WRRDMMTDSPTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[WRRDFLDSPTEST_VIEW]=new(CWrRdFLDspTest_View);
((CWrRdFLDspTest_View *)input_forms[WRRDFLDSPTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[RELAISBOARD_VIEW]=new(CRelaisBoard_View);
((CRelaisBoard_View *)input_forms[RELAISBOARD_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);
input_forms[THROUGHPUTTEST_VIEW]=new(CThroughputTest_View);
((CThroughputTest_View *)input_forms[THROUGHPUTTEST_VIEW])->Create(NULL,NULL,WS_CHILD,rect1,this,0,pContext);

return TRUE;
}

void CInputArea::OnCmdSend() 
{
CWinThread  *pThread;
FILE        *fd=NULL;
CMainFrame  *pMainFrame=(CMainFrame *)(GetParent()->GetParent());
CString     str;

// chiudo il file da prima se e' ancora aperto
if (pMainFrame->socket.m_fd)
	{
	fclose(pMainFrame->socket.m_fd);
	pMainFrame->socket.m_fd=NULL;
	}

m_SendCmd.GetWindowText(str);
// creo il pacchetto ethernet
switch (activeView)
	{
	case NULL_VIEW:
	break;
	case RESET_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReset_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case DIAGNOSTIC_VIEW:
		if (str=="Start")
			{
			// faccio partire il thread per il refresh diagnostico
			DiagnosticExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,3,0);
			if (threadParam) free (threadParam),threadParam=NULL;
			threadParam=(DWORD *)malloc(sizeof(DWORD*)*5);
			threadParam[ 0]=(DWORD)this;
			threadParam[ 1]=(DWORD)&pMainFrame->socket;
			threadParam[ 2]=(DWORD)input_forms[activeView];
			threadParam[ 3]=(DWORD)m_DiagnosticExitHandle;
			threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
			pThread=AfxBeginThread(DiagnosticThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,0,0,NULL);
			DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hDiagnosticThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
			}
		else if (str=="Stop")
			{
			DiagnosticExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case WRSAME_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSEQ_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			if (((CReadDsp_View*)input_forms[activeView])->m_ReplyToFile)
				pMainFrame->socket.m_fd=fopen(((CReadDsp_View*)input_forms[activeView])->m_FileName,"wt");
			}
		SetEvent(m_SendPackHandle);
	break;
	case DLDSP_PRG_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CDLDspPrg_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRRDDSPTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CWrRdDspTest_View*)input_forms[activeView])->UpdateData(TRUE);
/*			if (((CWrRdDspTest_View*)input_forms[activeView])->m_FirstDSP!=0xFF)
				AfxMessageBox("m_FirstDPS value not valid (must be 0xFF)!");
			else if (((CWrRdDspTest_View*)input_forms[activeView])->m_LastDSP!=0xFF)
				AfxMessageBox("m_LastDPS value not valid (must be 0xFF)!");
			else*/ if (((CWrRdDspTest_View*)input_forms[activeView])->m_NumIter==0)
				AfxMessageBox("Invalid number of iteraction");
			else if (((CWrRdDspTest_View*)input_forms[activeView])->m_Size<=0 || ((CWrRdDspTest_View*)input_forms[activeView])->m_Size>MAX_MGP_DATA_SIZE/4)
				AfxMessageBox("Invalid data buffer size");
			else
				{
				// faccio partire il thread per la scrittura/lettura dei buffer
				PollingExitFromThread();
				SendMessage(WM_UPDATE_BUTTONS,3,0);
				if (threadParam) free (threadParam),threadParam=NULL;
				threadParam=(DWORD *)malloc(sizeof(DWORD*)*12);
				threadParam[ 0]=(DWORD)this;
				threadParam[ 1]=(DWORD)&pMainFrame->socket;
				threadParam[ 2]=(DWORD)input_forms[activeView];
				threadParam[ 3]=(DWORD)m_PollingExitHandle;
				threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
				threadParam[ 5]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_FirstDSP;
				threadParam[ 6]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_LastDSP;
				threadParam[ 7]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_NumIter;
				threadParam[ 8]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_Size;
				threadParam[ 9]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_StartAddress;
				threadParam[10]=(DWORD)((CWrRdDspTest_View*)input_forms[activeView])->m_FixedBuffer;
				threadParam[11]=(DWORD)0;
				pThread=AfxBeginThread(PollingThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,268435456,0,NULL);
				DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
				}
			}
		else if (str=="Stop")
			{
			PollingExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case LOCK_FLASH_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CLockFlash_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case UNLOCK_FLASH_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CUnlockFlash_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case CLEAR_FLASH_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CClearFlash_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRITE_FLASH_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteFlash_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_FLASH_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadFlash_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			if (((CReadFlash_View*)input_forms[activeView])->m_ReplyToFile)
				pMainFrame->socket.m_fd=fopen(((CReadFlash_View*)input_forms[activeView])->m_FileName,"wb");
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRITE_FPGA_RAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteFpgaRam_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case CLEAR_SDRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CClearSdram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSAME_SDRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteSdram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSEQ_SDRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteSdram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_SDRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadSdram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			if (((CReadSdram_View*)input_forms[activeView])->m_ReplyToFile)
				pMainFrame->socket.m_fd=fopen(((CReadSdram_View*)input_forms[activeView])->m_FileName,"wt");
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSAME_DIAGBUFF_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteDiagBuff_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSEQ_DIAGBUFF_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteDiagBuff_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_DIAGBUFF_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadDiagBuff_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRRDSDRAMTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CWrRdSdramTest_View*)input_forms[activeView])->UpdateData(TRUE);
/*			if (((CWrRdSdramTest_View*)input_forms[activeView])->m_FirstDSP!=0xFF)
				AfxMessageBox("m_FirstDPS value not valid (must be 0xFF)!");
			else if (((CWrRdSdramTest_View*)input_forms[activeView])->m_LastDSP!=0xFF)
				AfxMessageBox("m_LastDPS value not valid (must be 0xFF)!");
			else*/ if (((CWrRdSdramTest_View*)input_forms[activeView])->m_NumIter==0)
				AfxMessageBox("Invalid number of iteraction");
			else if (((CWrRdSdramTest_View*)input_forms[activeView])->m_Size<=0 || ((CWrRdSdramTest_View*)input_forms[activeView])->m_Size>MAX_MGP_DATA_SIZE/4)
				AfxMessageBox("Invalid data buffer size");
			else
				{
				// faccio partire il thread per la scrittura/lettura dei buffer
				PollingExitFromThread();
				SendMessage(WM_UPDATE_BUTTONS,3,0);
				if (threadParam) free (threadParam),threadParam=NULL;
				threadParam=(DWORD *)malloc(sizeof(DWORD*)*12);
				threadParam[ 0]=(DWORD)this;
				threadParam[ 1]=(DWORD)&pMainFrame->socket;
				threadParam[ 2]=(DWORD)input_forms[activeView];
				threadParam[ 3]=(DWORD)m_PollingExitHandle;
				threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
				threadParam[ 5]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_FirstDSP;
				threadParam[ 6]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_LastDSP;
				threadParam[ 7]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_NumIter;
				threadParam[ 8]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_Size;
				threadParam[ 9]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_StartAddress;
				threadParam[10]=(DWORD)((CWrRdSdramTest_View*)input_forms[activeView])->m_FixedBuffer;
				threadParam[11]=(DWORD)1;
				pThread=AfxBeginThread(PollingThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,268435456,0,NULL);
				DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
				}
			}
		else if (str=="Stop")
			{
			PollingExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case CLEAR_SRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CClearSram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSAME_SRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteSram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSEQ_SRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteSram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_SRAM_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadSram_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRRDSRAMTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CWrRdSramTest_View*)input_forms[activeView])->UpdateData(TRUE);
			if (((CWrRdSramTest_View*)input_forms[activeView])->m_NumIter==0)
				AfxMessageBox("Invalid number of iteraction");
			else if (((CWrRdSramTest_View*)input_forms[activeView])->m_Size<=0 || ((CWrRdSramTest_View*)input_forms[activeView])->m_Size>MAX_MGP_DATA_SIZE/4)
				AfxMessageBox("Invalid data buffer size");
			else
				{
				// faccio partire il thread per la scrittura/lettura dei buffer
				PollingExitFromThread();
				SendMessage(WM_UPDATE_BUTTONS,3,0);
				if (threadParam) free (threadParam),threadParam=NULL;
				threadParam=(DWORD *)malloc(sizeof(DWORD*)*12);
				threadParam[ 0]=(DWORD)this;
				threadParam[ 1]=(DWORD)&pMainFrame->socket;
				threadParam[ 2]=(DWORD)input_forms[activeView];
				threadParam[ 3]=(DWORD)m_PollingExitHandle;
				threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
				threadParam[ 5]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_FirstDSP;
				threadParam[ 6]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_LastDSP;
				threadParam[ 7]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_NumIter;
				threadParam[ 8]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_Size;
				threadParam[ 9]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_StartAddress;
				threadParam[10]=(DWORD)((CWrRdSramTest_View*)input_forms[activeView])->m_FixedBuffer;
				threadParam[11]=(DWORD)2;
				pThread=AfxBeginThread(PollingThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,268435456,0,NULL);
				DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
				}
			}
		else if (str=="Stop")
			{
			PollingExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case TESTPROCEDURES_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CTestProcedures_View *)input_forms[activeView])->UpdateData(TRUE);
			// faccio partire il thread per la scrittura/lettura dei buffer
			TestProcExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,3,0);
			if (threadParam) free (threadParam),threadParam=NULL;
			threadParam=(DWORD *)malloc(sizeof(DWORD*)*8);
			threadParam[ 0]=(DWORD)this;
			threadParam[ 1]=(DWORD)&pMainFrame->socket;
			threadParam[ 2]=(DWORD)input_forms[activeView];
			threadParam[ 3]=(DWORD)m_TestProcExitHandle;
			threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
			threadParam[ 5]=(DWORD)((CTestProcedures_View *)input_forms[activeView])->m_FirstDSP;
			threadParam[ 6]=(DWORD)((CTestProcedures_View *)input_forms[activeView])->m_SaveOnFile;
			threadParam[ 7]=(DWORD)((CTestProcedures_View *)input_forms[activeView])->m_Step;
			pThread=AfxBeginThread(TestProcThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,0,0,NULL);
			DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hTestProcThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
			}
		else if (str=="Stop")
			{
			TestProcExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case WRSAME_MMT_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteMMTDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRSEQ_MMT_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CWriteMMTDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case READ_MMT_DSP_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CReadMMTDsp_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			if (((CReadMMTDsp_View*)input_forms[activeView])->m_ReplyToFile)
				pMainFrame->socket.m_fd=fopen(((CReadMMTDsp_View*)input_forms[activeView])->m_FileName,"wt");
			}
		SetEvent(m_SendPackHandle);
	break;
	case DLMMTDSP_PRG_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CDLMMTDspPrg_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case WRRDMMTDSPTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CWrRdMMTDspTest_View*)input_forms[activeView])->UpdateData(TRUE);
			if (((CWrRdMMTDspTest_View*)input_forms[activeView])->m_NumIter==0)
				AfxMessageBox("Invalid number of iteraction");
			else if (((CWrRdMMTDspTest_View*)input_forms[activeView])->m_Size<=0)
				AfxMessageBox("Invalid data buffer size");
			else if (((CWrRdMMTDspTest_View*)input_forms[activeView])->m_PmDm && ((CWrRdMMTDspTest_View*)input_forms[activeView])->m_Size>MAX_MGP_DATA_SIZE/4)
				AfxMessageBox("Invalid data buffer size");
			else if (!((CWrRdMMTDspTest_View*)input_forms[activeView])->m_PmDm && ((CWrRdMMTDspTest_View*)input_forms[activeView])->m_Size>MAX_MGP_DATA_SIZE/2)
				AfxMessageBox("Invalid data buffer size");
			else if (!((CWrRdMMTDspTest_View*)input_forms[activeView])->m_PmDm && ((CWrRdMMTDspTest_View*)input_forms[activeView])->m_Size&1)
				AfxMessageBox("Invalid data buffer size (must be even)");
			else
				{
				// faccio partire il thread per la scrittura/lettura dei buffer
				PollingExitFromThread();
				SendMessage(WM_UPDATE_BUTTONS,3,0);
				if (threadParam) free (threadParam),threadParam=NULL;
				threadParam=(DWORD *)malloc(sizeof(DWORD*)*12);
				threadParam[ 0]=(DWORD)this;
				threadParam[ 1]=(DWORD)&pMainFrame->socket;
				threadParam[ 2]=(DWORD)input_forms[activeView];
				threadParam[ 3]=(DWORD)m_PollingExitHandle;
				threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
				threadParam[ 5]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_FirstDSP;
				threadParam[ 6]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_LastDSP;
				threadParam[ 7]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_NumIter;
				threadParam[ 8]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_Size;
				threadParam[ 9]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_StartAddress;
				threadParam[10]=(DWORD)((CWrRdMMTDspTest_View*)input_forms[activeView])->m_FixedBuffer;
				if (((CWrRdMMTDspTest_View*)input_forms[activeView])->m_PmDm)
					threadParam[11]=(DWORD)4;
				else
					threadParam[11]=(DWORD)3;
				pThread=AfxBeginThread(PollingThread,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,268435456,0,NULL);
				DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
				}
			}
		else if (str=="Stop")
			{
			PollingExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case WRRDFLDSPTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CWrRdFLDspTest_View*)input_forms[activeView])->UpdateData(TRUE);
			// faccio partire il thread per la scrittura/lettura dei buffer
			Polling1ExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,3,0);
			if (threadParam) free (threadParam),threadParam=NULL;
			threadParam=(DWORD *)malloc(sizeof(DWORD*)*5);
			threadParam[ 0]=(DWORD)this;
			threadParam[ 1]=(DWORD)&pMainFrame->socket;
			threadParam[ 2]=(DWORD)input_forms[activeView];
			threadParam[ 3]=(DWORD)m_Polling1ExitHandle;
			threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
			pThread=AfxBeginThread(PollingThread1,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,0,0,NULL);
			DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread1,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
			}
		else if (str=="Stop")
			{
			Polling1ExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	case RELAISBOARD_VIEW:
		if (str=="Send")
			{
			// assegno un cmd identifier al pacchetto (passandolo attraverso bufferLen)
			bufferLen=(int *)(&commandId);
			numPackets=((CRelaisBoard_View*)input_forms[activeView])->CreateBuffer(&bufferLen,&buffer);
			}
		SetEvent(m_SendPackHandle);
	break;
	case THROUGHPUTTEST_VIEW:
		if (str=="Start")
			{
			// verifica dati di input
			((CThroughputTest_View*)input_forms[activeView])->UpdateData(TRUE);
			if (((CThroughputTest_View*)input_forms[activeView])->m_NumIter==0)
				AfxMessageBox("Invalid number of iteraction");
			else if (((CThroughputTest_View*)input_forms[activeView])->m_Size<=0)
				AfxMessageBox("Invalid data buffer size");
			else
				{
				// faccio partire il thread per la scrittura/lettura dei buffer
				Polling2ExitFromThread();
				SendMessage(WM_UPDATE_BUTTONS,3,0);
				if (threadParam) free (threadParam),threadParam=NULL;
				threadParam=(DWORD *)malloc(sizeof(DWORD*)*11);
				threadParam[ 0]=(DWORD)this;
				threadParam[ 1]=(DWORD)&pMainFrame->socket;
				threadParam[ 2]=(DWORD)input_forms[activeView];
				threadParam[ 3]=(DWORD)m_Polling2ExitHandle;
				threadParam[ 4]=(DWORD)pMainFrame->socket.m_CallbackHandle;
				threadParam[ 5]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_FirstDSP;
				threadParam[ 6]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_LastDSP;
				threadParam[ 7]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_NumIter;
				threadParam[ 8]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_Size;
				threadParam[ 9]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_StartAddress;
				threadParam[10]=(DWORD)((CThroughputTest_View*)input_forms[activeView])->m_DeviceSel;
				pThread=AfxBeginThread(PollingThread2,(LPVOID)&threadParam,THREAD_PRIORITY_NORMAL,268435456,0,NULL);
				DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hPollingThread2,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);
				}
			}
		else if (str=="Stop")
			{
			Polling2ExitFromThread();
			SendMessage(WM_UPDATE_BUTTONS,2,0);
			}
	break;
	default:
		bufferLen=0;
		numPackets=0;
	break;
	}
}

void CInputArea::OnConnect()
{
CMainFrame *pMainFrame=(CMainFrame *)(GetParent()->GetParent());

if (pMainFrame->socket.UDPPort==0xFFFF)
	{
	if (pMainFrame->socketAddr.IP[0]=='\0')
		{
		AfxMessageBox("Error: remote IP not defined");
		return;
		}
	if (pMainFrame->socketAddr.port==0)
		{
		AfxMessageBox("Error: UDP port not defined");
		return;
		}
	pMainFrame->socket.ConnectAdapter(&pMainFrame->socketAddr);
	}
else
	pMainFrame->socket.DisconnectAdapter();
}

LRESULT CInputArea::OnUpdateButtons(WPARAM type,LPARAM dummy2)
{
CMainFrame *pMainFrame=(CMainFrame *)(GetParent()->GetParent());

// aggiorno il bottone di send/start-stop
if      (type==0)
	{
	m_SendCmd.EnableWindow(FALSE);
	}
else if (type==1)
	{
	if (pMainFrame->socket.Adapter.OpenInstance)
		m_SendCmd.EnableWindow(TRUE);
	else
		m_SendCmd.EnableWindow(FALSE);
	m_SendCmd.SetWindowText("Send");
	}
else if (type==2)
	{
	if (pMainFrame->socket.Adapter.OpenInstance)
		m_SendCmd.EnableWindow(TRUE);
	else
		m_SendCmd.EnableWindow(FALSE);
	m_SendCmd.SetWindowText("Start");
	}
else if (type==3)
	{
	if (pMainFrame->socket.Adapter.OpenInstance)
		m_SendCmd.EnableWindow(TRUE);
	else
		m_SendCmd.EnableWindow(FALSE);
	m_SendCmd.SetWindowText("Stop");
	}
else if (type==10)
	{
	m_SendCmd.EnableWindow(TRUE);
	m_Connect.SetWindowText("Disconnect");
	}
else if (type==11)
	{
	m_SendCmd.EnableWindow(FALSE);
	m_Connect.SetWindowText("Connect");
	}

return (0);
}

void CInputArea::PollingExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hPollingThread)
	{
	if (m_PollingExitHandle)	
		{
		SetEvent(m_PollingExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hPollingThread,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("PollingThread (code %08x) exited - counter = %d\n",hPollingThread,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hPollingThread,exitCode);
			GetExitCodeThread(hPollingThread,&exitCode);
			}
		hPollingThread=NULL;
		}
	else
		InternalError(28);
	}
else
	TRACE ("InputArea PollingThread undefined\n");
}

void CInputArea::Polling1ExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hPollingThread1)
	{
	if (m_Polling1ExitHandle)	
		{
		SetEvent(m_Polling1ExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hPollingThread1,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("PollingThread1 (code %08x) exited - counter = %d\n",hPollingThread1,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hPollingThread1,exitCode);
			GetExitCodeThread(hPollingThread1,&exitCode);
			}
		hPollingThread1=NULL;
		}
	else
		InternalError(32);
	}
else
	TRACE ("InputArea PollingThread1 undefined\n");
}

void CInputArea::Polling2ExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hPollingThread2)
	{
	if (m_Polling2ExitHandle)	
		{
		SetEvent(m_Polling2ExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hPollingThread2,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("PollingThread2 (code %08x) exited - counter = %d\n",hPollingThread2,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hPollingThread2,exitCode);
			GetExitCodeThread(hPollingThread2,&exitCode);
			}
		hPollingThread2=NULL;
		}
	else
		InternalError(32);
	}
else
	TRACE ("InputArea PollingThread2 undefined\n");
}

void CInputArea::SendExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hSendThread)
	{
	if (m_SendExitHandle)	
		{
		SetEvent(m_SendExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hSendThread,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("SendThread (code %08x) exited - counter = %d\n",hSendThread,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hSendThread,exitCode);
			GetExitCodeThread(hSendThread,&exitCode);
			}
		hSendThread=NULL;
		}
	else
		InternalError(29);
	}
else
	TRACE ("InputArea SendThread undefined\n");
}

void CInputArea::DiagnosticExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hDiagnosticThread)
	{
	if (m_DiagnosticExitHandle)	
		{
		SetEvent(m_DiagnosticExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hDiagnosticThread,&exitCode);
			ContinueMessages();
			Sleep(10);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("DiagnosticThread (code %08x) exited - counter = %d\n",hDiagnosticThread,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hDiagnosticThread,exitCode);
			GetExitCodeThread(hDiagnosticThread,&exitCode);
			}
		hDiagnosticThread=NULL;
		}
	else
		InternalError(30);
	}
else
	TRACE ("InputArea DiagnosticThread undefined\n");
}

void CInputArea::TestProcExitFromThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hTestProcThread)
	{
	if (m_TestProcExitHandle)	
		{
		SetEvent(m_TestProcExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hTestProcThread,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("TestProcThread (code %08x) exited - counter = %d\n",hTestProcThread,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hTestProcThread,exitCode);
			GetExitCodeThread(hTestProcThread,&exitCode);
			}
		hTestProcThread=NULL;
		}
	else
		InternalError(31);
	}
else
	TRACE ("InputArea TestProcThread undefined\n");
}

void CInputArea::OnDestroy() 
{
DiagnosticExitFromThread();
SendExitFromThread();
PollingExitFromThread();
Polling1ExitFromThread();
Polling2ExitFromThread();
TestProcExitFromThread();

CFormView::OnDestroy();
}

void CInputArea::OnSize(UINT nType, int cx, int cy) 
{
SIZE size;
CFormView::OnSize(nType, cx, cy);

if (activeView!=-1 && ::IsWindow(input_forms[activeView]->m_hWnd))
	{
	size.cx=cx;
	size.cy=cy;
	SetScrollSizes(MM_TEXT,size);
	input_forms[activeView]->MoveWindow(0,TOP_BORDER,cx,cy-TOP_BORDER,TRUE);
	}
}
