// LockFlash_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "LockFlash_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLockFlash_View

IMPLEMENT_DYNCREATE(CLockFlash_View, CFormView)

CLockFlash_View::CLockFlash_View()
	: CFormView(CLockFlash_View::IDD)
{
	//{{AFX_DATA_INIT(CLockFlash_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_Block = 0;
	m_WantReply = TRUE;
	//}}AFX_DATA_INIT
}

CLockFlash_View::~CLockFlash_View()
{
}

void CLockFlash_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLockFlash_View)
	DDX_Control(pDX, IDC_BLOCK, m_BlockCtrl);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_CBIndex(pDX, IDC_BLOCK, m_Block);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLockFlash_View, CFormView)
	//{{AFX_MSG_MAP(CLockFlash_View)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLockFlash_View diagnostics

#ifdef _DEBUG
void CLockFlash_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CLockFlash_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLockFlash_View message handlers

BOOL CLockFlash_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CLockFlash_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);

m_BlockCtrl.AddString("Default Logic");
m_BlockCtrl.AddString("User Logic");
m_BlockCtrl.AddString("Default Program");
m_BlockCtrl.AddString("User Program");
m_BlockCtrl.AddString("Configuration Area");
m_BlockCtrl.AddString("Entire Flash");

m_BlockCtrl.SetCurSel(0);
}

DWORD CLockFlash_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;

(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*1);
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*1);
// alloco il (*buffer) a dimensione massima
(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[0],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[0];
pData=(uint32 *)((*buffer)[0]+MGP_HLEN);

tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_LOCK_FLASH;
tx_mgp->len=1;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;

if (m_Block==0)      // default logic
	{
	tx_mgp->saddr=DEFAULT_LOGIC_SADDR/4;
	pData[0]=DEFAULT_LOGIC_LEN/4;
	}
else if (m_Block==1) // user logic
	{
	tx_mgp->saddr=USER_LOGIC_SADDR/4;
	pData[0]=USER_LOGIC_LEN/4;
	}
else if (m_Block==2) // default program
	{
	tx_mgp->saddr=DEFAULT_PRG_SADDR/4;
	pData[0]=DEFAULT_PRG_LEN/4;
	}
else if (m_Block==3) // user program
	{
	tx_mgp->saddr=USER_PRG_SADDR/4;
	pData[0]=USER_PRG_LEN/4;
	}
else if (m_Block==4) // configuration area
	{
	tx_mgp->saddr=CONFIG_AREA_SADDR/4;
	pData[0]=CONFIG_AREA_LEN/4;
	}
else if (m_Block==5)
	{
	tx_mgp->saddr=0x00000000;
	pData[0]=-1;
	}

(*bufferLen)[0]=MGP_HLEN+tx_mgp->len*4;

return (1);
}
