// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "MainFrm.h"
#include "InputArea.h"
#include "OutputArea.h"
#include "SetIP_Dialog.h"
#include "udp.h"
#include "iphlpapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_REMOTEIP, OnRemoteIP)
	ON_UPDATE_COMMAND_UI(ID_REMOTEIP, OnUpdateRemoteIP)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_BUTTONS, OnUpdateButtons)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
m_bSplitterCreated=FALSE;
memset((void *)&socketAddr,0,sizeof(socketAddr));
strcpy(socketAddr.IP,"192.168.0.67");
//strcpy(socketAddr.IP,"192.168.0.50");
//strcpy(socketAddr.IP,"193.206.155.42");
socketAddr.port=10000;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
int             i;
ULONG		       ulOutBufLen;
IP_ADAPTER_INFO *pAdapterInfo;
IP_ADAPTER_INFO *pAdapter;
CRect           rect(0,0,0,0);
char            *pChar,*pChar1;
char            str[500];

if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
	return -1;

if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
	| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
	!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

if (!m_wndStatusBar.Create(this) ||
	!m_wndStatusBar.SetIndicators(indicators,
	  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

// TODO: Delete these three lines if you don't want the toolbar to
//  be dockable
m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
EnableDocking(CBRS_ALIGN_ANY);
DockControlBar(&m_wndToolBar);

if (!socket.Create(lpCreateStruct->lpszClass,lpCreateStruct->lpszName,lpCreateStruct->style,rect,this,0,0))
	{
	sprintf(str,"Error %d opening socket",GetLastError( ));
	AfxMessageBox(str);
	}

if (!socket.OpenAdapter())
	return FALSE;

// ricerca del MAC e IP della scheda
ulOutBufLen = 0;

GetAdaptersInfo( NULL, &ulOutBufLen);

pAdapterInfo = (IP_ADAPTER_INFO *) malloc( ulOutBufLen );

if (GetAdaptersInfo( pAdapterInfo, &ulOutBufLen) != ERROR_SUCCESS) 
	{
	free (pAdapterInfo);
	InternalError(200);
	}

pAdapter = pAdapterInfo;
do
	{
	if (!strcmp(pAdapter->Description,socket.AdaptersInfo.AdapterName[socket.Adapter.DeviceSelected]))
		break;
	pAdapter = pAdapter->Next;
	}
while (pAdapter);

if (!pAdapter)
	{
	free (pAdapterInfo);
	InternalError(201);
	}

memcpy(socket.local_eth_addr,pAdapter->Address,ETH_ALEN);
socket.local_ip_addr = 0;
strcpy(str,pAdapter->IpAddressList.IpAddress.String);
pChar = pChar1 = str;
for (i=0;i<4;i++)
	{
	while(*pChar!='.' && *pChar!='\0')
		pChar++;
	*(pChar++)='\0';
	socket.local_ip_addr += atoi(pChar1) * 1 << (i * 8);
	pChar1=pChar;
	}
TRACE("MAC Addr:    %02x:%02x:%02x:%02x:%02x:%02x\n",pAdapter->Address[0],pAdapter->Address[1],pAdapter->Address[2],pAdapter->Address[3],pAdapter->Address[4],pAdapter->Address[5]);
TRACE("IP  Address: %s\n", pAdapter->IpAddressList.IpAddress.String);

free(pAdapterInfo);

// assegno i pointer dei buffer di I/O
socket.pOutputSend=(void *)m_wndSubSplitter.GetPane(0,0);
socket.pOutputReceive=(void *)m_wndSubSplitter.GetPane(1,0);

return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
#define PANE1_YSIZE 300

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
RECT rect;
SIZE size;

GetClientRect(&rect);

// crea lo splitter della finestra
if (!m_wndSplitter.CreateStatic(this,2,1,
                                WS_CHILD|WS_VISIBLE,
                                AFX_IDW_PANE_FIRST))
	return (FALSE);

size.cx=rect.right;
size.cy=PANE1_YSIZE;
if (!m_wndSplitter.CreateView(0, 0, pContext->m_pNewViewClass, size, pContext ))
	return (FALSE);

// add the second splitter pane - which is a nested splitter with 2 rows
if (!m_wndSubSplitter.CreateStatic(&m_wndSplitter,2,1,
											  WS_CHILD | WS_VISIBLE | WS_BORDER,  // style, WS_BORDER is needed
											  m_wndSplitter.IdFromRowCol(1, 0)))
	return FALSE;

size.cx=rect.right;
size.cy=(rect.bottom-PANE1_YSIZE)/2;
if (!m_wndSubSplitter.CreateView(0, 0, RUNTIME_CLASS(COutputArea), size, pContext ))
	return (FALSE);
if (!m_wndSubSplitter.CreateView(1, 0, RUNTIME_CLASS(COutputArea), size, pContext ))
	return (FALSE);

m_bSplitterCreated=TRUE;
	
return (TRUE);
}

void CMainFrame::OnRemoteIP() 
{
CInputArea *pInputArea=(CInputArea *)m_wndSplitter.GetPane(0,0);
CSetIP_Dialog dlg;

strcpy(dlg.IP,socketAddr.IP);
dlg.port=socketAddr.port;
dlg.adapterName=socket.AdaptersInfo.AdapterName[socket.Adapter.DeviceSelected];

if (dlg.DoModal()==IDOK)
   {
   strcpy(socketAddr.IP,dlg.IP);
	socketAddr.port=dlg.port;
   }
}

void CMainFrame::OnUpdateRemoteIP(CCmdUI* pCmdUI) 
{
CInputArea *pInputArea=(CInputArea *)m_wndSplitter.GetPane(0,0);

if (socket.UDPPort!=0xFFFF)
	pCmdUI->Enable(FALSE);
else
	pCmdUI->Enable(TRUE);
}

LRESULT CMainFrame::OnUpdateButtons(WPARAM type,LPARAM dummy2)
{
::SendMessage(m_wndSplitter.GetPane(0,0)->m_hWnd,WM_UPDATE_BUTTONS,type,0);

return (0);
}
