// MyAsyncSocket.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "MyAsyncSocket.h"
#include "EthernetCardSelect.h"
#include "MainFrm.h"
#include "OutputArea.h"
#include "eth.h"
#include "arp.h"
#include "udp.h"
#include "iphlpapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char  Buffer[MAX_ADAPTERS * 512];

/////////////////////////////////////////////////////////////////////////////
// CMyAsyncSocket

UINT CMyAsyncSocket::ReceiverThread(LPVOID lpParams)
{
BYTE   m_FirstDSP,m_LastDSP;
uint32 *pData;
char   str[1000],str1[1000];
int    i,i1;
struct ethhdr *rx_eth;
//struct arphdr *rx_arp;
struct iphdr  *rx_ip;
struct udphdr *rx_udp;
struct mgphdr *rx_mgp;
HANDLE      hFile;
ULONG       PacketLength;
HGLOBAL     hPacket[2];
LPPACKET    lpPacket[2];
DWORD       **threadParam=(DWORD **)lpParams;
HANDLE      handles[3];
DWORD       rep;

CMyAsyncSocket    *pSocket       = (CMyAsyncSocket *)((*threadParam)[0]);
HANDLE            exit_handle    = (HANDLE)((*threadParam)[1]); // exit handle
READTHREAD        *pReadThread   = (READTHREAD *)((*threadParam)[2]);
DWORD             *pRcvBufferPtr = (DWORD *)((*threadParam)[3]);
TCHAR             *pRcvBuffer    = (TCHAR *)((*threadParam)[4]);

if (*threadParam!=NULL) free (*threadParam),*threadParam=NULL;

if (pSocket->Adapter.OpenInstance == NULL)
	goto end;

hPacket[0]=GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, sizeof(PACKET));
lpPacket[0]=(LPPACKET)GlobalLock(hPacket[0]);
hPacket[1]=GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, sizeof(PACKET));
lpPacket[1]=(LPPACKET)GlobalLock(hPacket[1]);
if (lpPacket[0]==NULL || lpPacket[1]==NULL)
	{
   TRACE("Packet32: PacketAllocateSendPacket: GlobalAlloc Failed\n");
	goto end;
	}

lpPacket[0]->OverLapped.hEvent=exit_handle;
lpPacket[0]->Buffer=pSocket->Adapter.lpMem[0];
lpPacket[0]->Length=pSocket->Adapter.BufferSize;
lpPacket[1]->OverLapped.hEvent=exit_handle;
lpPacket[1]->Buffer=pSocket->Adapter.lpMem[1];
lpPacket[1]->Length=pSocket->Adapter.BufferSize;

hFile = ((LPADAPTER)pSocket->Adapter.OpenInstance)->hFile;

handles[0] = exit_handle;
handles[1] = pReadThread->enable_event;
handles[2] = pReadThread->receive_event;

ResetEvent(handles[0]);
ResetEvent(handles[1]);
// metodo spartano per svuotare il semaforo
while (WAIT_TIMEOUT!=WaitForSingleObject(handles[2],100));
rep = 0;
lpPacket[rep]->OverLapped.Offset=0;
lpPacket[rep]->OverLapped.OffsetHigh=0;
lpPacket[rep]->Result=ReadFile(hFile,lpPacket[rep]->Buffer,lpPacket[rep]->Length,&PacketLength,&lpPacket[rep]->OverLapped);
while (1)
	{
	if (!lpPacket[rep]->Result && GetLastError() == ERROR_IO_PENDING) 
		lpPacket[rep]->Result=GetOverlappedResult(hFile,&lpPacket[rep]->OverLapped,&PacketLength,TRUE);
	if (lpPacket[rep]->Result)
		{
		if (!HasOverlappedIoCompleted(&lpPacket[rep]->OverLapped)) // ricevuto un exit dal thread
			goto end;
//		TRACE("Ethernet packet received\n");
		rx_eth = (struct ethhdr *)((BYTE *)lpPacket[rep]->Buffer);
		rx_ip  = (struct iphdr *) ((BYTE *)lpPacket[rep]->Buffer + ETH_HLEN);
		rx_udp = (struct udphdr *)((BYTE *)lpPacket[rep]->Buffer + ETH_HLEN + IP_HLEN);
		rep    = 1 - rep;
		lpPacket[rep]->OverLapped.Offset=0;
		lpPacket[rep]->OverLapped.OffsetHigh=0;
		lpPacket[rep]->Result=ReadFile(hFile,lpPacket[rep]->Buffer,lpPacket[rep]->Length,&PacketLength,&lpPacket[rep]->OverLapped);
		if (pReadThread->type==ETH_P_IP &&
			 rx_eth->h_proto==swap16_be_le(ETH_P_IP) &&
			 rx_ip->protocol==IP_P_UDP &&
			 rx_udp->source==swap16_be_le(pSocket->UDPPort))
			{
//			TRACE("UDP ethernet packet received id %02x\n",*((BYTE *)rx_eth + 51));
			memcpy((void *)&pRcvBuffer[((*pRcvBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1))*ETHERNET_MAX_BUFFER_SIZE],(BYTE *)rx_udp + UDP_HLEN,swap16_be_le(rx_udp->len) - UDP_HLEN);
			*pRcvBufferPtr=(*pRcvBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1);
			// notifico ad un eventuale processo esterno che e' arrivato qualcosa
			ReleaseSemaphore(handles[2],1,NULL);
//			SetEvent(handles[2]);
			// parser di visualizzazione del comando ethernet ricevuto
			rx_mgp=(struct mgphdr *)&pRcvBuffer[*pRcvBufferPtr*ETHERNET_MAX_BUFFER_SIZE];
			pData=(uint32 *)((uint32)&pRcvBuffer[*pRcvBufferPtr*ETHERNET_MAX_BUFFER_SIZE]+MGP_HLEN);
			m_FirstDSP=((rx_mgp->DSPs[0]&0xF0)>>4)+((rx_mgp->DSPs[1]&0x0F)<<4);
			m_LastDSP=rx_mgp->DSPs[2];
			if (pSocket->m_EnableOutput && rx_mgp->op!=MGP_OP_CMD_DIAGNOSTIC)
				{
				((COutputArea *)pSocket->pOutputReceive)->AddString("Ethernet packet received:");
				sprintf(str,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x",rx_mgp->DSPs[0]&0x0F,m_FirstDSP,(rx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,rx_mgp->op,rx_mgp->len,rx_mgp->fl,rx_mgp->id,rx_mgp->saddr);
				((COutputArea *)pSocket->pOutputReceive)->AddString(str);
				strcpy(str,"Data rcvd ");
				for (i=0;i<rx_mgp->len;)
					{
					for (i1=0;i1<7 && i<rx_mgp->len-1;i++,i1++)
						{
						sprintf(str1,"%08x - ",pData[i]);
						strcat(str,str1);
						}
					sprintf(str1,"%08x",pData[i++]);
					strcat(str,str1);
					((COutputArea *)pSocket->pOutputReceive)->AddString(str);
					strcpy(str,"          ");
					}
				}
			// verifico se ho ricevuto un pacchetto diagnstico master 
			if (rx_mgp->op==MGP_OP_CMD_DIAGNOSTIC) 
				{
				sprintf(str,"Diagnostic packet received: #%d",rx_mgp->id);
				((COutputArea *)pSocket->pOutputReceive)->AddString(str);
/*				if (diag_counter!=rx_mgp->id)
					{
					sprintf(str,"Packet lost!!!");
					diag_counter=rx_mgp->id;
					}
				else
					diag_counter++;*/
				}
			if (pSocket->m_fd)
				{
				// formato di uscita standard
	/*			fprintf(m_fd,"Ethernet packet received:\n");
				fprintf(m_fd,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x\n",rx_mgp->DSPs[0]&0x0F,m_FirstDSP,(rx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,rx_mgp->op,rx_mgp->len,rx_mgp->fl,rx_mgp->id,rx_mgp->saddr);
				strcpy(str,"Data rcvd ");
				for (i=0;i<rx_mgp->len;)
					{
					for (i1=0;i1<7 && i<rx_mgp->len-1;i++,i1++)
						{
						sprintf(str1,"%08x - ",pData[i]);
						strcat(str,str1);
						}
					sprintf(str1,"%08x\n",pData[i++]);
					strcat(str,str1);
					fprintf(m_fd,str);
					strcpy(str,"          ");
					}*/
	/*			for (i=0;i<rx_mgp->len;i+=2)
					{
					sprintf(str,"%5.5d %5.5d %5.5d %5.5d\n",pData[i]&0x0000FFFF,(pData[i]&0xFFFF0000)>>16,pData[i+1]&0x0000FFFF,(pData[i+1]&0xFFFF0000)>>16);
					fprintf(m_fd,str);
					}*/
	/*			for (i=0;i<rx_mgp->len;i++)
					{
					sprintf(str,"%08x\n",pData[i]);
					fprintf(m_fd,str);
					}
				// formato di uscita binaria
				// fwrite((void *)pData,rx_mgp->len,sizeof(DWORD),m_fd);*/
				}
			//"First DSP #.## - Last DSP #.## - Cmd ## - Data len #### - Flags ## - Cmd ID ## - Start ########"
			//"Data rcvd ######## - ######## - ######## - ######## - ######## - ######## - ######## - ########"
			//"          ######## - ######## - ######## - ######## - ######## - ######## - ######## - ########"
			}
		else if (pReadThread->type==ETH_P_ARP &&
					rx_eth->h_proto==swap16_be_le(ETH_P_ARP))
			{
			TRACE("ARP ethernet packet received\n");
			*pRcvBufferPtr=(*pRcvBufferPtr+1)&(CIRCULAR_BUFFER_SIZE-1);
			memcpy((void *)&pRcvBuffer[*pRcvBufferPtr*ETHERNET_MAX_BUFFER_SIZE],rx_eth,lpPacket[1-rep]->Length);
			ReleaseSemaphore(handles[2],1,NULL);
//			SetEvent(handles[2]);
			}
		}
	}
	/*		// verifico se e' un pacchetto di ping
			if (rx_eth->h_proto==swap16_be_le(ETH_P_IP))
				{
			rx_ip = (struct iphdr *)(Adapter.lpMem + ETH_HLEN);
			if (rx_ip->saddr[0] == 192 &&
				 rx_ip->saddr[1] == 168 &&
				 rx_ip->saddr[2] == 0 &&
				 rx_ip->saddr[3] == 4)
				{
				if (rx_ip->protocol==IP_P_ICMP)
					{
					rx_icmp = (struct icmphdr *)(Adapter.lpMem + ETH_HLEN + IP_HLEN);
					m_ReadData.AddString("Ping received");
					}*/

end:

GlobalUnlock(hPacket[0]);
//GlobalFree(hPacket[0]);
GlobalUnlock(hPacket[1]);
//GlobalFree(hPacket[1]);

TRACE ("ReceiverThread thread exited\n");

return (0);
}

CMyAsyncSocket::CMyAsyncSocket()
{
UDPPort=-1;
memset(local_eth_addr,0,ETH_ALEN);
local_ip_addr=0;
memset(remote_eth_addr,0,ETH_ALEN);
remote_ip_addr=0;

pOutputSend=NULL;
pOutputReceive=NULL;
m_EnableOutput=TRUE;
m_fd=NULL;
memset((void *)&readThread,0,sizeof(readThread));
memset((void *)&Adapter,0,sizeof(Adapter));
memset((void *)&AdaptersInfo,0,sizeof(AdaptersInfo));
readThread.enable_event=CreateEvent(NULL,FALSE,FALSE,NULL);
readThread.receive_event=CreateSemaphore(NULL,0,256,"LBT_EngPanelCallbackEvent");
//readThread.receive_event=CreateEvent(NULL,FALSE,FALSE,NULL);
m_ExitHandle=CreateEvent(NULL,FALSE,FALSE,NULL);
m_CallbackHandle=readThread.receive_event;
receiverBufferPtr=CIRCULAR_BUFFER_SIZE-1;
}

CMyAsyncSocket::~CMyAsyncSocket()
{
ExitFromReceiveThread();

if (readThread.enable_event)  CloseHandle(readThread.enable_event),  readThread.enable_event=NULL;
if (readThread.receive_event) CloseHandle(readThread.receive_event), readThread.receive_event=NULL;
if (m_ExitHandle)             CloseHandle(m_ExitHandle),             m_ExitHandle=NULL;

if (Adapter.hMem[0])
	{
	GlobalUnlock(Adapter.hMem[0]);
	GlobalFree(Adapter.hMem[0]);
	}
if (Adapter.hMem[1])
	{
	GlobalUnlock(Adapter.hMem[1]);
	GlobalFree(Adapter.hMem[1]);
	}
if (Adapter.hMem2)
	{
	GlobalUnlock(Adapter.hMem2);
	GlobalFree(Adapter.hMem2);
	}
}

// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CMyAsyncSocket, CAsyncSocket)
	//{{AFX_MSG_MAP(CMyAsyncSocket)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CMyAsyncSocket member functions

PVOID CMyAsyncSocket::PacketOpenAdapter(LPTSTR AdapterName)
/*++
Routine Description:
    This rotine opens an instance of the adapter
Arguments:
    AdapterName - unicode name of the adapter to open
Return Value:
    SUCCESS - returns a pointer to an adapter object
    FAILURE - NULL
--*/
{
LPADAPTER  lpAdapter;
    
TRACE("Packet32: PacketOpenAdapter\n");

lpAdapter=(LPADAPTER)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_ZEROINIT,sizeof(ADAPTER));

if (lpAdapter==NULL) 
	{
   TRACE("Packet32: PacketOpenAdapter GlobalAlloc Failed\n");
	return NULL;
	}

wsprintf(lpAdapter->SymbolicLink,TEXT("\\\\.\\%s"),&AdapterName[12]);

lpAdapter->hFile=CreateFile(lpAdapter->SymbolicLink, GENERIC_WRITE | GENERIC_READ, 0,
                            NULL, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);

if (lpAdapter->hFile != INVALID_HANDLE_VALUE)
	return lpAdapter;

TRACE("Packet32: PacketOpenAdapter Could not open adapter\n");

GlobalFreePtr(lpAdapter);

return NULL;
}

VOID CMyAsyncSocket::PacketCloseAdapter(LPADAPTER lpAdapter)
/*++
Routine Description:
    This rotine closes a previouly opened adapter
Arguments:
    Adapter object returned from PacketOpenAdapter
Return Value:
--*/
{
TRACE("Packet32: PacketCloseAdapter\n");

CloseHandle(lpAdapter->hFile);

GlobalFreePtr(lpAdapter);
}

PVOID CMyAsyncSocket::PacketAllocatePacket(LPADAPTER AdapterObject)
/*++
Routine Description:
    This rotine this routine allocates a packet object for use
    in sending a receiveing packets
Arguments:
    Adapter object returned from PacketOpenAdapter
Return Value:
    SUCCESS - returns packet object
	 FAILURE - NULL
--*/
{
LPPACKET lpPacket;

lpPacket=(LPPACKET)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_ZEROINIT, sizeof(PACKET));

if (lpPacket==NULL) 
	{
   TRACE("Packet32: PacketAllocateSendPacket: GlobalAlloc Failed\n");
	return NULL;
	}

lpPacket->OverLapped.hEvent=CreateEvent(NULL,FALSE,FALSE,NULL);

if (lpPacket->OverLapped.hEvent==NULL) 
	{
	TRACE("Packet32: PacketAllocateSendPacket: CreateEvent Failed\n");
	GlobalFreePtr(lpPacket);
	return NULL;
   }

return lpPacket;
}

VOID CMyAsyncSocket::PacketFreePacket(LPPACKET lpPacket)
{
CloseHandle(lpPacket->OverLapped.hEvent);

GlobalFreePtr(lpPacket);
}

VOID CMyAsyncSocket::PacketInitPacket(LPPACKET lpPacket, PVOID Buffer, UINT Length)
/*++
Routine Description:
    This rotine initializes a packet object to point to
    a memory buffer described by Start address and length
Arguments:
    lpPacket   -  Packet object returned by PacketAllocatePacket
    Buffer     -  Begining address of a memory buffer
    Length     -  Length of memory buffer
Return Value:
--*/
{
lpPacket->Buffer=Buffer;
lpPacket->Length=Length;
}

BOOL CMyAsyncSocket::PacketSendPacket(LPADAPTER AdapterObject, LPPACKET lpPacket, BOOL Sync)
/*++
Routine Description:
    This rotine sends a packet to the adapter
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
    lpPacket       - Packet object returned by PacketAllocatePacket and initialized
                     by PacketInitPacket
    Sync           - TRUE if service should wait for packet to transmit
Return Value:
    SUCCESS - TRUE if succeeded and SYNC==TRUE
    FAILURE -
--*/
{
BOOL      Result;
DWORD      BytesTransfered;

lpPacket->OverLapped.Offset=0;
lpPacket->OverLapped.OffsetHigh=0;

if (!ResetEvent(lpPacket->OverLapped.hEvent))
	return FALSE;

Result=WriteFile(AdapterObject->hFile,lpPacket->Buffer,lpPacket->Length,
					  &BytesTransfered,&lpPacket->OverLapped);

if(!Result) 
	{
   if (GetLastError() == ERROR_IO_PENDING) 
		{
      if (Sync) 
         //  They want to wait for I/O to complete
			Result=GetOverlappedResult(AdapterObject->hFile,&lpPacket->OverLapped,&BytesTransfered,TRUE);
		else
         //  They don't want to wait, they will call PacketWaitPacket to get the real result
         Result=TRUE;
	    }
	}
return Result;
}

BOOL CMyAsyncSocket::PacketReceivePacket(LPADAPTER AdapterObject, LPPACKET lpPacket, BOOL Sync, PULONG BytesReceived)
/*++
Routine Description:
    This rotine issues a receive request from the adapter
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
    lpPacket       - Packet object returned by PacketAllocatePacket and initialized
                     by PacketInitPacket
    Sync           - TRUE if service should wait for packet to transmit
Return Value:
    SUCCESS - TRUE if succeeded and SYNC==TRUE
    FAILURE -
--*/
{
BOOL Result;

lpPacket->OverLapped.Offset=0;
lpPacket->OverLapped.OffsetHigh=0;

if (!ResetEvent(lpPacket->OverLapped.hEvent)) 
   return FALSE;

Result=ReadFile(AdapterObject->hFile,lpPacket->Buffer,lpPacket->Length,BytesReceived,&lpPacket->OverLapped);

if(!Result)
	{
   if (GetLastError() == ERROR_IO_PENDING) 
		{
		if (Sync) 
         //  They want to wait
         Result=GetOverlappedResult(AdapterObject->hFile,&lpPacket->OverLapped,BytesReceived,TRUE);
		else
			Result=TRUE;
	    }
	}
return Result;
}

BOOL CMyAsyncSocket::PacketWaitPacket(LPADAPTER AdapterObject, LPPACKET lpPacket, PULONG BytesReceived)
/*++
Routine Description:
    This routine waits for an overlapped IO on a packet to complete
    Called if the send or receive call specified FALSE for the Sync parmeter
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
    lpPacket       - Packet object returned by PacketAllocatePacket and initialized
                     by PacketInitPacket
Return Value:
    SUCCESS - TRUE if overlapped call succeeded
    FAILURE -
--*/
{
return GetOverlappedResult(AdapterObject->hFile,&lpPacket->OverLapped,BytesReceived,TRUE);
}

BOOL CMyAsyncSocket::PacketResetAdapter(LPADAPTER AdapterObject)
/*++
Routine Description:
    This rotuine resets the adapter. This will complete all pending sends receives and requests
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
Return Value:
    SUCCESS - TRUE if overlapped call succeeded
    FAILURE -
--*/
{
unsigned long BytesReturned;

return DeviceIoControl(AdapterObject->hFile,(DWORD)IOCTL_PROTOCOL_RESET,NULL,0,NULL,0,&BytesReturned,NULL);
}

BOOL CMyAsyncSocket::PacketRequest(LPADAPTER AdapterObject, BOOL Set, PPACKET_OID_DATA OidData)
/*++
Routine Description:
    This routine sends issues a request to and adapter
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
    Set            - True means that the request is SET otherwise it is a query
    OidData        - Structure containing the details of the OID
Return Value:
    SUCCESS -
    FAILURE -
--*/
{
unsigned long BytesReturned;
BOOL    Result;
//ULONG   IoCtlBufferLength = sieof(PACKET_OID_DATA)-1+OidData->Length;
ULONG   IoCtlBufferLength = 15;

Result=DeviceIoControl(AdapterObject->hFile,
                       (DWORD) Set ? IOCTL_PROTOCOL_SET_OID : IOCTL_PROTOCOL_QUERY_OID,
                       OidData, IoCtlBufferLength, OidData,
                       IoCtlBufferLength, &BytesReturned, NULL);

return Result;
}

BOOL CMyAsyncSocket::PacketSetFilter(LPADAPTER AdapterObject, ULONG Filter)
/*++
Routine Description:
    This rotine sets the adapters packet filter
Arguments:
    AdapterObject  - AdapterObject return by PacketOpenAdapter
    Filter         - filter to be set
Return Value:
    SUCCESS -
    FAILURE -
--*/
{
BOOL  Status;
//ULONG IoCtlBufferLength=(sizeof(PACKET_OID_DATA)+sizeof(ULONG)-1);
ULONG IoCtlBufferLength=15;
PPACKET_OID_DATA  OidData;

OidData=(PPACKET_OID_DATA)GlobalAllocPtr(GMEM_MOVEABLE | GMEM_ZEROINIT,IoCtlBufferLength);

if (OidData == NULL)
	return FALSE;

OidData->Oid=OID_GEN_CURRENT_PACKET_FILTER;
OidData->Length=sizeof(ULONG);
*((PULONG)OidData->Data)=Filter;

Status=PacketRequest(AdapterObject,TRUE,OidData);

GlobalFreePtr(OidData);

return Status;
}

BOOL CMyAsyncSocket::PacketStartDriver(LPTSTR ServiceName)
/*++
Routine Description:
    This routine Atempts to start the kernel mode packet driver
Arguments:
    ServiceName  - Name of service to try to start
Return Value:
    SUCCESS -
    FAILURE -
--*/
{
BOOL  Status = FALSE;
SERVICE_STATUS      ServiceStatus;
SC_HANDLE  SCManagerHandle = NULL;
SC_HANDLE  SCServiceHandle = NULL;

/* Open a handle to the SC Manager database. */

SCManagerHandle = OpenSCManager(
                  NULL,                   /* local machine           */
                  NULL,                   /* ServicesActive database */
                  SC_MANAGER_ALL_ACCESS); /* full access rights      */

if (SCManagerHandle==NULL) 
	{
	AfxMessageBox(TEXT("Could not open SC"),MB_OK);
	goto CleanExit;
	} 
else 
	{
	SCServiceHandle=OpenService(SCManagerHandle,
                               ServiceName,
                               SERVICE_START);

	if (SCServiceHandle == NULL) 
		{
		AfxMessageBox(TEXT("Could not open service"),MB_OK);
      goto CleanExit;
		}

   Status=StartService(SCServiceHandle,0,NULL);

	if (!Status) 
		{
		if (GetLastError()==ERROR_SERVICE_ALREADY_RUNNING) 
			{
	      TRACE("Packet32: Packet service already started\n");
			Status = TRUE;
         goto CleanExit;
		   } 
		else 
			{
			AfxMessageBox(TEXT("Could not start service"),MB_OK);
			goto CleanExit;
         }
		}
	while (1)
		{ // loop until the service is fully started.
		if (!QueryServiceStatus(SCServiceHandle, &ServiceStatus))
			goto CleanExit;

		switch(ServiceStatus.dwCurrentState)
			{
			case  SERVICE_RUNNING:
				Status = TRUE;
            goto CleanExit;
				break;

         case SERVICE_START_PENDING:
				Sleep(2000);
            break;
			default:
				goto CleanExit;
            break;
         }
		}
	}

CleanExit:
    if(SCManagerHandle != NULL) 
        CloseServiceHandle(SCManagerHandle);
    if(SCServiceHandle != NULL)
        CloseServiceHandle(SCServiceHandle);
return(Status);
}

BOOL CMyAsyncSocket::PacketStopDriver(IN LPCTSTR ServiceName)
{
BOOL  Status = FALSE;
SERVICE_STATUS      ServiceStatus;
SC_HANDLE  SCManagerHandle = NULL;
SC_HANDLE  SCServiceHandle = NULL;

/* Open a handle to the SC Manager database. */

SCManagerHandle = OpenSCManager(
                  NULL,                   /* local machine           */
                  NULL,                   /* ServicesActive database */
                  SC_MANAGER_ALL_ACCESS); /* full access rights      */

if (SCManagerHandle==NULL) 
	{
	AfxMessageBox(TEXT("Could not open SC"),MB_OK);
	goto CleanExit;
   } 
SCServiceHandle=OpenService(SCManagerHandle,ServiceName,SERVICE_STOP);
if (SCServiceHandle == NULL) 
	{
	AfxMessageBox(TEXT("Could not open service"),MB_OK);
   goto CleanExit;
	}

// Request that the service stop.
if (ControlService(SCServiceHandle,SERVICE_CONTROL_STOP,&ServiceStatus)) 
	Status = TRUE;
else
	AfxMessageBox(TEXT("Could not stop service"),MB_OK);

CleanExit:
if(SCManagerHandle != NULL)
	CloseServiceHandle(SCManagerHandle);
if(SCServiceHandle != NULL)
	CloseServiceHandle(SCServiceHandle);

return Status;
}   //  PacketStopDriver

BOOL CMyAsyncSocket::PacketInit(IN PVOID DllHandle, IN ULONG Reason, IN PCONTEXT Context OPTIONAL)
/*++
Routine Description:
Arguments:
    DllHandle - Not Used
    Reason - Attach or Detach
    Context - Not Used
Return Value:
    SUCCESS - TRUE
    FAILURE - FALSE
--*/
{
BOOL Status=TRUE;

TRACE("Packet32: DllEntry\n");

switch ( Reason ) 
	{
	case DLL_PROCESS_ATTACH:
	break;
	case DLL_PROCESS_DETACH:
	break;
	default:
	break;
   }

return Status;
}

ULONG CMyAsyncSocket::PacketGetAdapterNames(PTSTR pStr, PULONG BufferSize)
/*++
Routine Description:
    This routine returns the names all adapters availible
Arguments:
    Pstr       -  Pointer to a buffer which recieves the UNICODE names
                  Each name is NULL terminated with a second NULL at the end
                  of the list.
    BufferSize -  Size of the buffer passed in
Return Value:
    SUCCESS -
    FAILURE -
--*/
{
HKEY  SystemKey=NULL;
HKEY  ControlSetKey=NULL;
HKEY  ServicesKey=NULL;
HKEY  NdisPerfKey=NULL;
HKEY  LinkageKey=NULL;
LONG  Status;
DWORD RegType;

Status=RegOpenKeyEx(HKEY_LOCAL_MACHINE,TEXT("SYSTEM"),0,KEY_READ,&SystemKey);
if (Status != ERROR_SUCCESS) 
	goto exit;

Status=RegOpenKeyEx(SystemKey,TEXT("CurrentControlSet"),0,KEY_READ,&ControlSetKey);
if (Status != ERROR_SUCCESS) 
	goto exit;

Status=RegOpenKeyEx(ControlSetKey,TEXT("Services"),0,KEY_READ,&ServicesKey);
if (Status != ERROR_SUCCESS) 
	goto exit;

Status=RegOpenKeyEx(ServicesKey,TEXT("Packet"),0,KEY_READ,&NdisPerfKey);
if (Status != ERROR_SUCCESS) 
	goto exit;

Status=RegOpenKeyEx(NdisPerfKey,TEXT("Linkage"),0,KEY_READ,&LinkageKey);
if (Status != ERROR_SUCCESS) 
	goto exit;

Status=RegQueryValueEx(LinkageKey,TEXT("Export"),NULL,&RegType,(LPBYTE)pStr,BufferSize);

exit:
if (SystemKey) RegCloseKey(SystemKey);
if (ControlSetKey) RegCloseKey(ControlSetKey);
if (ServicesKey) RegCloseKey(ServicesKey);
if (NdisPerfKey) RegCloseKey(NdisPerfKey);
if (LinkageKey) RegCloseKey(LinkageKey);

return Status;
}

BOOL CMyAsyncSocket::OpenAdapter()
{
CWinThread *pThread;

// apro il driver eth
Adapter.DeviceSelected=0;

// apro il driver eth
Adapter.BufferSize=ETHERNET_MAX_BUFFER_SIZE;

if (!(Adapter.hMem[0]=GlobalAlloc(GMEM_MOVEABLE,Adapter.BufferSize)))
	return FALSE;
if (!(Adapter.lpMem[0]=(PUCHAR)GlobalLock(Adapter.hMem[0])))
	return FALSE;

if (!(Adapter.hMem[1]=GlobalAlloc(GMEM_MOVEABLE,Adapter.BufferSize)))
	return FALSE;
if (!(Adapter.lpMem[1]=(PUCHAR)GlobalLock(Adapter.hMem[1])))
	return FALSE;

if (!(Adapter.hMem2=GlobalAlloc(GMEM_MOVEABLE,Adapter.BufferSize)))
	return FALSE;
if (!(Adapter.lpMem2=(PUCHAR)GlobalLock(Adapter.hMem2)))
	return FALSE;

if (!PacketStartDriver(TEXT("PACKET")))
	return FALSE;

Sleep(200);

if (!EnumAdapters())
	return FALSE;

if (AdaptersInfo.NumAdapters>1)
	{
	CEthernetCardSelect EthernetCardSelectDlg(&AdaptersInfo);
	Adapter.DeviceSelected=EthernetCardSelectDlg.DoModal();
	}

Adapter.OpenInstance=PacketOpenAdapter(AdaptersInfo.SymbolicLink[Adapter.DeviceSelected]);

if (Adapter.OpenInstance == NULL) 
	{
	AfxMessageBox("Unable to open adapter");
	return FALSE;
	}

//PacketSetFilter((struct _ADAPTER *)Adapter.OpenInstance,NDIS_PACKET_TYPE_BROADCAST);
PacketSetFilter((struct _ADAPTER *)Adapter.OpenInstance,NDIS_PACKET_TYPE_DIRECTED);

PacketResetAdapter((struct _ADAPTER *)Adapter.OpenInstance);

threadParam=(DWORD *)malloc(sizeof (DWORD*)*5);
threadParam[ 0]=(DWORD)this;
threadParam[ 1]=(DWORD)m_ExitHandle;
threadParam[ 2]=(DWORD)&readThread;
threadParam[ 3]=(DWORD)&receiverBufferPtr;
threadParam[ 4]=(DWORD)receiverBuffer;
//pThread=AfxBeginThread(ReceiverThread,(LPVOID)&threadParam,THREAD_PRIORITY_HIGHEST,0,0,NULL);
pThread=AfxBeginThread(ReceiverThread,(LPVOID)&threadParam,THREAD_PRIORITY_TIME_CRITICAL,0,0,NULL);
DuplicateHandle(GetCurrentProcess(),pThread->m_hThread,GetCurrentProcess(),&hReceiverThread,THREAD_QUERY_INFORMATION|THREAD_TERMINATE,FALSE,NULL);

return TRUE;
}

void CMyAsyncSocket::DisconnectAdapter()
{
char str[100];

UDPPort=-1;
memset(remote_eth_addr,0,ETH_ALEN);
remote_ip_addr=0;

sprintf(str,"Disconnected to BCU");
((COutputArea *)pOutputSend)->AddString(str);
::SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_UPDATE_BUTTONS,11,0);
}

void CMyAsyncSocket::ConnectAdapter(SOCKETADDR *pSocketAddr)
{
int i;
struct ethhdr *tx_eth;
struct arphdr *tx_arp,*rx_arp;
char *pChar,*pChar1;
char str[100];

UDPPort = pSocketAddr->port;
remote_ip_addr = 0;
strcpy(str,pSocketAddr->IP);
pChar = pChar1 = str;
for (i=0;i<4;i++)
	{
	while(*pChar!='.' && *pChar!='\0')
		pChar++;
	*(pChar++)='\0';
	remote_ip_addr += atoi(pChar1) * 1 << (i * 8);
	pChar1=pChar;
	}

// mando un arp per cercare il MAC della BCU
tx_eth = (struct ethhdr *)Adapter.lpMem2;
memset(tx_eth->h_dest,0xff,ETH_ALEN);
memcpy(tx_eth->h_source,local_eth_addr,ETH_ALEN);
tx_eth->h_proto=swap16_be_le(ETH_P_ARP);
//tx_eth->h_proto=ETH_P_ARP;
tx_arp=(struct arphdr *)(Adapter.lpMem2 + ETH_HLEN);

tx_arp->ar_hrd=swap16_be_le(ARPHRD_ETHER);
tx_arp->ar_pro=swap16_be_le(ETH_P_IP);
tx_arp->ar_hln=ETH_ALEN;
tx_arp->ar_pln=IP_ALEN;
tx_arp->ar_op=swap16_be_le(ARPOP_REQUEST);

memcpy(tx_arp->ar_sha,local_eth_addr,ETH_ALEN);
memcpy(tx_arp->ar_sip,&local_ip_addr,IP_ALEN);
memset(tx_arp->ar_tha,0,ETH_ALEN);
memcpy(tx_arp->ar_tip,&remote_ip_addr,IP_ALEN);

readThread.type=ETH_P_ARP;
//SetEvent(readThread.enable_event);

if (PacketSend(ETH_HLEN+ARP_HLEN))
	{
	sprintf(str,"ARP command sent");
	((COutputArea *)pOutputSend)->AddString(str);
	}
else
	{
	sprintf(str,"ARP command fault");
	((COutputArea *)pOutputSend)->AddString(str);
	}

if (WaitForSingleObject(readThread.receive_event,1000)==WAIT_TIMEOUT)
	{
	UDPPort=-1;
	memset(remote_eth_addr,0,ETH_ALEN);
	remote_ip_addr=0;
	sprintf(str,"Unable to connect to BCU: %s",pSocketAddr->IP);
	((COutputArea *)pOutputSend)->AddString(str);
	::SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_UPDATE_BUTTONS,11,0);
	}
else
	{
	rx_arp=(struct arphdr *)(&receiverBuffer[receiverBufferPtr][0] + ETH_HLEN);
	if (rx_arp->ar_op==swap16_be_le(ARPOP_REPLY) && !memcmp(rx_arp->ar_sip,&remote_ip_addr,IP_ALEN))
		{
		memcpy(remote_eth_addr,rx_arp->ar_sha,ETH_ALEN);
		sprintf(str,"Connected to BCU: MAC %02x:%02x:%02x:%02x:%02x:%02x - IP %d.%d.%d.%d",
				remote_eth_addr[0],
		      remote_eth_addr[1],
				remote_eth_addr[2],
				remote_eth_addr[3],
				remote_eth_addr[4],
				remote_eth_addr[5],
				((BYTE *)&remote_ip_addr)[0],
				((BYTE *)&remote_ip_addr)[1],
				((BYTE *)&remote_ip_addr)[2],
				((BYTE *)&remote_ip_addr)[3]);
		((COutputArea *)pOutputSend)->AddString(str);
		::SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_UPDATE_BUTTONS,10,0);
		}
	else
		{
		UDPPort=-1;
		memset(remote_eth_addr,0,ETH_ALEN);
		remote_ip_addr=0;
		sprintf(str,"Unable to connect to BCU");
		((COutputArea *)pOutputSend)->AddString(str);
		::SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_UPDATE_BUTTONS,11,0);
		}
	}
return;
}

void CMyAsyncSocket::CloseAdapter()
{
if (Adapter.OpenInstance != NULL)
	{
	PacketCloseAdapter((struct _ADAPTER *)Adapter.OpenInstance);
   Adapter.OpenInstance = NULL;
   }
else
	AfxMessageBox(TEXT("Error: device not open"), MB_OK);

((COutputArea *)pOutputSend)->AddString("Current connection closed");
::SendMessage(AfxGetApp()->GetMainWnd()->m_hWnd,WM_UPDATE_BUTTONS,11,0);
}

BOOL CMyAsyncSocket::EnumAdapters()
{
HANDLE hFile;
ULONG bytesReturned;
TCHAR *buffer;
UINT i;

memset(Buffer, 0, sizeof(Buffer));
hFile=CreateFile(TEXT("\\\\.\\Packet"),
                 GENERIC_WRITE | GENERIC_READ,
                 0,
                 NULL,
                 OPEN_EXISTING,
                 FILE_FLAG_OVERLAPPED,
                 0);
if (hFile == INVALID_HANDLE_VALUE) 
	{
   AfxMessageBox(TEXT("Error: driver is not loaded. Try reloading the app."), MB_OK);
   return FALSE;
	}
    
if (!DeviceIoControl(hFile,
							IOCTL_ENUM_ADAPTERS,
							NULL,
							0,
							Buffer,
							sizeof(Buffer),
							&bytesReturned,
							NULL))
	{
   AfxMessageBox(TEXT("Error: enum ioctl failed"), MB_OK);
   return FALSE;
	}

buffer = (TCHAR *)Buffer;

//
// Parse the output and fill the AdaptersInfo structure
//

AdaptersInfo.NumAdapters = *(PULONG)buffer;
(PCHAR)buffer += sizeof(ULONG);

// zip del buffer da 16 a 8 bit
for (i=0;i<sizeof(Buffer)/2;i++)
	buffer[i]=buffer[i*2];

i = 0;
AdaptersInfo.AdapterName[i] = (LPTSTR)buffer;
while (*(buffer++)) 
	{
   while (*(buffer++));
	AdaptersInfo.SymbolicLink[i] = (LPTSTR)buffer;
   while (*(buffer++));
	if(++i == MAX_ADAPTERS) 
		break;
	AdaptersInfo.AdapterName[i] = (LPTSTR)buffer;
   }

CloseHandle(hFile);
return TRUE;
}

BOOL CMyAsyncSocket::PacketSend(int nBufLen)
{
PVOID Packet;

if(Adapter.OpenInstance != NULL)
	{
	Packet=PacketAllocatePacket((struct _ADAPTER *)Adapter.OpenInstance);
	if (Packet != NULL) 
		{
		PacketInitPacket((struct _PACKET *)Packet,Adapter.lpMem2,nBufLen);
		if(!PacketSendPacket((struct _ADAPTER *)Adapter.OpenInstance,(struct _PACKET *)Packet,TRUE))
			{
			TRACE(TEXT("Error: send failed"));
			PacketFreePacket((struct _PACKET *)Packet);
			return FALSE;
			}
		PacketFreePacket((struct _PACKET *)Packet);
		return TRUE;
		}
	TRACE(TEXT("Error: unable to allocate packet"));
	return FALSE;
	}
else
	{
	TRACE(TEXT("Error: device not open"));
	return FALSE;
	}
}

void CMyAsyncSocket::Send(const void*lpBuf,int nBufLen,int nFlags)
{
BYTE   m_FirstDSP,m_LastDSP,numDSP;
uint32 *pData;
char   str[1000],str1[1000];
int    i,i1;
uint32 val32;
WORD   *ptr16;
struct ethhdr *tx_eth;
struct iphdr  *tx_ip;
struct udphdr *tx_udp;
struct mgphdr *tx_mgp;

// preparo l'header MAC
tx_eth = (struct ethhdr *)Adapter.lpMem2;
memcpy(tx_eth->h_dest,remote_eth_addr,ETH_ALEN);
memcpy(tx_eth->h_source,local_eth_addr,ETH_ALEN);
tx_eth->h_proto=swap16_be_le(ETH_P_IP);
tx_ip=(struct iphdr *)(Adapter.lpMem2 + ETH_HLEN);
tx_ip->vihl=0x45;
tx_ip->tos=0;
tx_ip->tot_len=swap16_be_le(IP_HLEN + UDP_HLEN + nBufLen);
//tx_ip->id=rand();
tx_ip->id=0x0094;
tx_ip->frag_off=0;
tx_ip->ttl=128;
tx_ip->protocol=IP_P_UDP;
tx_ip->check=0;
memcpy(tx_ip->saddr,&local_ip_addr,IP_ALEN);
memcpy(tx_ip->daddr,&remote_ip_addr,IP_ALEN);
tx_udp=(struct udphdr *)(Adapter.lpMem2 + ETH_HLEN + IP_HLEN);
tx_udp->source=swap16_be_le(UDPPort);
tx_udp->dest=swap16_be_le(UDPPort);
tx_udp->len=swap16_be_le(UDP_HLEN + nBufLen);
tx_udp->check=0;
memcpy((BYTE *)tx_udp + UDP_HLEN,lpBuf,nBufLen);
// calcolo delle checksum IP
ptr16=(WORD *)tx_ip;
val32=0;
for (i=0;i<IP_HLEN;i+=2)
	cks_add_val16(&val32,*ptr16++);
tx_ip->check=0xFFFF-(uint16)val32;
// calcolo delle checksum UDP
ptr16=(WORD *)((BYTE *)tx_udp - 8);
val32=0;
cks_add_val16(&val32,swap16_be_le(IP_P_UDP));
//cks_add_val16(&val32,IP_P_UDP);
cks_add_val16(&val32,swap16_be_le(UDP_HLEN + nBufLen));
for (i=0;i<8 + UDP_HLEN + (int)nBufLen;i+=2)
	cks_add_val16(&val32,*ptr16++);
tx_udp->check=0xFFFF-(uint16)val32;

readThread.type=ETH_P_IP;
//SetEvent(readThread.enable_event);
//Sleep(0);
PacketSend(ETH_HLEN+IP_HLEN+UDP_HLEN+nBufLen);

tx_mgp=(struct mgphdr *)lpBuf;
pData=(uint32 *)((BYTE *)lpBuf+MGP_HLEN);
m_FirstDSP=((tx_mgp->DSPs[0]&0xF0)>>4)+((tx_mgp->DSPs[1]&0x0F)<<4);
m_LastDSP=tx_mgp->DSPs[2];
if (tx_mgp->op==MGP_OP_WRSAME_DSP || tx_mgp->op==MGP_OP_RESET_DEVICES || 
	 tx_mgp->op==MGP_OP_LOCK_FLASH || tx_mgp->op==MGP_OP_UNLOCK_FLASH || 
	 tx_mgp->op==MGP_OP_CLEAR_FLASH || tx_mgp->op==MGP_OP_WRITE_FLASH || 
	 tx_mgp->op==MGP_OP_WR_SCIMEASURE_RAM || tx_mgp->op==MGP_OP_CLEAR_SDRAM || 
	 tx_mgp->op==MGP_OP_WRSAME_SDRAM || tx_mgp->op==MGP_OP_CLEAR_SRAM || 
	 tx_mgp->op==MGP_OP_WRSAME_SRAM || tx_mgp->op==MGP_OP_WRSAME_DIAGBUFF)
	numDSP=1;
else if (tx_mgp->op==MGP_OP_RDSEQ_FLASH || tx_mgp->op==MGP_OP_WRSEQ_SDRAM || 
         tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_WRSEQ_SRAM || 
         tx_mgp->op==MGP_OP_RDSEQ_SRAM || tx_mgp->op==MGP_OP_WRSEQ_DIAGBUFF ||
			tx_mgp->op==MGP_OP_RDSEQ_DIAGBUFF)
	numDSP=(m_LastDSP>>1)-(m_FirstDSP>>1)+1;
else if (tx_mgp->op==MGP_OP_WRSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_DSP)
	numDSP=m_LastDSP-m_FirstDSP+1;
else
	numDSP=0;

// parser di visualizzazione del comando ethernet spedito
if (m_EnableOutput)
	{
	((COutputArea *)pOutputSend)->AddString("Ethernet packet sent:");
	sprintf(str,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x",tx_mgp->DSPs[0]&0x0F,m_FirstDSP,(tx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,tx_mgp->op,tx_mgp->len,tx_mgp->fl,tx_mgp->id,tx_mgp->saddr);
	((COutputArea *)pOutputSend)->AddString(str);
	strcpy(str,"Data sent ");
	if (!(tx_mgp->op==MGP_OP_RDSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_FLASH || 
			tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_RDSEQ_SRAM ||
			tx_mgp->op==MGP_OP_RDSEQ_DIAGBUFF))
		{
		for (i=0;i<tx_mgp->len*numDSP;)
			{
			for (i1=0;i1<7 && i<tx_mgp->len*numDSP-1;i++,i1++)
				{
				sprintf(str1,"%08x - ",pData[i]);
				strcat(str,str1);
				}
			sprintf(str1,"%08x",pData[i++]);
			strcat(str,str1);
			((COutputArea *)pOutputSend)->AddString(str);
			strcpy(str,"          ");
			}
		}
	}
/*if (m_fd)
	{
	// formato di uscita standard
	fprintf(m_fd,"Ethernet packet sent:\n");
	fprintf(m_fd,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x\n",tx_mgp->DSPs[0]&0x0F,m_FirstDSP,(tx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,tx_mgp->op,tx_mgp->len,tx_mgp->fl,tx_mgp->id,tx_mgp->saddr);
	strcpy(str,"Data sent ");
	if (!(tx_mgp->op==MGP_OP_RDSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_FLASH || 
			tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_RDSEQ_SRAM))
		{
		for (i=0;i<tx_mgp->len*numDSP;)
			{
			for (i1=0;i1<7 && i<tx_mgp->len*numDSP-1;i++,i1++)
				{
				sprintf(str1,"%08x - ",pData[i]);
				strcat(str,str1);
				}
			sprintf(str1,"%08x\n",pData[i++]);
			strcat(str,str1);
			fprintf(m_fd,str);
			strcpy(str,"          ");
			}
		}
	}*/
}

BOOL CMyAsyncSocket::PacketRead(int nBufLen)
{
return TRUE;
}

void CMyAsyncSocket::ExitFromReceiveThread()
{
DWORD exitCode,count;

// se attivo esco dal thread
if (hReceiverThread)
	{
	if (m_ExitHandle)	
		{
		SetEvent(m_ExitHandle);
		// attendo la fine the thread
		count=0;
		do	
			{
			GetExitCodeThread(hReceiverThread,&exitCode);
			ContinueMessages();
			Sleep(1);
			count++;
			}
		while (exitCode==STILL_ACTIVE && count<EXIT_THREAD_TIMEOUT);
		TRACE ("ReceiverThread (code %08x) exited - counter = %d\n",hReceiverThread,count);
		if (count==EXIT_THREAD_TIMEOUT)
			{
			TerminateThread(hReceiverThread,exitCode);
			GetExitCodeThread(hReceiverThread,&exitCode);
			}
		hReceiverThread=NULL;
		}
	else
		InternalError(55);
	}
else
	TRACE ("ReceiverThread undefined\n");
}
/*
void CNetworkTestDlg::OnRead() 
{
PETHHDR  rx_eth;
PIPHDR   rx_ip;
PICMPHDR rx_icmp;
struct _PACKET *Packet;

UpdateData(TRUE);
if (m_Device==-1)
	{
   AfxMessageBox(TEXT("Error: no device present"), MB_OK);
	return;
	}
if (Adapter.OpenInstance != NULL)
	{
   if (m_Filter != 0)
		{
		Packet=(struct _PACKET *)PacketAllocatePacket((struct _ADAPTER *)Adapter.OpenInstance);
		if (Packet != NULL) 
			{
			PacketInitPacket(Packet,Adapter.lpMem,1514);
			memset(Adapter.lpMem,0,1514);
			if(!PacketReceivePacket((struct _ADAPTER *)Adapter.OpenInstance,Packet,TRUE,&Adapter.PacketLength)) 
				{
            AfxMessageBox(TEXT("Error: read failed"), MB_OK);                                 
            return;
				}                          
			PacketFreePacket((struct _PACKET *)Packet);
			// verifico se e' un pacchetto di ping
			rx_eth = (struct ethhdr *)Adapter.lpMem;
			if (rx_eth->h_proto==swap16_be_le(ETH_P_IP))
				{
				rx_ip = (struct iphdr *)(Adapter.lpMem + ETH_HLEN);
				if (rx_ip->saddr[0] == 192 &&
				    rx_ip->saddr[1] == 168 &&
					 rx_ip->saddr[2] == 0 &&
					 rx_ip->saddr[3] == 4)
					{
					if (rx_ip->protocol==IP_P_ICMP)
						{
						rx_icmp = (struct icmphdr *)(Adapter.lpMem + ETH_HLEN + IP_HLEN);
						m_ReadData.AddString("Ping received");
						}
					}
				}
			}
		}
	else
      AfxMessageBox(TEXT("Error: set the filter to a valid mode"), MB_OK);
	}
else
	AfxMessageBox(TEXT("Error: device not open"), MB_OK);

return;
}

void CNetworkTestDlg::OnSelChangeFilter() 
{
UpdateData(TRUE);

if (m_Device==-1)
	{
   AfxMessageBox(TEXT("Error: no device present"), MB_OK);
	return;
	}
if(Adapter.OpenInstance != NULL)
	{
   if (m_Filter != 0)
		{
		if(!PacketSetFilter((struct _ADAPTER *)Adapter.OpenInstance,Filters[m_Filter])) 
			{
			m_Filter = 0;
			AfxMessageBox(TEXT("Error: set filter failed"), MB_OK);
			}
		}
	else
      AfxMessageBox(TEXT("Error: set the filter to a valid mode"), MB_OK);
	}
else
	{
	m_Filter = 0;
	AfxMessageBox(TEXT("Error: device not open"), MB_OK);
	}
UpdateData(FALSE);
}


/*
int CMyAsyncSocket::Send(const void*lpBuf,int nBufLen,int nFlags)
{
BYTE m_FirstDSP,m_LastDSP,numDSP;
struct mgphdr *tx_mgp;
uint32 *pData;
char str[1000],str1[1000];
int  i,i1;

int res=CAsyncSocket::Send(lpBuf,nBufLen,nFlags);
tx_mgp=(struct mgphdr *)lpBuf;
pData=(uint32 *)((BYTE *)lpBuf+MGP_HLEN);
m_FirstDSP=((tx_mgp->DSPs[0]&0xF0)>>4)+((tx_mgp->DSPs[1]&0x0F)<<4);
m_LastDSP=tx_mgp->DSPs[2];
if (tx_mgp->op==MGP_OP_WRSAME_DSP || tx_mgp->op==MGP_OP_RESET_DEVICES || 
	 tx_mgp->op==MGP_OP_LOCK_FLASH || tx_mgp->op==MGP_OP_UNLOCK_FLASH || 
	 tx_mgp->op==MGP_OP_CLEAR_FLASH || tx_mgp->op==MGP_OP_WRITE_FLASH || 
	 tx_mgp->op==MGP_OP_WR_SCIMEASURE_RAM || tx_mgp->op==MGP_OP_CLEAR_SDRAM || 
	 tx_mgp->op==MGP_OP_WRSAME_SDRAM || tx_mgp->op==MGP_OP_CLEAR_SRAM || 
	 tx_mgp->op==MGP_OP_WRSAME_SRAM || tx_mgp->op==MGP_OP_WRSAME_DIAGBUFF)
	numDSP=1;
else if (tx_mgp->op==MGP_OP_RDSEQ_FLASH || tx_mgp->op==MGP_OP_WRSEQ_SDRAM || 
         tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_WRSEQ_SRAM || 
         tx_mgp->op==MGP_OP_RDSEQ_SRAM || tx_mgp->op==MGP_OP_WRSEQ_DIAGBUFF ||
			tx_mgp->op==MGP_OP_RDSEQ_DIAGBUFF)
	numDSP=(m_LastDSP>>1)-(m_FirstDSP>>1)+1;
else if (tx_mgp->op==MGP_OP_WRSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_DSP)
	numDSP=m_LastDSP-m_FirstDSP+1;
else
	numDSP=0;

// parser di visualizzazione del comando ethernet spedito
if (m_EnableOutput)
	{
	((COutputArea *)pOutputSend)->AddString("Ethernet packet sent:");
	sprintf(str,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x",tx_mgp->DSPs[0]&0x0F,m_FirstDSP,(tx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,tx_mgp->op,tx_mgp->len,tx_mgp->fl,tx_mgp->id,tx_mgp->saddr);
	((COutputArea *)pOutputSend)->AddString(str);
	strcpy(str,"Data sent ");
	if (!(tx_mgp->op==MGP_OP_RDSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_FLASH || 
			tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_RDSEQ_SRAM ||
			tx_mgp->op==MGP_OP_RDSEQ_DIAGBUFF))
		{
		for (i=0;i<tx_mgp->len*numDSP;)
			{
			for (i1=0;i1<7 && i<tx_mgp->len*numDSP-1;i++,i1++)
				{
				sprintf(str1,"%08x - ",pData[i]);
				strcat(str,str1);
				}
			sprintf(str1,"%08x",pData[i++]);
			strcat(str,str1);
			((COutputArea *)pOutputSend)->AddString(str);
			strcpy(str,"          ");
			}
		}
	}
/*if (m_fd)
	{
	// formato di uscita standard
	fprintf(m_fd,"Ethernet packet sent:\n");
	fprintf(m_fd,"First DSP %01x.%02x - Last DSP %01x.%02x - Cmd %02x - Data len %04x - Flags %02x - Cmd ID %02x - Start %08x\n",tx_mgp->DSPs[0]&0x0F,m_FirstDSP,(tx_mgp->DSPs[1]&0xF0)>>4,m_LastDSP,tx_mgp->op,tx_mgp->len,tx_mgp->fl,tx_mgp->id,tx_mgp->saddr);
	strcpy(str,"Data sent ");
	if (!(tx_mgp->op==MGP_OP_RDSEQ_DSP || tx_mgp->op==MGP_OP_RDSEQ_FLASH || 
			tx_mgp->op==MGP_OP_RDSEQ_SDRAM || tx_mgp->op==MGP_OP_RDSEQ_SRAM))
		{
		for (i=0;i<tx_mgp->len*numDSP;)
			{
			for (i1=0;i1<7 && i<tx_mgp->len*numDSP-1;i++,i1++)
				{
				sprintf(str1,"%08x - ",pData[i]);
				strcat(str,str1);
				}
			sprintf(str1,"%08x\n",pData[i++]);
			strcat(str,str1);
			fprintf(m_fd,str);
			strcpy(str,"          ");
			}
		}
	}*/
/*
return (res);
}
*/
