// OutputArea.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "OutputArea.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FONT_NAME    "Courier New"
#define FONT_HEIGHT  14
#define FONT_WIDTH   7
#define MAX_LINES    500

/////////////////////////////////////////////////////////////////////////////
// COutputArea
int CALLBACK EnumFontFamExProc(ENUMLOGFONT *lpelfe,      // pointer to logical-font data
                               NEWTEXTMETRICEX *lpntme,  // pointer to physical-font data
                               DWORD FontType,           // type of font
                               LPARAM lParam)            // application-defined data
{
// cerco i tre caratteri per la stampa
if (((CFont*)lParam)->m_hObject==0 && strcmp(lpelfe->elfLogFont.lfFaceName,FONT_NAME)==0)
	{
	lpelfe->elfLogFont.lfHeight=(long)(FONT_HEIGHT);
	lpelfe->elfLogFont.lfWidth=(long)(FONT_WIDTH);
	lpelfe->elfLogFont.lfWeight=FW_NORMAL;
	lpelfe->elfLogFont.lfItalic=0;
	((CFont*)lParam)->CreateFontIndirect(&lpelfe->elfLogFont);
	}
return(1);
}

IMPLEMENT_DYNCREATE(COutputArea, CFormView)

COutputArea::COutputArea()
	: CFormView(COutputArea::IDD)
{
	//{{AFX_DATA_INIT(COutputArea)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COutputArea::~COutputArea()
{
}

void COutputArea::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COutputArea)
	DDX_Control(pDX, IDC_LISTBOX, m_ListBox);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COutputArea, CFormView)
	//{{AFX_MSG_MAP(COutputArea)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COutputArea diagnostics

#ifdef _DEBUG
void COutputArea::AssertValid() const
{
	CFormView::AssertValid();
}

void COutputArea::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COutputArea message handlers

void COutputArea::OnSize(UINT nType, int cx, int cy) 
{
SIZE size;
CFormView::OnSize(nType, cx, cy);
	
size.cx=cx;
size.cy=cy;

SetScrollSizes(MM_TEXT,size);
if (m_ListBox.m_hWnd)
	m_ListBox.SetWindowPos(NULL,0,0,cx,cy,SWP_NOZORDER);
}

void COutputArea::OnInitialUpdate() 
{
SIZE     size;
RECT     rect;
LOGFONT  logfont;

CFormView::OnInitialUpdate();

// carico il font per il list box
logfont.lfCharSet=DEFAULT_CHARSET;
memset((void *)logfont.lfFaceName,0,sizeof(logfont.lfFaceName));
logfont.lfPitchAndFamily=0;
EnumFontFamiliesEx(GetDC()->m_hDC,                  // handle to device context
						 &logfont,                        // pointer to logical font information
						 (FONTENUMPROC)EnumFontFamExProc, // pointer to callback function
						 (LPARAM)&boxFont,                // application-supplied data
						 0);                              // reserved; must be zero
// aspetto che il font venga caricato
while(boxFont.m_hObject==0);

GetClientRect(&rect);

size.cx=rect.right;
size.cy=rect.bottom;

SetScrollSizes(MM_TEXT,size);
m_ListBox.SetWindowPos(NULL,0,0,size.cx,size.cy,SWP_NOZORDER);
m_ListBox.SetFont(&boxFont,TRUE);
}

void COutputArea::AddString(LPCTSTR lpszItem)
{
int i;

if (m_ListBox.m_hWnd)
	{
	i=m_ListBox.AddString(lpszItem);
	while (i>=MAX_LINES)
		i=m_ListBox.DeleteString(0);
	m_ListBox.SetCurSel(i);
	}
}
