// ReadDiagBuff_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "ReadDiagBuff_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReadDiagBuff_View

IMPLEMENT_DYNCREATE(CReadDiagBuff_View, CFormView)

CReadDiagBuff_View::CReadDiagBuff_View()
	: CFormView(CReadDiagBuff_View::IDD)
{
	//{{AFX_DATA_INIT(CReadDiagBuff_View)
	m_FirstDSP = 0;
	m_LastDSP = 0;
	m_StartAddress = 0;
	m_Size = 0;
	m_WantReply = TRUE;
	m_MultplePackets = TRUE;
	//}}AFX_DATA_INIT
}

CReadDiagBuff_View::~CReadDiagBuff_View()
{
}

void CReadDiagBuff_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadDiagBuff_View)
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Control(pDX, IDC_AREASIZE, m_SizeCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_HexText(pDX, IDC_AREASIZE, m_Size);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultplePackets);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReadDiagBuff_View, CFormView)
	//{{AFX_MSG_MAP(CReadDiagBuff_View)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadDiagBuff_View diagnostics

#ifdef _DEBUG
void CReadDiagBuff_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CReadDiagBuff_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReadDiagBuff_View message handlers

BOOL CReadDiagBuff_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CReadDiagBuff_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
m_SizeCtrl.LimitText(8);
}

DWORD CReadDiagBuff_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
struct mgphdr *tx_mgp;
BYTE   *packetID;
DWORD  start_addr,size,numPackets;

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;
if (m_FirstDSP==0xFF || m_FirstDSP==0xFE)
	numDSP = 1;
else
	numDSP = (m_LastDSP>>1) - (m_FirstDSP>>1) + 1;
size=m_Size<<2;

if (size && numDSP==1)
	{
	for (numPackets=0;numPackets<=(size-1)/MAX_MGP_DATA_SIZE;numPackets++)
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_RDSEQ_DIAGBUFF;
		if ((numPackets+1)*MAX_MGP_DATA_SIZE<size)
			tx_mgp->len=MAX_MGP_DATA_SIZE>>2;
		else
			tx_mgp->len=(uint16)((size-numPackets*MAX_MGP_DATA_SIZE)>>2);
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		(*bufferLen)[numPackets]=MGP_HLEN;
		start_addr+=tx_mgp->len;
		}
	}
else if (size)
	{
	if (((m_Size*numDSP)<<2)>MAX_MGP_DATA_SIZE)
		AfxMessageBox("Data length value not valid");
	else
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_RDSEQ_DIAGBUFF;
		tx_mgp->len=(uint16)m_Size;
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		(*bufferLen)[numPackets]=MGP_HLEN;
		start_addr+=tx_mgp->len;
		numPackets++;
		}
	}

return (numPackets);
}
