// ReadMMTDsp_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "ReadMMTDsp_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReadMMTDsp_View

IMPLEMENT_DYNCREATE(CReadMMTDsp_View, CFormView)

CReadMMTDsp_View::CReadMMTDsp_View()
	: CFormView(CReadMMTDsp_View::IDD)
{
	//{{AFX_DATA_INIT(CReadMMTDsp_View)
	m_FirstDSP = 0;
	m_LastDSP = 0;
	m_StartAddress = 0;
	m_Size = 4;
	m_WantReply = TRUE;
	m_MultplePackets = TRUE;
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\Lbt\\Codes\\LBT_EngPanel\\v2.00\\output.dat");
	m_ReplyToFile = FALSE;
	m_PmDm = FALSE;
	m_GenIrq = FALSE;
	m_GenRst= FALSE;
	//}}AFX_DATA_INIT
}

CReadMMTDsp_View::~CReadMMTDsp_View()
{
}
 
void CReadMMTDsp_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadMMTDsp_View)
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Control(pDX, IDC_AREASIZE, m_SizeCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_HexText(pDX, IDC_AREASIZE, m_Size);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultplePackets);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_REPLYTOFILE, m_ReplyToFile);
	DDX_Check(pDX, IDC_PMDM, m_PmDm);
	DDX_Check(pDX, IDC_GEN_IRQ, m_GenIrq);
	DDX_Check(pDX, IDC_GEN_RST, m_GenRst);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReadMMTDsp_View, CFormView)
	//{{AFX_MSG_MAP(CReadMMTDsp_View)
	ON_BN_CLICKED(IDC_REPLYTOFILE, OnReplyToFile)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadMMTDsp_View diagnostics

#ifdef _DEBUG
void CReadMMTDsp_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CReadMMTDsp_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReadMMTDsp_View message handlers

BOOL CReadMMTDsp_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CReadMMTDsp_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(4);
m_SizeCtrl.LimitText(4);

UpdateData(TRUE);

if (m_ReplyToFile)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	}
else
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	}
}

DWORD CReadMMTDsp_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
struct mgphdr *tx_mgp;
BYTE   *packetID;
WORD   start_addr,size,numPackets; 

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;
if (m_FirstDSP==0xFF || m_FirstDSP==0xFC || m_FirstDSP==0xFA || m_FirstDSP==0xF8)
	{
	AfxMessageBox("FirstDSP value not valid");
	size=0;
	}
else
	{
	numDSP = m_LastDSP - m_FirstDSP + 1;
	if (!m_PmDm)
		size=m_Size<<1; // dimensione in bytes
	else
		size=m_Size<<2; // dimensione in bytes
	}

if (size && numDSP==1)
	{
	for (numPackets=0;numPackets<=(size-1)/MAX_MGP_DATA_SIZE;numPackets++)
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_HL_RDSEQ_DSP;
		if ((numPackets+1)*MAX_MGP_DATA_SIZE<size)
			{
			if (!m_PmDm)
				tx_mgp->len=MAX_MGP_DATA_SIZE>>1;
			else
				tx_mgp->len=MAX_MGP_DATA_SIZE>>2;
			}
		else
			{
			if (!m_PmDm)
				tx_mgp->len=(size-numPackets*MAX_MGP_DATA_SIZE)>>1;
			else
				tx_mgp->len=(size-numPackets*MAX_MGP_DATA_SIZE)>>2;
			}
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		if (m_GenIrq)    tx_mgp->fl+=MGP_FL_HL_IRQ;
		if (m_GenRst)    tx_mgp->fl+=MGP_FL_HL_RESET;
		if (!m_PmDm)     tx_mgp->fl+=MGP_FL_HL_DMPM;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		(*bufferLen)[numPackets]=MGP_HLEN;
		start_addr+=tx_mgp->len;
		}
	}
else if (size)
	{
	if (size*numDSP>MAX_MGP_DATA_SIZE)
		AfxMessageBox("Data length value not valid");
	else
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_HL_RDSEQ_DSP;
		tx_mgp->len=m_Size;
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		if (m_GenIrq)    tx_mgp->fl+=MGP_FL_HL_IRQ;
		if (m_GenRst)    tx_mgp->fl+=MGP_FL_HL_RESET;
		if (!m_PmDm)     tx_mgp->fl+=MGP_FL_HL_DMPM;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=m_StartAddress;
		(*bufferLen)[numPackets]=MGP_HLEN;
		numPackets++;
		}
	}

return (numPackets);
}

void CReadMMTDsp_View::OnReplyToFile() 
{
UpdateData(TRUE);

if (m_ReplyToFile)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	}
else
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	}
}

void CReadMMTDsp_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Data file name";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}
