// ReadSdram_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "ReadSdram_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//#define MAX_MGP_DATA_SIZE_LOC MAX_MGP_DATA_SIZE
#define MAX_MGP_DATA_SIZE_LOC JUMBO_MAX_MGP_DATA_SIZE

/////////////////////////////////////////////////////////////////////////////
// CReadSdram_View

IMPLEMENT_DYNCREATE(CReadSdram_View, CFormView)

CReadSdram_View::CReadSdram_View()
	: CFormView(CReadSdram_View::IDD)
{
	//{{AFX_DATA_INIT(CReadSdram_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0;
	m_Size = 0;
	m_WantReply = TRUE;
	m_MultplePackets = TRUE;
	m_FileName = _T("S:\\Ausil\\Mario\\sdrma_output.dat");
	m_ReplyToFile = FALSE;
	//}}AFX_DATA_INIT
}

CReadSdram_View::~CReadSdram_View()
{
}

void CReadSdram_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReadSdram_View)
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Control(pDX, IDC_AREASIZE, m_SizeCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_HexText(pDX, IDC_AREASIZE, m_Size);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultplePackets);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_REPLYTOFILE, m_ReplyToFile);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReadSdram_View, CFormView)
	//{{AFX_MSG_MAP(CReadSdram_View)
	ON_BN_CLICKED(IDC_REPLYTOFILE, OnReplyToFile)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReadSdram_View diagnostics

#ifdef _DEBUG
void CReadSdram_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CReadSdram_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReadSdram_View message handlers

BOOL CReadSdram_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CReadSdram_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
m_SizeCtrl.LimitText(8);

UpdateData(TRUE);

if (m_ReplyToFile)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	}
else
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	}
}

DWORD CReadSdram_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
struct mgphdr *tx_mgp;
BYTE   *packetID;
DWORD  start_addr,size,numPackets;

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;
if (m_FirstDSP==0xFF || m_FirstDSP==0xFE)
	numDSP = 1;
else
	numDSP = (m_LastDSP>>1) - (m_FirstDSP>>1) + 1;
size=m_Size<<2;

if (size && numDSP==1)
	{
	for (numPackets=0;numPackets<=(size-1)/MAX_MGP_DATA_SIZE_LOC;numPackets++)
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_RDSEQ_SDRAM;
		if ((numPackets+1)*MAX_MGP_DATA_SIZE_LOC<size)
			tx_mgp->len=MAX_MGP_DATA_SIZE_LOC>>2;
		else
			tx_mgp->len=(uint16)((size-numPackets*MAX_MGP_DATA_SIZE_LOC)>>2);
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		(*bufferLen)[numPackets]=MGP_HLEN;
		start_addr+=tx_mgp->len;
		}
	}
else if (size)
	{
	if (((m_Size*numDSP)<<2)>MAX_MGP_DATA_SIZE_LOC)
		AfxMessageBox("Data length value not valid");
	else
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE_LOC+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		tx_mgp->op=MGP_OP_RDSEQ_SDRAM;
		tx_mgp->len=(uint16)m_Size;
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		(*bufferLen)[numPackets]=MGP_HLEN;
		start_addr+=tx_mgp->len;
		numPackets++;
		}
	}

return (numPackets);
}

void CReadSdram_View::OnReplyToFile() 
{
UpdateData(TRUE);

if (m_ReplyToFile)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	}
else
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	}
}

void CReadSdram_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Data file name";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}
