// RelaisBoard_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "RelaisBoard_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRelaisBoard_View

IMPLEMENT_DYNCREATE(CRelaisBoard_View, CFormView)

CRelaisBoard_View::CRelaisBoard_View()
	: CFormView(CRelaisBoard_View::IDD)
{
	//{{AFX_DATA_INIT(CRelaisBoard_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_RelaisOutput = 0;
	m_RelaisOutput1 = 0;
	m_EnaRelaisBoard1 = 0;
	m_WantReply    = TRUE;
	//}}AFX_DATA_INIT
}

CRelaisBoard_View::~CRelaisBoard_View()
{
}

void CRelaisBoard_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRelaisBoard_View)
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_RELAISOUTPUT, m_RelaisOutputCtrl);
	DDX_Control(pDX, IDC_RELAISOUTPUT1, m_RelaisOutputCtrl1);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_RELAISOUTPUT, m_RelaisOutput);
	DDX_HexText(pDX, IDC_RELAISOUTPUT1, m_RelaisOutput1);
	DDX_Check(pDX, IDC_ENARELAISBOARD1, m_EnaRelaisBoard1);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRelaisBoard_View, CFormView)
	//{{AFX_MSG_MAP(CRelaisBoard_View)
	ON_BN_CLICKED(IDC_ENARELAISBOARD1, OnEnaRelaisBoard1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRelaisBoard_View diagnostics

#ifdef _DEBUG
void CRelaisBoard_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CRelaisBoard_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CRelaisBoard_View message handlers

BOOL CRelaisBoard_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CRelaisBoard_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();

UpdateData(TRUE);

m_RelaisOutputCtrl.LimitText(8);
m_RelaisOutputCtrl1.LimitText(8);

if (m_EnaRelaisBoard1)
	m_RelaisOutputCtrl1.EnableWindow(TRUE);
else
	m_RelaisOutputCtrl1.EnableWindow(FALSE);
}

DWORD CRelaisBoard_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;

UpdateData(TRUE);

if (m_FirstDSP==0xFF)
	numDSP = 1;
else
	{
	AfxMessageBox("Input firstDSP, only BCU board is allowed");
	return (0);
	}

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*1);
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*1);
// alloco il (*buffer) a dimensione massima
(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[0],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[0];
pData=(uint32 *)((*buffer)[0]+MGP_HLEN);
tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_WRRD_RELAIS_BOARD;
if (m_EnaRelaisBoard1)
	tx_mgp->len=3;
else
	tx_mgp->len=2;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0;
pData[0]=1;
pData[1]=m_RelaisOutput;
pData[2]=m_RelaisOutput1;
(*bufferLen)[0]=MGP_HLEN+tx_mgp->len*4;;

return (1);
}

void CRelaisBoard_View::OnEnaRelaisBoard1()
{
UpdateData(TRUE);
if (m_EnaRelaisBoard1)
	m_RelaisOutputCtrl1.EnableWindow(TRUE);
else
	m_RelaisOutputCtrl1.EnableWindow(FALSE);
}