// Reset_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "Reset_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CReset_View

IMPLEMENT_DYNCREATE(CReset_View, CFormView)

CReset_View::CReset_View()
	: CFormView(CReset_View::IDD)
{
	//{{AFX_DATA_INIT(CReset_View)
	m_FirstDSP       = -1;
	m_LastDSP        = -1;
	m_WantReply      = TRUE;
	m_ResetCrate     = FALSE;
	m_ResetDspBoards = FALSE;
	m_ResetBoard     = FALSE;
	m_ResetFpga      = FALSE;
	m_ResetFlash     = FALSE;
	m_ResetDsp0      = FALSE;
	m_ResetDsp1      = FALSE;
	m_ResetEthernet  = FALSE;
	m_EnaPower       = FALSE;
	m_DisPower       = FALSE;
	//}}AFX_DATA_INIT
}

CReset_View::~CReset_View()
{
}

void CReset_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CReset_View)
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_RESET_CRATE, m_ResetCrate);
	DDX_Check(pDX, IDC_RESET_DSP_BOARDS, m_ResetDspBoards);
	DDX_Check(pDX, IDC_RESET_BOARD, m_ResetBoard);
	DDX_Check(pDX, IDC_RESET_FPGA, m_ResetFpga);
	DDX_Check(pDX, IDC_RESET_FLASH, m_ResetFlash);
	DDX_Check(pDX, IDC_RESET_DSP0, m_ResetDsp0);
	DDX_Check(pDX, IDC_RESET_DSP1, m_ResetDsp1);
	DDX_Check(pDX, IDC_RESET_ETH, m_ResetEthernet);
	DDX_Check(pDX, IDC_ENA_POWER, m_EnaPower);
	DDX_Check(pDX, IDC_DIS_POWER, m_DisPower);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CReset_View, CFormView)
	//{{AFX_MSG_MAP(CReset_View)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CReset_View diagnostics

#ifdef _DEBUG
void CReset_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CReset_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CReset_View message handlers

BOOL CReset_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CReset_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
}

DWORD CReset_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;

(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*1);
(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*1);
// alloco il (*buffer) a dimensione massima
(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
memset((*buffer)[0],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
tx_mgp=(struct mgphdr *)(*buffer)[0];
pData=(uint32 *)((*buffer)[0]+MGP_HLEN);

tx_mgp->DSPs[0]=m_FirstDSP<<4;
tx_mgp->DSPs[1]=m_FirstDSP>>4;
tx_mgp->DSPs[2]=m_LastDSP;
tx_mgp->op=MGP_OP_RESET_DEVICES;
tx_mgp->len=1;
tx_mgp->fl=0;
if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
tx_mgp->id=(*packetID)++;
tx_mgp->saddr=0;
pData[0]=0;
if (m_ResetCrate)
	pData[0]+=(2<<0);
if (m_ResetDspBoards)
	pData[0]+=(2<<2);
if (m_ResetBoard)
	pData[0]+=(2<<4);
if (m_ResetFpga)
	pData[0]+=(2<<6);
if (m_ResetFlash)
	pData[0]+=(2<<8);
if (m_ResetDsp0)
	pData[0]+=(2<<10);
if (m_ResetDsp1)
	pData[0]+=(2<<12);
if (m_ResetEthernet)
	pData[0]+=(2<<14);

if (m_EnaPower)
	pData[0]+=(1<<17);
if (m_DisPower)
	pData[0]+=(1<<16);

(*bufferLen)[0]=MGP_HLEN+tx_mgp->len*4;

return (1);
}
