// SetBCUIP_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "SetBCUIP_View.h"
#include "MainFrm.h"
#include "eth.h"
#include "ip.h"
#include "ipass.h"
#include "OutputArea.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSetBCUIP_View

IMPLEMENT_DYNCREATE(CSetBCUIP_View, CFormView)

CSetBCUIP_View::CSetBCUIP_View()
	: CFormView(CSetBCUIP_View::IDD)
{
	//{{AFX_DATA_INIT(CSetBCUIP_View)
	m_MACAddress1 = 0x00;
	m_MACAddress2 = 0x20;
	m_MACAddress3 = 0xaf;
	m_MACAddress4 = 0xf4;
	m_MACAddress5 = 0xcc;
	m_MACAddress6 = 0x01;
	//}}AFX_DATA_INIT
}

CSetBCUIP_View::~CSetBCUIP_View()
{
}

void CSetBCUIP_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSetBCUIP_View)
	DDX_HexText(pDX, IDC_MACADDRESS1, m_MACAddress1);
	DDX_HexText(pDX, IDC_MACADDRESS2, m_MACAddress2);
	DDX_HexText(pDX, IDC_MACADDRESS3, m_MACAddress3);
	DDX_HexText(pDX, IDC_MACADDRESS4, m_MACAddress4);
	DDX_HexText(pDX, IDC_MACADDRESS5, m_MACAddress5);
	DDX_HexText(pDX, IDC_MACADDRESS6, m_MACAddress6);
	DDX_Control(pDX, IDC_MACADDRESS1, m_MACAddress1Ctrl);
	DDX_Control(pDX, IDC_MACADDRESS2, m_MACAddress2Ctrl);
	DDX_Control(pDX, IDC_MACADDRESS3, m_MACAddress3Ctrl);
	DDX_Control(pDX, IDC_MACADDRESS4, m_MACAddress4Ctrl);
	DDX_Control(pDX, IDC_MACADDRESS5, m_MACAddress5Ctrl);
	DDX_Control(pDX, IDC_MACADDRESS6, m_MACAddress6Ctrl);
	DDX_Control(pDX, IDC_IPADDRESS, m_IPAddressCtrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSetBCUIP_View, CFormView)
	//{{AFX_MSG_MAP(CSetBCUIP_View)
	ON_BN_CLICKED(IDC_SETIP, OnSetIP)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSetBCUIP_View diagnostics

#ifdef _DEBUG
void CSetBCUIP_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CSetBCUIP_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSetBCUIP_View message handlers

BOOL CSetBCUIP_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CSetBCUIP_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();

m_MACAddress1Ctrl.LimitText(2);
m_MACAddress2Ctrl.LimitText(2);
m_MACAddress3Ctrl.LimitText(2);
m_MACAddress4Ctrl.LimitText(2);
m_MACAddress5Ctrl.LimitText(2);
m_MACAddress6Ctrl.LimitText(2);

m_IPAddressCtrl.SetWindowText("192.168.0.51");
}

void CSetBCUIP_View::OnSetIP()
{
char            str[100];
char            *pChar,*pChar1;
struct ethhdr   *tx_eth;
struct ipasshdr *tx_ipass;
DWORD           val,i;

CMainFrame *pMainFrame=(CMainFrame *)(GetParent()->GetParent()->GetParent());

UpdateData(TRUE);

tx_eth = (struct ethhdr *)pMainFrame->socket.Adapter.lpMem2;
tx_eth->h_dest[0] = m_MACAddress1;
tx_eth->h_dest[1] = m_MACAddress2;
tx_eth->h_dest[2] = m_MACAddress3;
tx_eth->h_dest[3] = m_MACAddress4;
tx_eth->h_dest[4] = m_MACAddress5;
tx_eth->h_dest[5] = m_MACAddress6;
memcpy(tx_eth->h_source,pMainFrame->socket.local_eth_addr,ETH_ALEN);
tx_eth->h_proto=ETH_P_IPASS;

tx_ipass = (struct ipasshdr *)(pMainFrame->socket.Adapter.lpMem2 + ETH_HLEN);
tx_ipass->ipass_op=IPASS_OP_SET;
memcpy(tx_ipass->ipass_sha,pMainFrame->socket.local_eth_addr,ETH_ALEN);
memcpy(tx_ipass->ipass_sip,&pMainFrame->socket.local_ip_addr,IP_ALEN);
memcpy(tx_ipass->ipass_tha,tx_eth->h_dest,ETH_ALEN);

m_IPAddressCtrl.GetWindowText(str,sizeof(str));
val=0;
pChar = pChar1 = str;
for (i=0;i<4;i++)
	{
	while(*pChar!='.' && *pChar!='\0')
		pChar++;
	*(pChar++)='\0';
	val += atoi(pChar1) * 1 << (i * 8);
	pChar1=pChar;
	}
memcpy(tx_ipass->ipass_tip,&val,IP_ALEN);

if (pMainFrame->socket.PacketSend(ETH_HLEN+IPASS_HLEN))
	{
	sprintf(str,"BCU IP assign command sent");
	((COutputArea *)pMainFrame->socket.pOutputSend)->AddString(str);
	}
else
	{
	sprintf(str,"BCU IP assign command fault");
	((COutputArea *)pMainFrame->socket.pOutputSend)->AddString(str);
	}
}
