// ThroughputTest_View.cpp : implementation file
//

#include "stdafx.h"
#include "lbt_engpanel.h"
#include "ThroughputTest_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CThroughputTest_View

IMPLEMENT_DYNCREATE(CThroughputTest_View, CFormView)

CThroughputTest_View::CThroughputTest_View()
	: CFormView(CThroughputTest_View::IDD)
{
	//{{AFX_DATA_INIT(CThroughputTest_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0x080000;
	m_Size = 364;
	m_NumIter = 1000000;
	m_DeviceSel = 0;
	m_OutText1 = _T("");
	m_OutText2 = _T("");
	m_OutText3 = _T("");
	m_OutText4 = _T("");
	m_OutText5 = _T("");
	m_Text = _T("");
	//}}AFX_DATA_INIT
}

CThroughputTest_View::~CThroughputTest_View()
{
}

void CThroughputTest_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CThroughputTest_View)
	DDX_Control(pDX, IDC_PROGRESS, m_Progress);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Control(pDX, IDC_AREASIZE, m_SizeCtrl);
	DDX_Control(pDX, IDC_NUMITER, m_NumIterCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_HexText(pDX, IDC_AREASIZE, m_Size);
	DDX_Text(pDX, IDC_NUMITER, m_NumIter);
	DDX_Radio(pDX, IDC_DEVICESEL, m_DeviceSel);
	DDX_Text(pDX, IDC_OUTTEXT1, m_OutText1);
	DDX_Text(pDX, IDC_OUTTEXT2, m_OutText2);
	DDX_Text(pDX, IDC_OUTTEXT3, m_OutText3);
	DDX_Text(pDX, IDC_OUTTEXT4, m_OutText4);
	DDX_Text(pDX, IDC_OUTTEXT5, m_OutText5);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CThroughputTest_View, CFormView)
	//{{AFX_MSG_MAP(CThroughputTest_View)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_UPDATE_PROGRESS, OnUpdateProgress)
	ON_MESSAGE(WM_SET_PROGRESS, OnSetProgress)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CThroughputTest_View diagnostics

#ifdef _DEBUG
void CThroughputTest_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CThroughputTest_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CThroughputTest_View message handlers

BOOL CThroughputTest_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CThroughputTest_View::OnInitialUpdate() 
{
CRect rect;

CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
m_SizeCtrl.LimitText(4);
m_NumIterCtrl.LimitText(8);

m_Progress.SetPos(0);

//GetParent()->GetClientRect(&rect);
//SetWindowPos(NULL,0,0,rect.right+1,rect.bottom+1,SWP_NOZORDER|SWP_NOMOVE);
}

LRESULT CThroughputTest_View::OnUpdateProgress(PROGRESS_PACKET *pUpdateData,LPARAM dummy2)
{
UpdateData(TRUE);
m_OutText1.Format("%.3e",pUpdateData->numBitSent);
m_OutText2.Format("%02d:%02d:%02d.%03d",pUpdateData->elapsedTime/3600000,(pUpdateData->elapsedTime/60000)-(pUpdateData->elapsedTime/3600000)*60,(pUpdateData->elapsedTime/1000)-(pUpdateData->elapsedTime/60000)*60,pUpdateData->elapsedTime%1000);
m_OutText3.Format("%d",pUpdateData->numPacketLost);
m_OutText4.Format("%d",pUpdateData->numCmdReplyFault);
if (pUpdateData->elapsedTime)
	m_OutText5.Format("%5.3f",pUpdateData->numBitSent/(double)pUpdateData->elapsedTime/1000.);
else
	m_OutText5.Format("");
UpdateData(FALSE);
m_Progress.SetPos(pUpdateData->progressCount);
return (0);
}

LRESULT CThroughputTest_View::OnSetProgress(UINT range,LPARAM dummy2)
{
UpdateData(TRUE);
if (range==-1)
	{ // reset
	m_Text="";
	m_Progress.SetPos(0);
	}
else
	{ // reset
	m_Text="Read Throughput Test in process...";
	m_Progress.SetRange32(0,range);
	m_Progress.SetPos(0);
	}
UpdateData(FALSE);
return (0);
}
