// WriteFlash_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteFlash_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriteFlash_View

IMPLEMENT_DYNCREATE(CWriteFlash_View, CFormView)

CWriteFlash_View::CWriteFlash_View()
	: CFormView(CWriteFlash_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteFlash_View)
	m_FileName = _T("LBTLogic_test.rbf");
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_Block = 0;
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	//}}AFX_DATA_INIT
	m_FileExt = _T("");
}

CWriteFlash_View::~CWriteFlash_View()
{
}

void CWriteFlash_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteFlash_View)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	DDX_Control(pDX, IDC_BLOCK, m_BlockCtrl);
	DDX_CBIndex(pDX, IDC_BLOCK, m_Block);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWriteFlash_View, CFormView)
	//{{AFX_MSG_MAP(CWriteFlash_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_CBN_SELCHANGE(IDC_BLOCK, OnSelChangeBlock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteFlash_View diagnostics

#ifdef _DEBUG
void CWriteFlash_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteFlash_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteFlash_View message handlers

BOOL CWriteFlash_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteFlash_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);

m_BlockCtrl.AddString("Default Logic");
m_BlockCtrl.AddString("User Logic");
m_BlockCtrl.AddString("Default Program");
m_BlockCtrl.AddString("User Program");
m_BlockCtrl.AddString("Configuration Area");

m_BlockCtrl.SetCurSel(0);
}

DWORD CWriteFlash_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
DWORD  start_addr,numPackets;
DWORD  i,i1;
char   tmpbuff[200];

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;

// determino la lunghezza del file binario
fd=fopen(m_FileName,"rb");
if (!fd)
	{
	AfxMessageBox("Input file name not valid");
	return (0);
	}

if (m_Block==0)      // default logic
	start_addr=DEFAULT_LOGIC_SADDR/4;
else if (m_Block==1) // user logic
	start_addr=USER_LOGIC_SADDR/4;
else if (m_Block==2) // default program
	start_addr=DEFAULT_PRG_SADDR/4;
else if (m_Block==3) // user program
	start_addr=USER_PRG_SADDR/4;
else if (m_Block==4) // configuration area
	start_addr=CONFIG_AREA_SADDR/4;

do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	tx_mgp->op=MGP_OP_WRITE_FLASH;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	i=0;
	if (m_FileExt=="dat")
		{
		while (i<MAX_MGP_DATA_SIZE>>2)
			{
			memset(tmpbuff,0,sizeof(tmpbuff));
			if (!GetFileLine(fd,tmpbuff,sizeof(tmpbuff)))
				{ // linea non valida troppo lunga!!!
				AfxMessageBox("Invalid data file format");
				goto end;
				}
			if (tmpbuff[0]==EOF)
				break;
			pData[i]=0;
			strlwr(tmpbuff);
			if (tmpbuff[0]=='#')
				{
				}
			// dat file mio formato hex (0x00000000)
			else if (tmpbuff[0]=='0' && tmpbuff[1]=='x')
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='a' && tmpbuff[2+i1]<='f')
						{
						pData[i]=pData[i]*16+tmpbuff[2+i1]-'a'+10;
						i1++;
						}
					else if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						pData[i]=pData[i]*16+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						i++;
						break;
						}
					else
						break;
					}
				}
			// dat file nios formato (@00000000 00000000)
			else if (tmpbuff[0]=='@')
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[10+i1]>='a' && tmpbuff[10+i1]<='f')
						{
						pData[i]=pData[i]*16+tmpbuff[10+i1]-'a'+10;
						i1++;
						}
					else if (tmpbuff[10+i1]>='0' && tmpbuff[10+i1]<='9')
						{
						pData[i]=pData[i]*16+tmpbuff[10+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						i++;
						break;
						}
					else
						break;
					}
				}
			// dat file mio formato decimale
			else
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						pData[i]=pData[i]*10+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						i++;
						break;
						}
					else
						break;
					}
				}
			}
		(*bufferLen)[numPackets]=i*4;
		}
	else if (m_FileExt=="bin" || m_FileExt=="rbf") // lettura file binario
		{
		(*bufferLen)[numPackets]=fread(pData,sizeof(BYTE),MAX_MGP_DATA_SIZE,fd);
		(*bufferLen)[numPackets]=(*bufferLen)[numPackets]-((*bufferLen)[numPackets]-1)%4+3;
		}
	tx_mgp->len=(*bufferLen)[numPackets]/4;
	start_addr+=tx_mgp->len;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

end:
fclose(fd);

return (numPackets);
}

void CWriteFlash_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Raw binary files (*.rbf)|*.rbf|Binary files (*.bin)|*.bin|Dat files (*.dat)|*.dat||",NULL);

dlg.m_ofn.lpstrTitle="Select file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
m_FileExt=dlg.GetFileExt();
m_FileExt.MakeLower();
if (((m_Block==0 || m_Block==1) && m_FileExt!="rbf") ||
	 ((m_Block==2 || m_Block==3) && m_FileExt!="bin") ||
	 (m_Block==4 && m_FileExt!="dat"))
	AfxMessageBox("Invalid file Extension");
else
	UpdateData(FALSE);
}

void CWriteFlash_View::OnSelChangeBlock() 
{
UpdateData(TRUE);

if (m_Block==0 || m_Block==1)
	m_FileExt="rbf";
else if (m_Block==2 || m_Block==3)
	m_FileExt="bin";
else if (m_Block==4)
	m_FileExt="dat";
}
