// WriteFpgaRam_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteFpgaRam_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriteFpgaRam_View

IMPLEMENT_DYNCREATE(CWriteFpgaRam_View, CFormView)

CWriteFpgaRam_View::CWriteFpgaRam_View()
	: CFormView(CWriteFpgaRam_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteFpgaRam_View)
	m_FileName = _T("");
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0;
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	m_RamBlock = 0;
	m_Text = _T("");
	//}}AFX_DATA_INIT
m_FileNameScimeasure = _T("Scimeasure.dat");
m_FileNameSigGen = _T("SigGen.dat");
m_FileNameWaveGen = _T("WaveGenerator_default_setup.dat");
}

CWriteFpgaRam_View::~CWriteFpgaRam_View()
{
}

void CWriteFpgaRam_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteFpgaRam_View)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	DDX_CBIndex(pDX, IDC_RAMBLOCK, m_RamBlock);
	DDX_Text(pDX, IDC_TEXT, m_Text);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWriteFpgaRam_View, CFormView)
	//{{AFX_MSG_MAP(CWriteFpgaRam_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_CBN_SELCHANGE(IDC_RAMBLOCK, OnSelChangeRamBlock)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteFpgaRam_View diagnostics

#ifdef _DEBUG
void CWriteFpgaRam_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteFpgaRam_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteFpgaRam_View message handlers

BOOL CWriteFpgaRam_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteFpgaRam_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();

UpdateData(TRUE);

m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);

m_RamBlock = 0;
m_FileName = m_FileNameScimeasure;
m_Text     = "valid start address range: from 0x00000000 to 0x00004000";

UpdateData(FALSE);
}

DWORD CWriteFpgaRam_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets;
char   tmpbuff[100];

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;

if      (m_RamBlock==0 && m_FirstDSP!=0xFF)
	{
	AfxMessageBox("Command available on the BCU board only\n");
	return (numPackets);
	}
else if (m_RamBlock==1 && m_FirstDSP!=0xFC && m_FirstDSP!=0xF8)
	{
	AfxMessageBox("Command available on the SigGen or Accel board only\n");
	return (numPackets);
	}
else if (m_RamBlock==2 && m_FirstDSP!=0xFA)
	{
	AfxMessageBox("Command available on the WaveGen board only\n");
	return (numPackets);
	}

// determino la lunghezza del file binario
fd=fopen(m_FileName,"rt");
if (!fd)
	{
	AfxMessageBox("Input file name not valid");
	return (numPackets);
	}

do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	if (m_RamBlock==0)
		tx_mgp->op=MGP_OP_WR_SCIMEASURE_RAM;
	else if (m_RamBlock==1)
		tx_mgp->op=MGP_OP_WRITE_SIGGEN_RAM;
	else if (m_RamBlock==2)
		tx_mgp->op=MGP_OP_WRITE_WAVEGEN_RAM;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	// lettura del data file
	i=0;
	while (i<MAX_MGP_DATA_SIZE>>2 && fscanf(fd,"%s",tmpbuff)!=-1)
		{
		if (ConvertString(tmpbuff,(DWORD *)&pData[i]))
			i++;
		}
	(*bufferLen)[numPackets]=i*4;
	tx_mgp->len=i;
	start_addr+=i;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

fclose(fd);

return (numPackets);
}

void CWriteFpgaRam_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select data file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
if (m_RamBlock==0)
	m_FileNameScimeasure = m_FileName;
else if (m_RamBlock==1)
	m_FileNameSigGen = m_FileName;
else if (m_RamBlock==2)
	m_FileNameWaveGen = m_FileName;
UpdateData(FALSE);
}

BOOL CWriteFpgaRam_View::ConvertString(char *buff,DWORD *val32)
{
int   i1;

strlwr(buff);
*val32=0;
if (buff[0]=='0' && buff[1]=='x')
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='a' && buff[2+i1]<='f')
			{
			*val32=*val32*16+buff[2+i1]-'a'+10;
			i1++;
			}
		else if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*16+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
else
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*10+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
return FALSE;
}

void CWriteFpgaRam_View::OnSelChangeRamBlock() 
{
UpdateData(TRUE);

if (m_RamBlock==0)
	{
	m_FileName = m_FileNameScimeasure;
	m_Text = "valid start address range: from 0x00000000 to 0x00001000";
	}
else if (m_RamBlock==1)
	{
	m_FileName = m_FileNameSigGen;
	m_Text = "valid start address range: from 0x00000000 to 0x00000008";
	}
else if (m_RamBlock==2)
	{
	m_FileName = m_FileNameWaveGen;
	m_Text = "valid start address range: from 0x00000000 to 0x00004000";
	}
		
UpdateData(FALSE);
}
