// WriteMMTDsp_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteMMTDsp_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriteMMTDsp_View

IMPLEMENT_DYNCREATE(CWriteMMTDsp_View, CFormView)

CWriteMMTDsp_View::CWriteMMTDsp_View()
	: CFormView(CWriteMMTDsp_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteMMTDsp_View)
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\Lbt\\Codes\\LBT_EngPanel\\v2.00\\pippo1.dat");
	m_FirstDSP = 0;
	m_LastDSP = 0;
	m_StartAddress = 0;
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	m_SingleValue0 = 0;
	m_WriteSelection = 0;
	m_PmDm = FALSE;
	m_GenIrq = FALSE;
	m_GenRst= FALSE;
	//}}AFX_DATA_INIT
	m_wrsame = FALSE;
}

CWriteMMTDsp_View::~CWriteMMTDsp_View()
{
}

void CWriteMMTDsp_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteMMTDsp_View)
	DDX_Control(pDX, IDC_RADIO_FILE, m_WriteSelection0Ctrl);
	DDX_Control(pDX, IDC_RADIO_SINGLE, m_WriteSelection1Ctrl);
	DDX_Control(pDX, IDC_SINGLEVALUE0, m_SingleValue0Ctrl);
	DDX_Control(pDX, IDC_FILENAME, m_FileNameCtrl);
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	DDX_HexText(pDX, IDC_SINGLEVALUE0, m_SingleValue0);
	DDX_Radio(pDX, IDC_RADIO_FILE, m_WriteSelection);
	DDX_Check(pDX, IDC_PMDM, m_PmDm);
	DDX_Check(pDX, IDC_GEN_IRQ, m_GenIrq);
	DDX_Check(pDX, IDC_GEN_RST, m_GenRst);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWriteMMTDsp_View, CFormView)
	//{{AFX_MSG_MAP(CWriteMMTDsp_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	ON_BN_CLICKED(IDC_RADIO_FILE, OnRadioFile)
	ON_BN_CLICKED(IDC_RADIO_SINGLE, OnRadioSingle)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_PMDM, OnPmDm)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteMMTDsp_View diagnostics

#ifdef _DEBUG
void CWriteMMTDsp_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteMMTDsp_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteMMTDsp_View message handlers

BOOL CWriteMMTDsp_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteMMTDsp_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(4);
m_SingleValue0Ctrl.LimitText(4);

UpdateData(TRUE);

if (m_WriteSelection==0)
	{
	m_Browse.EnableWindow(TRUE);
	m_FileNameCtrl.EnableWindow(TRUE);
	m_SingleValue0Ctrl.EnableWindow(FALSE);
	}
else if (m_WriteSelection==1)
	{
	m_Browse.EnableWindow(FALSE);
	m_FileNameCtrl.EnableWindow(FALSE);
	m_SingleValue0Ctrl.EnableWindow(TRUE);
	}
}

DWORD CWriteMMTDsp_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData32,val;
uint16 *pData16;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets,i1;
char   tmpbuff[100];

UpdateData(TRUE);

if (m_FirstDSP==0xFF || m_FirstDSP==0xFC || m_FirstDSP==0xFA || m_FirstDSP==0xF8)
	{
	AfxMessageBox("FirstDSP value not valid");
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=0;
	m_WriteSelection=-1;
	}
else if (m_wrsame==TRUE)
	numDSP = 1;
else
	numDSP = m_LastDSP - m_FirstDSP + 1;

if (numDSP == 1)
	m_wrsame=TRUE;

if (m_WriteSelection==0)
	{
	packetID=(BYTE *)(*bufferLen);
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=0;
	start_addr=m_StartAddress;

	// determino la lunghezza del file binario
	fd=fopen(m_FileName,"rt");
	if (!fd)
		{
		AfxMessageBox("Input file name not valid");
		return (0);
		}
	do
		{
		(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
		(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
		// alloco il (*buffer) a dimensione massima
		(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
		memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
		tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
		if (!m_PmDm)
			pData16=(uint16 *)((*buffer)[numPackets]+MGP_HLEN);
		else
			pData32=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
		tx_mgp->DSPs[0]=m_FirstDSP<<4;
		tx_mgp->DSPs[1]=m_FirstDSP>>4;
		tx_mgp->DSPs[2]=m_LastDSP;
		if (m_wrsame==TRUE)
			tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
		else
			tx_mgp->op=MGP_OP_HL_WRSEQ_DSP;
		tx_mgp->fl=0;
		if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
		if (m_GenIrq)    tx_mgp->fl+=MGP_FL_HL_IRQ;
		if (m_GenRst)    tx_mgp->fl+=MGP_FL_HL_RESET;
		if (!m_PmDm)     tx_mgp->fl+=MGP_FL_HL_DMPM;
		tx_mgp->id=(*packetID)++;
		tx_mgp->saddr=start_addr;
		// lettura del data file
		i=val=0;
		while (val<MAX_MGP_DATA_SIZE && fscanf(fd,"%s",tmpbuff)!=-1)
			{
			val=0;
			strlwr(tmpbuff);
			if (tmpbuff[0]=='#')
				{
				}
			else if (tmpbuff[0]=='0' && tmpbuff[1]=='x')
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='a' && tmpbuff[2+i1]<='f')
						{
						val=val*16+tmpbuff[2+i1]-'a'+10;
						i1++;
						}
					else if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						val=val*16+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						if (m_PmDm)
							pData32[i]=val&0x00FFFFFF;
						else
							pData16[i]=val&0x0000FFFF;
						i++;
						break;
						}
					else
						break;
					}
				}
			else
				{
				i1=0;
				while (1)
					{
					if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
						{
						val=val*10+tmpbuff[2+i1]-'0';
						i1++;
						}
					else if (i1!=0)
						{
						if (m_PmDm)
							pData32[i]=val&0x00FFFFFF;
						else
							pData16[i]=val&0x0000FFFF;;
						i++;
						break;
						}
					else
						break;
					}
				}
			if (!m_PmDm)
				val=i<<1;
			else
				val=i<<2;
			}
		i/=numDSP;
		if (!m_PmDm)
			(*bufferLen)[numPackets]=i*2*numDSP;
		else
			(*bufferLen)[numPackets]=i*4*numDSP;
		if ((*bufferLen)[numPackets]%4)
			(*bufferLen)[numPackets]+=(4-(*bufferLen)[numPackets]%4);
		tx_mgp->len=i;
		start_addr+=i;
		(*bufferLen)[numPackets]+=MGP_HLEN;
		}
	while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

	fclose(fd);
	}
else if (m_WriteSelection==1)
	{
	packetID=(BYTE *)(*bufferLen);
	(*buffer)=NULL;
	(*bufferLen)=NULL;
	numPackets=1;
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*numPackets);
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*numPackets);
	// alloco il (*buffer) a dimensione massima
	(*buffer)[0]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[0],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[0];
	pData32=(uint32 *)((*buffer)[0]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	if (m_wrsame==TRUE)
		tx_mgp->op=MGP_OP_HL_WRSAME_DSP;
	else
		tx_mgp->op=MGP_OP_HL_WRSEQ_DSP;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	if (m_GenIrq)    tx_mgp->fl+=MGP_FL_HL_IRQ;
	if (m_GenRst)    tx_mgp->fl+=MGP_FL_HL_RESET;
	if (!m_PmDm)     tx_mgp->fl+=MGP_FL_HL_DMPM;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=m_StartAddress;
	if (!m_PmDm)
		pData32[0]=m_SingleValue0&0x0000FFFF;
	else
		pData32[0]=m_SingleValue0&0x00FFFFFF;
	(*bufferLen)[0]=4;             // 4 bytes
	tx_mgp->len=1;                 // 1 dword
	(*bufferLen)[0]+=MGP_HLEN;
	}

return (numPackets);
}

/* 
come inizializzare l'header:
firstDSP: crate = 0, DSP come in MMT
lastDSP: crate = 0, DSP come in MMT
comando: MGP_OP_HL_WRSAME_DSP, MGP_OP_HL_WRSEQ_DSP, MGP_OP_HL_RDSEQ_DSP
length: lunghezza del paccheto in word a 16 bit su ciascun DSP
*/

void CWriteMMTDsp_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select data file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}

void CWriteMMTDsp_View::OnRadioFile() 
{
m_Browse.EnableWindow(TRUE);
m_FileNameCtrl.EnableWindow(TRUE);
m_SingleValue0Ctrl.EnableWindow(FALSE);
}

void CWriteMMTDsp_View::OnRadioSingle() 
{
m_Browse.EnableWindow(FALSE);
m_FileNameCtrl.EnableWindow(FALSE);
m_SingleValue0Ctrl.EnableWindow(TRUE);
}

void CWriteMMTDsp_View::OnShowWindow(BOOL bShow, UINT nStatus) 
{
CFormView::OnShowWindow(bShow, nStatus);
	
if (m_wrsame==1)
	{
	if (::IsWindow(m_WriteSelection0Ctrl.m_hWnd)) m_WriteSelection0Ctrl.EnableWindow(TRUE);
	if (::IsWindow(m_WriteSelection1Ctrl.m_hWnd)) m_WriteSelection1Ctrl.EnableWindow(TRUE);
	}
else	
	{
	if (::IsWindow(m_WriteSelection0Ctrl.m_hWnd)) m_WriteSelection0Ctrl.EnableWindow(TRUE);
	if (::IsWindow(m_WriteSelection1Ctrl.m_hWnd)) m_WriteSelection1Ctrl.EnableWindow(FALSE);
	if (::IsWindow(m_SingleValue0Ctrl.m_hWnd)) m_SingleValue0Ctrl.EnableWindow(FALSE);
	}
}

void CWriteMMTDsp_View::OnPmDm() 
{
UpdateData(TRUE);

if (m_PmDm)
	m_SingleValue0Ctrl.LimitText(6);
else
	{
	if (m_SingleValue0 > 0xFFFF)
		m_SingleValue0 = 0;
	m_SingleValue0Ctrl.LimitText(4);
	}

UpdateData(FALSE);
}
