// WriteSigGenRam_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteSigGenRam_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriteSigGenRam_View

IMPLEMENT_DYNCREATE(CWriteSigGenRam_View, CFormView)

CWriteSigGenRam_View::CWriteSigGenRam_View()
	: CFormView(CWriteSigGenRam_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteSigGenRam_View)
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0;
	m_FileName = _T("SignalGenerator.dat");
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	//}}AFX_DATA_INIT
}

CWriteSigGenRam_View::~CWriteSigGenRam_View()
{
}

void CWriteSigGenRam_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteSigGenRam_View)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWriteSigGenRam_View, CFormView)
	//{{AFX_MSG_MAP(CWriteSigGenRam_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteSigGenRam_View diagnostics

#ifdef _DEBUG
void CWriteSigGenRam_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteSigGenRam_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteSigGenRam_View message handlers

BOOL CWriteSigGenRam_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteSigGenRam_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
}

DWORD CWriteSigGenRam_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets;
char   tmpbuff[100];

UpdateData(TRUE);

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;

if (m_FirstDSP!=0xFE)
	{
	AfxMessageBox("Command available on the Signal Generator board only\n");
	return (0);
	}

// determino la lunghezza del file binario
fd=fopen(m_FileName,"rt");
if (!fd)
	{
	AfxMessageBox("Input file name not valid");
	return (0);
	}

do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	tx_mgp->op=MGP_OP_WRITE_SIGGEN_RAM;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	// lettura del data file
	i=0;
	while (i<MAX_MGP_DATA_SIZE>>2 && fscanf(fd,"%s",tmpbuff)!=-1)
		{
		if (ConvertString(tmpbuff,(DWORD *)&pData[i]))
			i++;
		}
	(*bufferLen)[numPackets]=i*4;
	tx_mgp->len=i;
	start_addr+=i;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

fclose(fd);

return (numPackets);
}

void CWriteSigGenRam_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select data file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}

BOOL CWriteSigGenRam_View::ConvertString(char *buff,DWORD *val32)
{
int   i1;

strlwr(buff);
*val32=0;
if (buff[0]=='0' && buff[1]=='x')
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='a' && buff[2+i1]<='f')
			{
			*val32=*val32*16+buff[2+i1]-'a'+10;
			i1++;
			}
		else if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*16+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
else
	{
	i1=0;
	while (1)
		{
		if (buff[2+i1]>='0' && buff[2+i1]<='9')
			{
			*val32=*val32*10+buff[2+i1]-'0';
			i1++;
			}
		else if (i1!=0)
			return TRUE;
		else
			return FALSE;
		}
	}
return FALSE;
}
