// WriteSram_View.cpp : implementation file
//

#include "stdafx.h"
#include "LBT_EngPanel.h"
#include "WriteSram_View.h"
#include "mgp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWriteSram_View

IMPLEMENT_DYNCREATE(CWriteSram_View, CFormView)

CWriteSram_View::CWriteSram_View()
	: CFormView(CWriteSram_View::IDD)
{
	//{{AFX_DATA_INIT(CWriteSram_View)
	m_FileName = _T("C:\\Srv\\Progetti\\Engineering\\Lbt\\Codes\\LBT_EngPanel\\v2.00\\pippo1.dat");
	m_FirstDSP = -1;
	m_LastDSP = -1;
	m_StartAddress = 0;
	m_WantReply = TRUE;
	m_MultiplePackets = TRUE;
	//}}AFX_DATA_INIT
	m_wrsame = FALSE;
}

CWriteSram_View::~CWriteSram_View()
{
}

void CWriteSram_View::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWriteSram_View)
	DDX_Control(pDX, IDC_BROWSE, m_Browse);
	DDX_Control(pDX, IDC_FIRSTDSP, m_FirstDSPCtrl);
	DDX_Control(pDX, IDC_LASTDSP, m_LastDSPCtrl);
	DDX_Control(pDX, IDC_STARTADDRESS, m_StartAddressCtrl);
	DDX_HexText(pDX, IDC_FIRSTDSP, m_FirstDSP);
	DDX_HexText(pDX, IDC_LASTDSP, m_LastDSP);
	DDX_HexText(pDX, IDC_STARTADDRESS, m_StartAddress);
	DDX_Text(pDX, IDC_FILENAME, m_FileName);
	DDX_Check(pDX, IDC_WANTREPLY, m_WantReply);
	DDX_Check(pDX, IDC_MUTIPLEPACKETS, m_MultiplePackets);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWriteSram_View, CFormView)
	//{{AFX_MSG_MAP(CWriteSram_View)
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWriteSram_View diagnostics

#ifdef _DEBUG
void CWriteSram_View::AssertValid() const
{
	CFormView::AssertValid();
}

void CWriteSram_View::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWriteSram_View message handlers

BOOL CWriteSram_View::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{

return CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
}

void CWriteSram_View::OnInitialUpdate() 
{
CFormView::OnInitialUpdate();
	
m_FirstDSPCtrl.LimitText(2);
m_LastDSPCtrl.LimitText(2);
m_StartAddressCtrl.LimitText(8);
}

DWORD CWriteSram_View::CreateBuffer(int **bufferLen,BYTE ***buffer)
{
BYTE   numDSP;
FILE   *fd;
struct mgphdr *tx_mgp;
uint32 *pData;
BYTE   *packetID;
WORD   i;
DWORD  start_addr,numPackets,i1;
char   tmpbuff[100];

UpdateData(TRUE);

if (m_FirstDSP==0xFF || m_FirstDSP==0xFE)
	numDSP = 1;
else
	numDSP = (m_LastDSP>>1) - (m_FirstDSP>>1) + 1;

packetID=(BYTE *)(*bufferLen);
(*buffer)=NULL;
(*bufferLen)=NULL;
numPackets=0;
start_addr=m_StartAddress;

// determino la lunghezza del file binario
fd=fopen(m_FileName,"rb");
if (!fd)
	{
	AfxMessageBox("Input file name not valid");
	return (0);
	}

do
	{
	(*buffer)=(BYTE **)realloc((*buffer),sizeof(BYTE *)*(numPackets+1));
	(*bufferLen)=(int *)realloc((*bufferLen),sizeof(int)*(numPackets+1));
	// alloco il (*buffer) a dimensione massima
	(*buffer)[numPackets]=(BYTE *)malloc(MAX_MGP_DATA_SIZE+MGP_HLEN);
	memset((*buffer)[numPackets],0,MAX_MGP_DATA_SIZE+MGP_HLEN);
	tx_mgp=(struct mgphdr *)(*buffer)[numPackets];
	pData=(uint32 *)((*buffer)[numPackets]+MGP_HLEN);
	tx_mgp->DSPs[0]=m_FirstDSP<<4;
	tx_mgp->DSPs[1]=m_FirstDSP>>4;
	tx_mgp->DSPs[2]=m_LastDSP;
	if (m_wrsame==TRUE)
		tx_mgp->op=MGP_OP_WRSAME_SRAM;
	else
		tx_mgp->op=MGP_OP_WRSEQ_SRAM;
	tx_mgp->fl=0;
	if (m_WantReply) tx_mgp->fl+=MGP_FL_WANTREPLY;
	tx_mgp->id=(*packetID)++;
	tx_mgp->saddr=start_addr;
	i=0;
	while (i<MAX_MGP_DATA_SIZE>>2 && fscanf(fd,"%s",tmpbuff)!=-1)
		{
		pData[i]=0;
		strlwr(tmpbuff);
		if (tmpbuff[0]=='#')
			{
			}
		else if (tmpbuff[0]=='0' && tmpbuff[1]=='x')
			{
			i1=0;
			while (1)
				{
				if (tmpbuff[2+i1]>='a' && tmpbuff[2+i1]<='f')
					{
					pData[i]=pData[i]*16+tmpbuff[2+i1]-'a'+10;
					i1++;
					}
				else if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
					{
					pData[i]=pData[i]*16+tmpbuff[2+i1]-'0';
					i1++;
					}
				else if (i1!=0)
					{
					i++;
					break;
					}
				else
					break;
				}
			}
		else
			{
			i1=0;
			while (1)
				{
				if (tmpbuff[2+i1]>='0' && tmpbuff[2+i1]<='9')
					{
					pData[i]=pData[i]*10+tmpbuff[2+i1]-'0';
					i1++;
					}
				else if (i1!=0)
					{
					i++;
					break;
					}
				else
					break;
				}
			}
		}
	if (m_wrsame==FALSE)	i/=numDSP;
	(*bufferLen)[numPackets]=i*4*numDSP;
	tx_mgp->len=i;
	start_addr+=i;
	(*bufferLen)[numPackets]+=MGP_HLEN;
	}
while ((*bufferLen)[numPackets++]==MAX_MGP_DATA_SIZE+MGP_HLEN);

fclose(fd);

return (numPackets);
}

void CWriteSram_View::OnBrowse() 
{
CFileDialog dlg(TRUE,NULL,NULL,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"Data files (*.dat)|*.dat|All files (*.*)|*.*||",NULL);

dlg.m_ofn.lpstrTitle="Select binary file";

if (dlg.DoModal()!=IDOK)
	return;

UpdateData(TRUE);
m_FileName=dlg.GetPathName();
UpdateData(FALSE);
}
